
/*  A Bison parser, made from Gmsh.y
    by GNU Bison version 1.28  */

#define YYBISON 1  /* Identify Bison output.  */

#define	tDOUBLE	257
#define	tSTRING	258
#define	tBIGSTR	259
#define	tEND	260
#define	tAFFECT	261
#define	tDOTS	262
#define	tPi	263
#define	tMPI_Rank	264
#define	tMPI_Size	265
#define	tEuclidian	266
#define	tCoordinates	267
#define	tExp	268
#define	tLog	269
#define	tLog10	270
#define	tSqrt	271
#define	tSin	272
#define	tAsin	273
#define	tCos	274
#define	tAcos	275
#define	tTan	276
#define	tRand	277
#define	tAtan	278
#define	tAtan2	279
#define	tSinh	280
#define	tCosh	281
#define	tTanh	282
#define	tFabs	283
#define	tFloor	284
#define	tCeil	285
#define	tFmod	286
#define	tModulo	287
#define	tHypot	288
#define	tPrintf	289
#define	tSprintf	290
#define	tStrCat	291
#define	tStrPrefix	292
#define	tStrRelative	293
#define	tBoundingBox	294
#define	tDraw	295
#define	tToday	296
#define	tPoint	297
#define	tCircle	298
#define	tEllipse	299
#define	tLine	300
#define	tSphere	301
#define	tPolarSphere	302
#define	tSurface	303
#define	tSpline	304
#define	tVolume	305
#define	tCharacteristic	306
#define	tLength	307
#define	tParametric	308
#define	tElliptic	309
#define	tPlane	310
#define	tRuled	311
#define	tTransfinite	312
#define	tComplex	313
#define	tPhysical	314
#define	tUsing	315
#define	tBump	316
#define	tProgression	317
#define	tPlugin	318
#define	tRotate	319
#define	tTranslate	320
#define	tSymmetry	321
#define	tDilate	322
#define	tExtrude	323
#define	tDuplicata	324
#define	tLoop	325
#define	tRecombine	326
#define	tDelete	327
#define	tCoherence	328
#define	tAttractor	329
#define	tLayers	330
#define	tHole	331
#define	tAlias	332
#define	tAliasWithOptions	333
#define	tText2D	334
#define	tText3D	335
#define	tInterpolationScheme	336
#define	tTime	337
#define	tGrain	338
#define	tCombine	339
#define	tBSpline	340
#define	tBezier	341
#define	tNurbs	342
#define	tOrder	343
#define	tKnots	344
#define	tColor	345
#define	tColorTable	346
#define	tFor	347
#define	tIn	348
#define	tEndFor	349
#define	tIf	350
#define	tEndIf	351
#define	tExit	352
#define	tReturn	353
#define	tCall	354
#define	tFunction	355
#define	tShow	356
#define	tHide	357
#define	tGetValue	358
#define	tGMSH_MAJOR_VERSION	359
#define	tGMSH_MINOR_VERSION	360
#define	tGMSH_PATCH_VERSION	361
#define	tAFFECTPLUS	362
#define	tAFFECTMINUS	363
#define	tAFFECTTIMES	364
#define	tAFFECTDIVIDE	365
#define	tOR	366
#define	tAND	367
#define	tEQUAL	368
#define	tNOTEQUAL	369
#define	tLESSOREQUAL	370
#define	tGREATEROREQUAL	371
#define	tPLUSPLUS	372
#define	tMINUSMINUS	373
#define	UNARYPREC	374

#line 1 "Gmsh.y"

// $Id: Gmsh.tab.cpp,v 1.313 2007-03-11 20:18:58 geuzaine Exp $
//
// Copyright (C) 1997-2007 C. Geuzaine, J.-F. Remacle
//
// This program is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2 of the License, or
// (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307
// USA.
// 
// Please report all bugs and problems to <gmsh@geuz.org>.

#include <stdarg.h>
#include <time.h>
#include "PluginManager.h"
#include "ParUtil.h"
#include "Gmsh.h"
#include "Numeric.h"
#include "Context.h"
#include "GModel.h"
#include "Geo.h"
#include "GeoInterpolation.h"
#include "Generator.h"
#include "Draw.h"
#include "Views.h"
#include "Options.h"
#include "Colors.h"
#include "Parser.h"
#include "OpenFile.h"
#include "CommandLine.h"
#include "FunctionManager.h"
#include "ColorTable.h"
#include "OS.h"
#include "CreateFile.h"
#include "gmshSurface.h"
#include "Attractors.h"

Tree_T *Symbol_T = NULL;

extern Context_T CTX;
extern Mesh *THEM;
extern GModel *GMODEL;

static ExtrudeParams extr;

static Post_View *View;
static List_T *ViewValueList;
static double ViewCoord[100];
static int *ViewNumList, ViewNumNodes, ViewNumComp, ViewNumListTmp;
static int ViewCoordIdx, ViewElementIdx;
static int ViewErrorFlags[VIEW_NB_ELEMENT_TYPES];

#define MAX_RECUR_LOOPS 100
static int ImbricatedLoop = 0;
static gmshSurface *myGmshSurface = 0;
static fpos_t yyposImbricatedLoopsTab[MAX_RECUR_LOOPS];
static int yylinenoImbricatedLoopsTab[MAX_RECUR_LOOPS];
static double LoopControlVariablesTab[MAX_RECUR_LOOPS][3];
static char *LoopControlVariablesNameTab[MAX_RECUR_LOOPS];

void yyerror(char *s);
void yymsg(int type, char *fmt, ...);
void skip_until(char *skip, char *until);
int PrintListOfDouble(char *format, List_T *list, char *buffer);
int CheckViewErrorFlags(Post_View *v);

#line 78 "Gmsh.y"
typedef union {
  char *c;
  int i;
  unsigned int u;
  double d;
  double v[5];
  Shape s;
  List_T *l;
} YYSTYPE;
#include <stdio.h>

#ifndef __cplusplus
#ifndef __STDC__
#define const
#endif
#endif



#define	YYFINAL		1218
#define	YYFLAG		-32768
#define	YYNTBASE	141

#define YYTRANSLATE(x) ((unsigned)(x) <= 374 ? yytranslate[x] : 209)

static const short yytranslate[] = {     0,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,   126,     2,   136,     2,   125,     2,     2,   131,
   132,   123,   121,   137,   122,   135,   124,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,   117,
     2,   119,   112,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
   133,     2,   134,   130,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,   138,     2,   139,   140,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     1,     3,     4,     5,     6,
     7,     8,     9,    10,    11,    12,    13,    14,    15,    16,
    17,    18,    19,    20,    21,    22,    23,    24,    25,    26,
    27,    28,    29,    30,    31,    32,    33,    34,    35,    36,
    37,    38,    39,    40,    41,    42,    43,    44,    45,    46,
    47,    48,    49,    50,    51,    52,    53,    54,    55,    56,
    57,    58,    59,    60,    61,    62,    63,    64,    65,    66,
    67,    68,    69,    70,    71,    72,    73,    74,    75,    76,
    77,    78,    79,    80,    81,    82,    83,    84,    85,    86,
    87,    88,    89,    90,    91,    92,    93,    94,    95,    96,
    97,    98,    99,   100,   101,   102,   103,   104,   105,   106,
   107,   108,   109,   110,   111,   113,   114,   115,   116,   118,
   120,   127,   128,   129
};

#if YYDEBUG != 0
static const short yyprhs[] = {     0,
     0,     2,     5,     6,     9,    11,    13,    15,    17,    19,
    21,    23,    25,    27,    29,    31,    33,    35,    37,    39,
    41,    44,    50,    58,    66,    76,    83,    92,    93,    96,
    99,   102,   105,   108,   111,   113,   117,   119,   123,   124,
   125,   136,   138,   142,   143,   157,   159,   163,   164,   180,
   189,   190,   197,   204,   206,   208,   210,   212,   214,   216,
   218,   223,   231,   241,   248,   255,   259,   266,   273,   283,
   290,   300,   306,   315,   324,   336,   343,   353,   363,   373,
   375,   377,   385,   394,   401,   408,   415,   423,   431,   439,
   449,   457,   467,   485,   493,   501,   513,   522,   531,   540,
   549,   553,   558,   569,   577,   585,   594,   603,   612,   620,
   629,   635,   647,   653,   663,   665,   667,   669,   670,   673,
   680,   687,   694,   701,   706,   713,   720,   727,   732,   739,
   743,   748,   754,   758,   762,   767,   772,   776,   784,   792,
   796,   804,   808,   811,   814,   830,   833,   840,   849,   858,
   869,   871,   874,   876,   880,   885,   887,   893,   905,   919,
   920,   928,   929,   943,   944,   960,   961,   968,   969,   980,
   989,   998,  1007,  1020,  1033,  1046,  1061,  1076,  1091,  1092,
  1105,  1106,  1119,  1120,  1133,  1134,  1151,  1152,  1169,  1170,
  1187,  1188,  1207,  1208,  1227,  1228,  1247,  1249,  1252,  1258,
  1266,  1276,  1279,  1289,  1296,  1306,  1316,  1325,  1335,  1344,
  1353,  1360,  1365,  1376,  1387,  1398,  1409,  1412,  1414,  1418,
  1421,  1424,  1427,  1431,  1435,  1439,  1443,  1447,  1451,  1455,
  1459,  1463,  1467,  1471,  1475,  1479,  1483,  1489,  1494,  1499,
  1504,  1509,  1514,  1519,  1524,  1529,  1534,  1539,  1546,  1551,
  1556,  1561,  1566,  1571,  1576,  1583,  1590,  1597,  1602,  1607,
  1612,  1617,  1622,  1627,  1632,  1637,  1642,  1647,  1652,  1659,
  1664,  1669,  1674,  1679,  1684,  1689,  1696,  1703,  1710,  1715,
  1717,  1719,  1721,  1723,  1725,  1727,  1729,  1731,  1737,  1742,
  1747,  1750,  1756,  1760,  1767,  1772,  1780,  1787,  1789,  1792,
  1795,  1799,  1803,  1815,  1825,  1833,  1841,  1843,  1847,  1849,
  1851,  1854,  1858,  1863,  1869,  1872,  1876,  1880,  1886,  1891,
  1893,  1895,  1897,  1901,  1908,  1910,  1912,  1916,  1920,  1930,
  1938,  1940,  1946,  1950,  1957,  1959,  1963,  1965,  1967,  1974,
  1979,  1984,  1989,  1996,  2003
};

static const short yyrhs[] = {   142,
     0,     1,     6,     0,     0,   142,   143,     0,   146,     0,
   145,     0,   165,     0,   167,     0,   168,     0,   171,     0,
   172,     0,   173,     0,   174,     0,   177,     0,   194,     0,
   195,     0,   196,     0,   176,     0,   175,     0,   119,     0,
   119,   119,     0,    35,   131,     5,   132,     6,     0,    35,
   131,     5,   132,   144,   208,     6,     0,    35,   131,     5,
   137,   204,   132,     6,     0,    35,   131,     5,   137,   204,
   132,   144,   208,     6,     0,     4,     5,   138,   147,   139,
     6,     0,     4,     5,     4,   199,   138,   147,   139,     6,
     0,     0,   147,   150,     0,   147,   154,     0,   147,   157,
     0,   147,   159,     0,   147,   160,     0,   147,   162,     0,
   197,     0,   148,   137,   197,     0,   197,     0,   149,   137,
   197,     0,     0,     0,     4,   151,   131,   148,   132,   152,
   138,   149,   139,     6,     0,   208,     0,   153,   137,   208,
     0,     0,    80,   131,   197,   137,   197,   137,   197,   132,
   155,   138,   153,   139,     6,     0,   208,     0,   156,   137,
   208,     0,     0,    81,   131,   197,   137,   197,   137,   197,
   137,   197,   132,   158,   138,   156,   139,     6,     0,    82,
   138,   201,   139,   138,   201,   139,     6,     0,     0,    83,
   161,   138,   149,   139,     6,     0,    84,   131,   197,   132,
   202,     6,     0,     7,     0,   108,     0,   109,     0,   110,
     0,   111,     0,   127,     0,   128,     0,     4,   163,   197,
     6,     0,     4,   133,   197,   134,   163,   197,     6,     0,
     4,   133,   138,   204,   139,   134,   163,   202,     6,     0,
     4,   133,   134,     7,   202,     6,     0,     4,   133,   134,
   108,   202,     6,     0,     4,   164,     6,     0,     4,   133,
   197,   134,   164,     6,     0,     4,   135,     4,     7,   208,
     6,     0,     4,   133,   197,   134,   135,     4,     7,   208,
     6,     0,     4,   135,     4,   163,   197,     6,     0,     4,
   133,   197,   134,   135,     4,   163,   197,     6,     0,     4,
   135,     4,   164,     6,     0,     4,   133,   197,   134,   135,
     4,   164,     6,     0,     4,   135,    91,   135,     4,     7,
   205,     6,     0,     4,   133,   197,   134,   135,    91,   135,
     4,     7,   205,     6,     0,     4,   135,    92,     7,   206,
     6,     0,     4,   133,   197,   134,   135,    92,     7,   206,
     6,     0,    64,   131,     4,   132,   135,     4,     7,   197,
     6,     0,    64,   131,     4,   132,   135,     4,     7,   208,
     6,     0,   197,     0,   208,     0,    43,   131,   197,   132,
     7,   199,     6,     0,    60,    43,   131,   166,   132,     7,
   202,     6,     0,    75,    43,   202,     7,   202,     6,     0,
    75,    46,   202,     7,   202,     6,     0,    52,    53,   202,
     7,   197,     6,     0,    46,   131,   197,   132,     7,   202,
     6,     0,    50,   131,   197,   132,     7,   202,     6,     0,
    44,   131,   197,   132,     7,   202,     6,     0,    44,   131,
   197,   132,     7,   202,    56,   199,     6,     0,    45,   131,
   197,   132,     7,   202,     6,     0,    45,   131,   197,   132,
     7,   202,    56,   199,     6,     0,    54,   131,   197,   132,
     7,   138,   197,   137,   197,   137,     5,   137,     5,   137,
     5,   139,     6,     0,    86,   131,   197,   132,     7,   202,
     6,     0,    87,   131,   197,   132,     7,   202,     6,     0,
    88,   131,   197,   132,     7,   202,    90,   202,    89,   197,
     6,     0,    46,    71,   131,   197,   132,     7,   202,     6,
     0,    60,    46,   131,   166,   132,     7,   202,     6,     0,
    56,    49,   131,   197,   132,     7,   202,     6,     0,    57,
    49,   131,   197,   132,     7,   202,     6,     0,    12,    13,
     6,     0,    13,    49,   197,     6,     0,    54,    49,   131,
   197,   132,     7,     5,     5,     5,     6,     0,    47,   131,
   197,   132,     7,   202,     6,     0,    48,   131,   197,   132,
     7,   202,     6,     0,    49,    71,   131,   197,   132,     7,
   202,     6,     0,    60,    49,   131,   166,   132,     7,   202,
     6,     0,    59,    51,   131,   197,   132,     7,   202,     6,
     0,    51,   131,   197,   132,     7,   202,     6,     0,    60,
    51,   131,   166,   132,     7,   202,     6,     0,    66,   199,
   138,   169,   139,     0,    65,   138,   199,   137,   199,   137,
   197,   139,   138,   169,   139,     0,    67,   199,   138,   169,
   139,     0,    68,   138,   199,   137,   197,   139,   138,   169,
   139,     0,   171,     0,   170,     0,   168,     0,     0,   170,
   167,     0,   170,    43,   138,   204,   139,     6,     0,   170,
    46,   138,   204,   139,     6,     0,   170,    49,   138,   204,
   139,     6,     0,   170,    51,   138,   204,   139,     6,     0,
    70,   138,   170,   139,     0,    70,     4,   133,   197,   134,
     6,     0,    78,     4,   133,   197,   134,     6,     0,    79,
     4,   133,   197,   134,     6,     0,    73,   138,   170,   139,
     0,    73,     4,   133,   197,   134,     6,     0,    73,     4,
     6,     0,    73,     4,     4,     6,     0,    91,   205,   138,
   170,   139,     0,   102,   208,     6,     0,   103,   208,     6,
     0,   102,   138,   170,   139,     0,   103,   138,   170,   139,
     0,     4,   208,     6,     0,     4,     4,   133,   197,   134,
   208,     6,     0,     4,     4,     4,   133,   197,   134,     6,
     0,     4,   197,     6,     0,    64,   131,     4,   132,   135,
     4,     6,     0,    85,     4,     6,     0,    98,     6,     0,
    40,     6,     0,    40,   138,   197,   137,   197,   137,   197,
   137,   197,   137,   197,   137,   197,   139,     6,     0,    41,
     6,     0,    93,   131,   197,     8,   197,   132,     0,    93,
   131,   197,     8,   197,     8,   197,   132,     0,    93,     4,
    94,   138,   197,     8,   197,   139,     0,    93,     4,    94,
   138,   197,     8,   197,     8,   197,   139,     0,    95,     0,
   101,     4,     0,    99,     0,   100,     4,     6,     0,    96,
   131,   197,   132,     0,    97,     0,    69,   199,   138,   170,
   139,     0,    69,   138,   199,   137,   199,   137,   197,   139,
   138,   170,   139,     0,    69,   138,   199,   137,   199,   137,
   199,   137,   197,   139,   138,   170,   139,     0,     0,    69,
   199,   138,   170,   178,   192,   139,     0,     0,    69,   138,
   199,   137,   199,   137,   197,   139,   138,   170,   179,   192,
   139,     0,     0,    69,   138,   199,   137,   199,   137,   199,
   137,   197,   139,   138,   170,   180,   192,   139,     0,     0,
    69,   138,   170,   181,   192,   139,     0,     0,    69,     4,
   133,   197,   134,   138,   170,   182,   192,   139,     0,    69,
    43,   138,   197,   137,   199,   139,     6,     0,    69,    46,
   138,   197,   137,   199,   139,     6,     0,    69,    49,   138,
   197,   137,   199,   139,     6,     0,    69,    43,   138,   197,
   137,   199,   137,   199,   137,   197,   139,     6,     0,    69,
    46,   138,   197,   137,   199,   137,   199,   137,   197,   139,
     6,     0,    69,    49,   138,   197,   137,   199,   137,   199,
   137,   197,   139,     6,     0,    69,    43,   138,   197,   137,
   199,   137,   199,   137,   199,   137,   197,   139,     6,     0,
    69,    46,   138,   197,   137,   199,   137,   199,   137,   199,
   137,   197,   139,     6,     0,    69,    49,   138,   197,   137,
   199,   137,   199,   137,   199,   137,   197,   139,     6,     0,
     0,    69,    43,   138,   197,   137,   199,   139,   183,   138,
   192,   139,     6,     0,     0,    69,    46,   138,   197,   137,
   199,   139,   184,   138,   192,   139,     6,     0,     0,    69,
    49,   138,   197,   137,   199,   139,   185,   138,   192,   139,
     6,     0,     0,    69,    43,   138,   197,   137,   199,   137,
   199,   137,   197,   139,   186,   138,   192,   139,     6,     0,
     0,    69,    46,   138,   197,   137,   199,   137,   199,   137,
   197,   139,   187,   138,   192,   139,     6,     0,     0,    69,
    49,   138,   197,   137,   199,   137,   199,   137,   197,   139,
   188,   138,   192,   139,     6,     0,     0,    69,    43,   138,
   197,   137,   199,   137,   199,   137,   199,   137,   197,   139,
   189,   138,   192,   139,     6,     0,     0,    69,    46,   138,
   197,   137,   199,   137,   199,   137,   199,   137,   197,   139,
   190,   138,   192,   139,     6,     0,     0,    69,    49,   138,
   197,   137,   199,   137,   199,   137,   199,   137,   197,   139,
   191,   138,   192,   139,     6,     0,   193,     0,   192,   193,
     0,    76,   138,   197,   139,     6,     0,    76,   138,   202,
   137,   202,   139,     6,     0,    76,   138,   202,   137,   202,
   137,   202,   139,     6,     0,    72,     6,     0,    77,   131,
   197,   132,     7,   202,    61,   197,     6,     0,    58,    46,
   202,     7,   197,     6,     0,    58,    46,   202,     7,   197,
    61,    63,   197,     6,     0,    58,    46,   202,     7,   197,
    61,    62,   197,     6,     0,    58,    49,   138,   197,   139,
     7,   202,     6,     0,    58,    49,   138,   197,   139,     7,
   202,     4,     6,     0,    55,    49,   138,   197,   139,     7,
   202,     6,     0,    58,    51,   138,   197,   139,     7,   202,
     6,     0,    72,    49,   202,     7,   197,     6,     0,    72,
    49,   202,     6,     0,    43,   138,   204,   139,    94,    49,
   138,   197,   139,     6,     0,    46,   138,   204,   139,    94,
    49,   138,   197,   139,     6,     0,    46,   138,   204,   139,
    94,    51,   138,   197,   139,     6,     0,    49,   138,   204,
   139,    94,    51,   138,   197,   139,     6,     0,    74,     6,
     0,   198,     0,   131,   197,   132,     0,   122,   197,     0,
   121,   197,     0,   126,   197,     0,   197,   122,   197,     0,
   197,   121,   197,     0,   197,   123,   197,     0,   197,   124,
   197,     0,   197,   125,   197,     0,   197,   130,   197,     0,
   197,   117,   197,     0,   197,   119,   197,     0,   197,   118,
   197,     0,   197,   120,   197,     0,   197,   115,   197,     0,
   197,   116,   197,     0,   197,   114,   197,     0,   197,   113,
   197,     0,   197,   112,   197,     8,   197,     0,    14,   131,
   197,   132,     0,    15,   131,   197,   132,     0,    16,   131,
   197,   132,     0,    17,   131,   197,   132,     0,    18,   131,
   197,   132,     0,    19,   131,   197,   132,     0,    20,   131,
   197,   132,     0,    21,   131,   197,   132,     0,    22,   131,
   197,   132,     0,    24,   131,   197,   132,     0,    25,   131,
   197,   137,   197,   132,     0,    26,   131,   197,   132,     0,
    27,   131,   197,   132,     0,    28,   131,   197,   132,     0,
    29,   131,   197,   132,     0,    30,   131,   197,   132,     0,
    31,   131,   197,   132,     0,    32,   131,   197,   137,   197,
   132,     0,    33,   131,   197,   137,   197,   132,     0,    34,
   131,   197,   137,   197,   132,     0,    23,   131,   197,   132,
     0,    14,   133,   197,   134,     0,    15,   133,   197,   134,
     0,    16,   133,   197,   134,     0,    17,   133,   197,   134,
     0,    18,   133,   197,   134,     0,    19,   133,   197,   134,
     0,    20,   133,   197,   134,     0,    21,   133,   197,   134,
     0,    22,   133,   197,   134,     0,    24,   133,   197,   134,
     0,    25,   133,   197,   137,   197,   134,     0,    26,   133,
   197,   134,     0,    27,   133,   197,   134,     0,    28,   133,
   197,   134,     0,    29,   133,   197,   134,     0,    30,   133,
   197,   134,     0,    31,   133,   197,   134,     0,    32,   133,
   197,   137,   197,   134,     0,    33,   133,   197,   137,   197,
   134,     0,    34,   133,   197,   137,   197,   134,     0,    23,
   133,   197,   134,     0,     3,     0,     9,     0,    10,     0,
    11,     0,   105,     0,   106,     0,   107,     0,     4,     0,
     4,   140,   138,   197,   139,     0,     4,   133,   197,   134,
     0,   136,     4,   133,   134,     0,     4,   164,     0,     4,
   133,   197,   134,   164,     0,     4,   135,     4,     0,     4,
   133,   197,   134,   135,     4,     0,     4,   135,     4,   164,
     0,     4,   133,   197,   134,   135,     4,   164,     0,   104,
   131,     5,   137,   197,   132,     0,   200,     0,   122,   199,
     0,   121,   199,     0,   199,   122,   199,     0,   199,   121,
   199,     0,   138,   197,   137,   197,   137,   197,   137,   197,
   137,   197,   139,     0,   138,   197,   137,   197,   137,   197,
   137,   197,   139,     0,   138,   197,   137,   197,   137,   197,
   139,     0,   131,   197,   137,   197,   137,   197,   132,     0,
   202,     0,   201,   137,   202,     0,   197,     0,   203,     0,
   138,   139,     0,   138,   204,   139,     0,   122,   138,   204,
   139,     0,   197,   123,   138,   204,   139,     0,   122,   203,
     0,   197,   123,   203,     0,   197,     8,   197,     0,   197,
     8,   197,     8,   197,     0,    43,   138,   197,   139,     0,
   168,     0,   171,     0,   177,     0,     4,   133,   134,     0,
     4,   133,   138,   204,   139,   134,     0,   197,     0,   203,
     0,   204,   137,   197,     0,   204,   137,   203,     0,   138,
   197,   137,   197,   137,   197,   137,   197,   139,     0,   138,
   197,   137,   197,   137,   197,   139,     0,     4,     0,     4,
   135,    91,   135,     4,     0,   138,   207,   139,     0,     4,
   133,   197,   134,   135,    92,     0,   205,     0,   207,   137,
   205,     0,     5,     0,    42,     0,    37,   131,   208,   137,
   208,   132,     0,    38,   131,   208,   132,     0,    39,   131,
   208,   132,     0,    36,   131,   208,   132,     0,    36,   131,
   208,   137,   204,   132,     0,    36,   131,     4,   135,     4,
   132,     0,    36,   131,     4,   133,   197,   134,   135,     4,
   132,     0
};

#endif

#if YYDEBUG != 0
static const short yyrline[] = { 0,
   143,   145,   150,   152,   155,   157,   158,   159,   160,   161,
   162,   163,   164,   165,   166,   167,   168,   169,   170,   173,
   178,   184,   190,   205,   218,   246,   254,   263,   271,   272,
   273,   274,   275,   276,   279,   282,   286,   289,   293,   484,
   502,   512,   518,   525,   533,   539,   545,   552,   560,   566,
   574,   579,   583,   592,   594,   595,   596,   597,   600,   602,
   605,   640,   679,   733,   750,   768,   779,   798,   812,   829,
   855,   882,   896,   913,   927,   944,   964,   987,   997,  1011,
  1016,  1024,  1050,  1066,  1095,  1126,  1148,  1166,  1184,  1202,
  1228,  1246,  1272,  1292,  1316,  1340,  1366,  1383,  1402,  1420,
  1459,  1464,  1469,  1475,  1497,  1519,  1535,  1555,  1572,  1589,
  1609,  1615,  1620,  1625,  1632,  1634,  1635,  1638,  1643,  1647,
  1670,  1693,  1716,  1743,  1756,  1762,  1768,  1779,  1789,  1799,
  1815,  1833,  1847,  1854,  1860,  1869,  1882,  1933,  1948,  1959,
  1979,  1989,  2011,  2015,  2020,  2025,  2035,  2052,  2068,  2094,
  2121,  2153,  2160,  2165,  2171,  2175,  2183,  2192,  2200,  2208,
  2212,  2220,  2224,  2232,  2236,  2244,  2248,  2255,  2259,  2271,
  2278,  2285,  2292,  2299,  2306,  2313,  2320,  2327,  2334,  2338,
  2345,  2349,  2356,  2360,  2367,  2371,  2378,  2382,  2389,  2393,
  2400,  2404,  2411,  2415,  2422,  2426,  2436,  2440,  2445,  2455,
  2477,  2501,  2505,  2528,  2547,  2565,  2583,  2612,  2647,  2652,
  2679,  2693,  2711,  2718,  2724,  2727,  2735,  2745,  2747,  2748,
  2749,  2750,  2751,  2752,  2753,  2754,  2761,  2762,  2763,  2764,
  2765,  2766,  2767,  2768,  2769,  2770,  2771,  2772,  2773,  2774,
  2775,  2776,  2777,  2778,  2779,  2780,  2781,  2782,  2783,  2784,
  2785,  2786,  2787,  2788,  2789,  2790,  2791,  2792,  2794,  2795,
  2796,  2797,  2798,  2799,  2800,  2801,  2802,  2803,  2804,  2805,
  2806,  2807,  2808,  2809,  2810,  2811,  2812,  2813,  2814,  2819,
  2824,  2825,  2826,  2827,  2828,  2829,  2833,  2849,  2864,  2884,
  2898,  2911,  2934,  2952,  2970,  2988,  3006,  3013,  3018,  3022,
  3026,  3030,  3036,  3041,  3045,  3049,  3055,  3061,  3068,  3074,
  3078,  3083,  3087,  3095,  3105,  3114,  3122,  3128,  3139,  3159,
  3169,  3179,  3189,  3206,  3232,  3238,  3242,  3246,  3258,  3263,
  3275,  3282,  3303,  3308,  3322,  3328,  3334,  3339,  3347,  3355,
  3369,  3383,  3387,  3406,  3428
};
#endif


#if YYDEBUG != 0 || defined (YYERROR_VERBOSE)

static const char * const yytname[] = {   "$","error","$undefined.","tDOUBLE",
"tSTRING","tBIGSTR","tEND","tAFFECT","tDOTS","tPi","tMPI_Rank","tMPI_Size","tEuclidian",
"tCoordinates","tExp","tLog","tLog10","tSqrt","tSin","tAsin","tCos","tAcos",
"tTan","tRand","tAtan","tAtan2","tSinh","tCosh","tTanh","tFabs","tFloor","tCeil",
"tFmod","tModulo","tHypot","tPrintf","tSprintf","tStrCat","tStrPrefix","tStrRelative",
"tBoundingBox","tDraw","tToday","tPoint","tCircle","tEllipse","tLine","tSphere",
"tPolarSphere","tSurface","tSpline","tVolume","tCharacteristic","tLength","tParametric",
"tElliptic","tPlane","tRuled","tTransfinite","tComplex","tPhysical","tUsing",
"tBump","tProgression","tPlugin","tRotate","tTranslate","tSymmetry","tDilate",
"tExtrude","tDuplicata","tLoop","tRecombine","tDelete","tCoherence","tAttractor",
"tLayers","tHole","tAlias","tAliasWithOptions","tText2D","tText3D","tInterpolationScheme",
"tTime","tGrain","tCombine","tBSpline","tBezier","tNurbs","tOrder","tKnots",
"tColor","tColorTable","tFor","tIn","tEndFor","tIf","tEndIf","tExit","tReturn",
"tCall","tFunction","tShow","tHide","tGetValue","tGMSH_MAJOR_VERSION","tGMSH_MINOR_VERSION",
"tGMSH_PATCH_VERSION","tAFFECTPLUS","tAFFECTMINUS","tAFFECTTIMES","tAFFECTDIVIDE",
"'?'","tOR","tAND","tEQUAL","tNOTEQUAL","'<'","tLESSOREQUAL","'>'","tGREATEROREQUAL",
"'+'","'-'","'*'","'/'","'%'","'!'","tPLUSPLUS","tMINUSMINUS","UNARYPREC","'^'",
"'('","')'","'['","']'","'.'","'#'","','","'{'","'}'","'~'","All","GeoFormatItems",
"GeoFormatItem","SendToFile","Printf","View","Views","ElementCoords","ElementValues",
"Element","@1","@2","Text2DValues","Text2D","@3","Text3DValues","Text3D","@4",
"InterpolationMatrix","Time","@5","Grain","NumericAffectation","NumericIncrement",
"Affectation","PhysicalId","Shape","Transform","MultipleShape","ListOfShapes",
"Duplicata","Delete","Colorify","Visibility","Command","Loop","Extrude","@6",
"@7","@8","@9","@10","@11","@12","@13","@14","@15","@16","@17","@18","@19","ExtrudeParameters",
"ExtrudeParameter","Transfinite","Embedding","Coherence","FExpr","FExpr_Single",
"VExpr","VExpr_Single","RecursiveListOfListOfDouble","ListOfDouble","FExpr_Multi",
"RecursiveListOfDouble","ColorExpr","ListOfColor","RecursiveListOfColor","StringExpr", NULL
};
#endif

static const short yyr1[] = {     0,
   141,   141,   142,   142,   143,   143,   143,   143,   143,   143,
   143,   143,   143,   143,   143,   143,   143,   143,   143,   144,
   144,   145,   145,   145,   145,   146,   146,   147,   147,   147,
   147,   147,   147,   147,   148,   148,   149,   149,   151,   152,
   150,   153,   153,   155,   154,   156,   156,   158,   157,   159,
   161,   160,   162,   163,   163,   163,   163,   163,   164,   164,
   165,   165,   165,   165,   165,   165,   165,   165,   165,   165,
   165,   165,   165,   165,   165,   165,   165,   165,   165,   166,
   166,   167,   167,   167,   167,   167,   167,   167,   167,   167,
   167,   167,   167,   167,   167,   167,   167,   167,   167,   167,
   167,   167,   167,   167,   167,   167,   167,   167,   167,   167,
   168,   168,   168,   168,   169,   169,   169,   170,   170,   170,
   170,   170,   170,   171,   171,   171,   171,   172,   172,   172,
   172,   173,   174,   174,   174,   174,   175,   175,   175,   175,
   175,   175,   175,   175,   175,   175,   176,   176,   176,   176,
   176,   176,   176,   176,   176,   176,   177,   177,   177,   178,
   177,   179,   177,   180,   177,   181,   177,   182,   177,   177,
   177,   177,   177,   177,   177,   177,   177,   177,   183,   177,
   184,   177,   185,   177,   186,   177,   187,   177,   188,   177,
   189,   177,   190,   177,   191,   177,   192,   192,   193,   193,
   193,   193,   193,   194,   194,   194,   194,   194,   194,   194,
   194,   194,   195,   195,   195,   195,   196,   197,   197,   197,
   197,   197,   197,   197,   197,   197,   197,   197,   197,   197,
   197,   197,   197,   197,   197,   197,   197,   197,   197,   197,
   197,   197,   197,   197,   197,   197,   197,   197,   197,   197,
   197,   197,   197,   197,   197,   197,   197,   197,   197,   197,
   197,   197,   197,   197,   197,   197,   197,   197,   197,   197,
   197,   197,   197,   197,   197,   197,   197,   197,   197,   198,
   198,   198,   198,   198,   198,   198,   198,   198,   198,   198,
   198,   198,   198,   198,   198,   198,   198,   199,   199,   199,
   199,   199,   200,   200,   200,   200,   201,   201,   202,   202,
   202,   202,   202,   202,   203,   203,   203,   203,   203,   203,
   203,   203,   203,   203,   204,   204,   204,   204,   205,   205,
   205,   205,   206,   206,   207,   207,   208,   208,   208,   208,
   208,   208,   208,   208,   208
};

static const short yyr2[] = {     0,
     1,     2,     0,     2,     1,     1,     1,     1,     1,     1,
     1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
     2,     5,     7,     7,     9,     6,     8,     0,     2,     2,
     2,     2,     2,     2,     1,     3,     1,     3,     0,     0,
    10,     1,     3,     0,    13,     1,     3,     0,    15,     8,
     0,     6,     6,     1,     1,     1,     1,     1,     1,     1,
     4,     7,     9,     6,     6,     3,     6,     6,     9,     6,
     9,     5,     8,     8,    11,     6,     9,     9,     9,     1,
     1,     7,     8,     6,     6,     6,     7,     7,     7,     9,
     7,     9,    17,     7,     7,    11,     8,     8,     8,     8,
     3,     4,    10,     7,     7,     8,     8,     8,     7,     8,
     5,    11,     5,     9,     1,     1,     1,     0,     2,     6,
     6,     6,     6,     4,     6,     6,     6,     4,     6,     3,
     4,     5,     3,     3,     4,     4,     3,     7,     7,     3,
     7,     3,     2,     2,    15,     2,     6,     8,     8,    10,
     1,     2,     1,     3,     4,     1,     5,    11,    13,     0,
     7,     0,    13,     0,    15,     0,     6,     0,    10,     8,
     8,     8,    12,    12,    12,    14,    14,    14,     0,    12,
     0,    12,     0,    12,     0,    16,     0,    16,     0,    16,
     0,    18,     0,    18,     0,    18,     1,     2,     5,     7,
     9,     2,     9,     6,     9,     9,     8,     9,     8,     8,
     6,     4,    10,    10,    10,    10,     2,     1,     3,     2,
     2,     2,     3,     3,     3,     3,     3,     3,     3,     3,
     3,     3,     3,     3,     3,     3,     5,     4,     4,     4,
     4,     4,     4,     4,     4,     4,     4,     6,     4,     4,
     4,     4,     4,     4,     6,     6,     6,     4,     4,     4,
     4,     4,     4,     4,     4,     4,     4,     4,     6,     4,
     4,     4,     4,     4,     4,     6,     6,     6,     4,     1,
     1,     1,     1,     1,     1,     1,     1,     5,     4,     4,
     2,     5,     3,     6,     4,     7,     6,     1,     2,     2,
     3,     3,    11,     9,     7,     7,     1,     3,     1,     1,
     2,     3,     4,     5,     2,     3,     3,     5,     4,     1,
     1,     1,     3,     6,     1,     1,     3,     3,     9,     7,
     1,     5,     3,     6,     1,     3,     1,     1,     6,     4,
     4,     4,     6,     6,     9
};

static const short yydefact[] = {     0,
     0,     1,     2,     0,     0,     0,     0,     0,     0,     0,
     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     0,     0,     0,     0,     0,   151,     0,   156,     0,   153,
     0,     0,     0,     0,     4,     6,     5,     7,     8,     9,
    10,    11,    12,    13,    19,    18,    14,    15,    16,    17,
   280,   287,   337,    54,   281,   282,   283,     0,     0,     0,
     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     0,     0,   338,     0,   284,   285,   286,    55,    56,    57,
    58,     0,     0,     0,    59,    60,     0,     0,     0,     0,
     0,     0,     0,   218,     0,     0,     0,     0,   144,     0,
   146,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     0,     0,     0,     0,     0,   298,     0,     0,     0,     0,
     0,     0,   118,     0,     0,   118,     0,     0,   118,   217,
     0,     0,     0,     0,     0,     0,     0,     0,   331,     0,
     0,     0,     0,     0,   143,     0,   152,   337,   118,     0,
   118,     0,     0,     0,     0,     0,   291,     0,    28,     0,
     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     0,     0,     0,     0,     0,     0,   287,   221,   220,   222,
     0,     0,     0,     0,     0,     0,     0,     0,     0,    66,
   140,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     0,     0,     0,     0,     0,     0,   137,   101,     0,     0,
     0,     0,   287,     0,     0,   320,   321,   322,   325,   326,
     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     0,     0,     0,     0,   309,     0,   310,     0,     0,     0,
     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     0,     0,   300,   299,     0,     0,     0,     0,   118,   118,
     0,     0,     0,     0,     0,     0,     0,     0,   166,     0,
   118,     0,     0,     0,     0,   130,     0,     0,     0,     0,
     0,     0,   142,     0,     0,     0,     0,     0,   118,     0,
     0,     0,   154,     0,   133,     0,   134,     0,     0,   293,
     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     0,     0,   219,     0,     0,     0,     0,    54,     0,     0,
     0,     0,     0,    61,     0,   236,   235,   233,   234,   229,
   231,   230,   232,   224,   223,   225,   226,   227,   228,   102,
     0,     0,     0,     0,     0,     0,   220,   315,     0,     0,
     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     0,     0,     0,     0,   311,     0,     0,     0,     0,     0,
     0,     0,     0,     0,     0,     0,     0,     0,    80,    81,
     0,     0,     0,     0,     0,     0,     0,   302,   301,   117,
     0,   116,   115,     0,     0,     0,     0,     0,     0,     0,
     0,     0,     0,     0,   119,     0,     0,   160,     0,   124,
   212,     0,   131,     0,   128,     0,     0,     0,     0,     0,
     0,     0,     0,     0,     0,     0,     0,   155,   135,   136,
     0,   289,   295,     0,    28,    39,     0,     0,     0,    51,
     0,     0,    29,    30,    31,    32,    33,    34,   238,   259,
   239,   260,   240,   261,   241,   262,   242,   263,   243,   264,
   244,   265,   245,   266,   246,   267,   258,   279,   247,   268,
     0,     0,   249,   270,   250,   271,   251,   272,   252,   273,
   253,   274,   254,   275,     0,     0,     0,     0,     0,     0,
     0,     0,   342,     0,     0,   340,   341,     0,     0,     0,
     0,     0,     0,     0,     0,     0,     0,    72,     0,     0,
     0,     0,   290,     0,    22,    20,     0,     0,     0,     0,
   323,     0,     0,   317,   225,   316,   327,   328,     0,     0,
     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     0,   312,     0,     0,     0,     0,     0,     0,     0,     0,
     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     0,   111,   113,     0,     0,     0,     0,     0,     0,     0,
     0,     0,     0,     0,     0,     0,   197,     0,   157,     0,
     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     0,     0,   132,     0,     0,     0,     0,   292,     0,   288,
     0,     0,     0,     0,     0,     0,     0,    26,     0,     0,
     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     0,   289,    64,    65,     0,     0,     0,     0,     0,    67,
    68,    70,     0,     0,   335,     0,    76,   237,    21,     0,
     0,     0,     0,     0,   319,     0,     0,     0,     0,     0,
     0,     0,     0,     0,     0,     0,     0,     0,     0,   313,
     0,    86,     0,     0,     0,     0,     0,   204,     0,     0,
     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     0,   118,     0,     0,     0,     0,     0,     0,     0,   202,
     0,     0,   167,   198,     0,     0,   125,   211,   129,    84,
    85,   126,   127,     0,     0,     0,   332,     0,     0,     0,
   147,   139,   294,   138,     0,     0,     0,     0,     0,   307,
     0,     0,   248,   269,   255,   276,   256,   277,   257,   278,
     0,   344,   343,   339,   297,     0,    54,     0,     0,     0,
     0,    62,     0,     0,     0,   333,    23,    24,     0,     0,
    82,     0,   318,     0,    89,     0,    91,     0,     0,    87,
     0,     0,   104,   105,     0,     0,    88,   109,   314,     0,
     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     0,     0,     0,   141,     0,     0,     0,     0,   118,   168,
     0,   179,     0,   181,     0,   183,     0,     0,     0,     0,
   309,     0,     0,     0,     0,   161,    94,    95,     0,     0,
     0,     0,   296,    27,     0,    35,     0,     0,     0,     0,
     0,    37,     0,     0,     0,     0,     0,    73,     0,     0,
    74,     0,   336,     0,     0,   324,     0,     0,     0,    97,
     0,     0,   106,     0,     0,     0,   209,    99,   100,     0,
     0,     0,   207,   210,   108,    83,    98,   107,   110,     0,
     0,     0,   306,     0,   305,     0,     0,     0,   170,     0,
     0,   171,     0,     0,   172,     0,   120,   121,   122,   123,
     0,     0,     0,     0,     0,     0,     0,   330,     0,   149,
   148,    40,     0,     0,     0,   308,     0,     0,     0,     0,
     0,    63,    69,    71,     0,    77,     0,    25,     0,     0,
    90,    92,     0,     0,     0,     0,     0,   206,   205,   208,
    78,    79,   118,     0,   114,     0,     0,     0,     0,     0,
     0,     0,   199,     0,     0,   118,     0,     0,     0,     0,
     0,    36,     0,     0,     0,    38,    52,    53,   345,     0,
   334,     0,   213,   214,   215,   216,   103,     0,     0,     0,
   304,   169,     0,     0,     0,     0,     0,     0,     0,     0,
     0,     0,     0,     0,   162,     0,     0,   329,   150,     0,
     0,     0,     0,    75,     0,     0,   112,     0,   185,     0,
     0,   187,     0,     0,   189,     0,     0,     0,   200,     0,
   158,     0,   118,    96,     0,    44,     0,    50,     0,     0,
   303,   173,     0,     0,   180,   174,     0,     0,   182,   175,
     0,     0,   184,     0,     0,     0,   164,     0,     0,     0,
     0,     0,     0,   191,     0,   193,     0,   195,   201,   203,
   163,   159,     0,    41,     0,    48,     0,     0,     0,   176,
     0,     0,   177,     0,     0,   178,     0,     0,     0,    42,
     0,   145,     0,     0,     0,     0,     0,     0,     0,   165,
     0,     0,     0,     0,   186,     0,   188,     0,   190,     0,
    43,    45,     0,    46,    93,     0,     0,     0,     0,     0,
   192,   194,   196,    47,    49,     0,     0,     0
};

static const short yydefgoto[] = {  1216,
     2,    55,   637,    56,    57,   383,   935,   941,   563,   722,
  1061,  1179,   564,  1149,  1203,   565,  1181,   566,   567,   726,
   568,   121,   207,    58,   498,   525,   296,   511,   512,   297,
    62,    63,    64,    65,    66,   298,   700,  1122,  1163,   526,
   987,   990,   993,   996,  1133,  1137,  1141,  1171,  1174,  1177,
   696,   697,    68,    69,    70,   315,   124,   333,   166,   839,
   840,   317,   301,   191,   632,   756,   500
};

static const short yypact[] = {  2839,
    21,  2916,-32768,  1967,    24,    47,   -80,     2,    69,   -90,
   -16,    -6,   -19,     4,    40,   -40,    46,    63,    76,   -32,
    90,   116,   159,   181,   163,   531,   124,    85,   -57,   -57,
    91,    20,     7,   267,     8,   348,   211,   353,   360,   396,
   278,   288,   301,     9,     6,-32768,   340,-32768,   433,-32768,
   470,   473,    18,    34,-32768,-32768,-32768,-32768,-32768,-32768,
-32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,
-32768,     3,    10,-32768,-32768,-32768,-32768,   -26,   113,   219,
   292,   300,   311,   332,   339,   347,   376,   397,   456,   499,
   512,   516,   520,   537,   538,   543,   553,   562,   363,   366,
   373,   379,-32768,   382,-32768,-32768,-32768,-32768,-32768,-32768,
-32768,  2262,  2262,  2262,-32768,-32768,  2262,  1761,    12,   480,
  2262,   510,  1195,-32768,   521,   526,  2262,   536,-32768,  2262,
-32768,  2262,  2101,  2262,  2262,   411,  2262,  2101,  2262,  2262,
   421,  2101,  2262,  2262,  1364,   439,  2262,   440,   452,   471,
  1364,   469,   477,   493,   508,   530,   534,   544,   545,   -57,
   -57,   -57,  2262,  2262,   -79,-32768,   -60,   -57,   475,   500,
   547,   573,  1932,   -54,   556,-32768,  1364,    22,-32768,-32768,
  1364,  1364,   583,   601,   554,  2262,  2262,  2262,   511,  2262,
   599,   649,  2262,  2262,-32768,   760,-32768,-32768,-32768,   764,
-32768,   768,   675,  2262,   805,   676,-32768,   -57,-32768,  2262,
  2262,  2262,  2262,  2262,  2262,  2262,  2262,  2262,  2262,  2262,
  2262,  2262,  2262,  2262,  2262,  2262,  2262,  2262,  2262,  2262,
  2262,  2262,  2262,  2262,  2262,  2262,  2262,  2262,  2262,  2262,
  2262,  2262,  2262,  2262,  2262,  2262,  2262,  2262,  2262,  2262,
  2262,   581,   487,   487,   487,   808,   175,   686,   686,   686,
  5127,    -2,  2101,  1022,   209,   696,   825,   701,  1603,-32768,
-32768,  2262,  2262,  2262,  2262,  2262,  2262,  2262,  2262,  2262,
  2262,  2262,  2262,  2262,  2262,  2262,-32768,-32768,  1898,    43,
  3683,  5148,   418,   698,  2101,-32768,-32768,-32768,  2594,-32768,
   551,  5169,  5190,  2262,  5211,   560,  5232,  5253,  2262,   563,
  5274,  5295,  1501,  1227,  2622,   831,-32768,  2262,  5316,  2262,
  2262,  2262,   832,  2262,  2262,  2262,  2225,  2225,  2225,  2225,
   708,    97,-32768,-32768,  3709,  3735,   -57,   -57,   682,   682,
   265,  2262,  2262,  2262,  2262,  1932,  1932,  2262,  2980,   413,
-32768,  2262,   978,    73,   835,-32768,  2262,  1401,   836,   838,
  2262,  2262,-32768,  5337,  5358,  5379,   751,  3761,-32768,   712,
  2641,  5400,-32768,  1538,-32768,  1789,-32768,  2262,  2929,   215,
  2262,   -20,     5,  5421,  4437,  5442,  4460,  5463,  4483,  5484,
  4506,  5505,  4529,  5526,  4552,  5547,  4575,  5568,  4598,  5589,
  4621,  5610,  4644,  5631,  4667,  3787,  3813,  5652,  4690,  5673,
  4713,  5694,  4736,  5715,  4759,  5736,  4782,  5757,  4805,  3839,
  3865,  3891,  3917,  3943,  3969,   568,    53,   709,   719,   720,
   717,  2262,-32768,  1364,  1364,   567,    93,   487,  2262,   849,
   854,    14,   725,-32768,  2664,   878,  1104,  1220,  1220,   557,
   557,   557,   557,   258,   258,   686,   686,   686,   686,-32768,
    15,  2101,  2262,   855,  1796,  2262,   686,-32768,  2262,  2101,
  2101,   769,   859,   860,  5778,   861,   776,   864,   866,  5799,
   780,   868,   869,  2101,-32768,   570,  1631,  2262,  5820,   873,
  2742,  5841,  5862,  2262,  3041,  3069,  5883,   749,  6135,-32768,
   750,   752,   754,   748,   -57,  2262,  2262,-32768,-32768,-32768,
   753,  2980,-32768,   755,  2262,  4828,  3995,  4021,  4047,  3657,
   -11,    86,   -25,    67,-32768,   237,   -57,  2358,  4851,-32768,
-32768,  2262,-32768,  4874,-32768,  1364,  1364,  4897,  4920,   880,
   881,   882,   756,  2262,  2378,  2262,  2262,-32768,-32768,-32768,
  4943,    72,-32768,  3097,-32768,-32768,   765,   766,   757,-32768,
   772,   893,-32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,
-32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,
-32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,
  2262,  2262,-32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,
-32768,-32768,-32768,-32768,  2262,  2262,  2262,  2262,  2262,  2262,
  2262,   896,-32768,  2101,   487,-32768,-32768,  2262,  4966,   898,
   899,   775,    25,  2262,   900,   905,  2034,-32768,   906,   779,
     9,   908,-32768,  2262,-32768,   797,   487,    74,  4073,   -57,
-32768,  2101,  3125,  2693,   686,-32768,  2594,-32768,   875,  1364,
  1364,   910,  1364,   659,  1364,  1364,   911,   874,  1364,  1364,
   578,-32768,  2101,  2073,   920,   790,   922,   925,   926,   671,
   927,   929,   930,   931,   932,   933,   934,   938,   417,  4099,
  4125,-32768,-32768,  3153,   810,   -57,   -57,   -57,  2101,  2101,
  2101,  2101,   937,   811,   815,   -42,-32768,   454,-32768,   237,
   944,  2193,   945,   946,   947,   949,   950,  1364,  1364,  1364,
   953,  4151,-32768,  2712,   705,   954,   960,-32768,   959,-32768,
    11,   837,  2262,  2262,  1364,   828,  2262,-32768,  5904,  4989,
  5925,  5012,  5946,  5035,  5967,  5058,  5081,   839,   115,   840,
  5988,    98,-32768,-32768,    13,   238,   842,   963,  2425,-32768,
-32768,-32768,     9,  2262,-32768,   596,-32768,  6135,-32768,   961,
    30,  2262,    32,   605,-32768,  2262,   841,    26,    27,  1364,
   972,   843,   844,   974,   977,  1364,   846,   979,   982,-32768,
   614,-32768,   984,  2262,  1364,  1364,  1364,-32768,   427,  1364,
  1364,  1364,  1364,  1364,  1364,  1364,   408,  2262,  2262,  2262,
   867,-32768,   119,   268,   299,   619,   620,   625,   626,-32768,
  1364,  2262,-32768,-32768,  1932,    56,-32768,-32768,-32768,-32768,
-32768,-32768,-32768,  1000,  1001,   919,-32768,  2262,  2262,  2262,
-32768,-32768,   215,-32768,  1004,  2262,  4177,  4203,   630,-32768,
  2262,  6009,-32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,
   876,-32768,-32768,-32768,-32768,  1364,   487,  2262,  1006,  1009,
    14,-32768,  1008,  5104,     9,-32768,-32768,-32768,   487,  4229,
-32768,   883,  6135,  2262,-32768,   -57,-32768,   -57,  1010,-32768,
  2262,  2262,-32768,-32768,  1012,  2262,-32768,-32768,-32768,  1014,
  4255,  1025,  1030,  1033,  2262,  2262,   771,  1034,  1035,  1037,
  1039,  1040,  1041,-32768,  2225,  3181,  6030,  2957,   682,  2980,
   -57,  1042,   -57,  1043,   -57,  1044,  1045,  1046,  1049,  1051,
   337,   923,  6051,  3209,   479,-32768,-32768,-32768,  1364,  2985,
   606,  6072,-32768,-32768,   174,  6135,  2262,  2262,  1364,   921,
   642,  6135,  1364,  1016,  1055,  1057,  2455,-32768,  1061,  1063,
-32768,   935,-32768,  1065,  2262,-32768,  3237,    38,    52,-32768,
  3265,  3293,-32768,  3321,  1069,  2262,-32768,-32768,-32768,  2474,
  2504,  1070,-32768,-32768,-32768,-32768,-32768,-32768,-32768,  2523,
  1073,   942,-32768,  2262,-32768,   948,   237,   484,-32768,   951,
   488,-32768,   955,   505,-32768,   956,-32768,-32768,-32768,-32768,
  1077,  1364,  1078,   957,  2262,   995,  2262,-32768,  2262,-32768,
-32768,-32768,  2262,  4281,  4307,-32768,  1364,  2262,  1080,  1082,
   965,-32768,-32768,-32768,     9,-32768,   999,-32768,  4333,  1086,
-32768,-32768,  1093,  1095,  1096,  1097,  4359,-32768,-32768,-32768,
-32768,-32768,   682,  3013,-32768,    92,  1932,   237,  1932,   237,
  1932,   237,-32768,   660,  1364,-32768,  3349,  2262,  3377,  3405,
   966,  6135,  2262,  2262,   661,  6135,-32768,-32768,-32768,  1099,
-32768,  2262,-32768,-32768,-32768,-32768,-32768,  1101,   969,  2262,
-32768,-32768,  3433,   507,   279,  3461,   513,   308,  3489,   515,
   327,  1364,  1103,  1050,  2427,   976,  2546,-32768,-32768,  2262,
  6093,  4385,  1109,-32768,  4411,   973,-32768,  3517,  1110,  2262,
  1112,  1113,  2262,  1114,  1116,  2262,  1117,   985,-32768,  2262,
-32768,   237,-32768,-32768,   667,-32768,  2262,-32768,  2262,  1120,
-32768,-32768,   988,  3545,-32768,-32768,   989,  3573,-32768,-32768,
   990,  3601,-32768,  1127,  2575,   336,  2476,  1142,  1017,  6114,
  3629,  1013,   237,  1148,   237,  1151,   237,  1152,-32768,-32768,
-32768,-32768,   237,-32768,   487,-32768,  1154,  1158,   352,-32768,
  1026,   369,-32768,  1028,   392,-32768,  1029,   423,   668,-32768,
  1032,-32768,  1036,  1162,   237,  1165,   237,  1166,   237,-32768,
   487,  1167,   487,  1168,-32768,   426,-32768,   429,-32768,   445,
-32768,-32768,   673,-32768,-32768,  1171,  1173,  1174,   487,  1175,
-32768,-32768,-32768,-32768,-32768,  1182,  1183,-32768
};

static const short yypgoto[] = {-32768,
-32768,-32768,   424,-32768,-32768,   629,-32768,    94,-32768,-32768,
-32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,
-32768,  -259,    36,-32768,    31,  1189,    -1,  -338,  -154,     1,
-32768,-32768,-32768,-32768,-32768,  1191,-32768,-32768,-32768,-32768,
-32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,
  -491,  -606,-32768,-32768,-32768,    49,-32768,   275,-32768,   178,
   422,   284,   230,  -627,   335,-32768,    -4
};


#define	YYLAST		6265


static const short yytable[] = {   125,
    60,   514,    61,   755,   434,   439,   203,   129,   556,   192,
   175,   178,   189,   208,   556,   265,   146,   630,   349,    74,
   635,   353,   198,   169,   358,   355,     3,   356,   746,   693,
   141,   875,   877,   694,   695,   868,   126,   871,   198,   122,
   132,   337,   338,  1031,   374,   141,   376,   133,   200,   202,
   128,   136,   123,    99,   100,   101,   102,  1032,   339,   103,
   337,   338,   170,   161,   162,   171,   337,   338,   172,    99,
   100,   101,   102,   163,   131,   103,   198,   340,   531,   532,
   164,   876,   878,   351,   557,   558,   559,   560,   561,   814,
   557,   558,   559,   560,   561,   127,   813,   142,   147,    74,
   337,   338,   266,   267,   210,   435,   211,    99,   100,   101,
   102,   137,   691,   103,   134,   747,   748,   555,   138,   132,
   108,   109,   110,   111,   135,   863,   689,   693,   145,   115,
   116,   694,   695,   636,   139,   204,   193,   205,   148,   130,
   161,   162,   206,   562,   176,   179,   190,   209,   636,   835,
   163,   631,   337,   338,   357,   199,   136,   173,   337,   338,
   258,   259,   260,   693,   149,   261,   264,   694,   695,   269,
   140,   201,   337,   338,   461,   289,   143,   624,   291,   462,
   292,   299,   302,   303,   613,   305,   299,   307,   308,   614,
   299,   311,   312,   144,   926,   319,   528,   144,   115,   116,
   108,   109,   110,   111,   692,   761,   717,   150,   816,   814,
   471,   335,   336,   154,   545,   438,   137,   337,   338,   115,
   116,   336,   160,   690,   115,   116,   151,   623,   168,   152,
  1082,   153,   717,   505,   364,   365,   366,   953,   368,   337,
   338,   371,   372,   212,   857,   213,   853,   427,   428,   429,
   430,   471,   379,   181,   159,   911,   182,   912,   384,   385,
   386,   387,   388,   389,   390,   391,   392,   393,   394,   395,
   396,   397,   398,   399,   400,   401,   402,   403,   404,   405,
   406,   407,   408,   409,   410,   411,   412,   413,   414,   415,
   416,   417,   418,   419,   420,   421,   422,   423,   424,   425,
   440,   115,   116,   165,   167,  1012,   174,   432,   693,   205,
  1013,   299,   694,   695,   206,   177,   108,   109,   110,   111,
   445,   446,   447,   448,   449,   450,   451,   452,   453,   454,
   455,   456,   457,   458,   459,   115,   116,   510,   510,   513,
   513,   115,   116,   467,   469,   108,   109,   110,   111,   214,
   693,   215,   475,   180,   694,   695,   183,   480,   501,   502,
   503,   467,   299,   184,   115,   116,   489,   306,   491,   492,
   493,   310,   495,   496,   497,   499,   499,   499,   499,   693,
   283,   284,   285,   694,   695,   337,   338,   286,   337,   338,
   516,   517,   518,   519,   258,   259,   520,  1070,   693,   185,
   529,   515,   694,   695,   913,   534,   914,   693,   186,   538,
   539,   694,   695,   904,   905,   553,   300,  1111,   187,   337,
   338,   300,   216,   693,   217,   300,   551,   694,   695,   554,
   218,   188,   219,   626,   332,   915,   334,   916,   195,   814,
   693,   220,   341,   221,   694,   695,  1114,   350,   272,   273,
   274,   275,   276,   277,   278,   279,   280,   281,   282,   487,
   284,   285,   222,   693,   223,  1117,   286,   694,   695,   224,
   194,   225,   625,   196,  1161,  1001,   197,   226,   814,   227,
   619,   814,   382,   268,   814,   856,   858,   627,   895,   896,
  1184,   198,   436,   252,   693,  1046,   253,   693,   694,   695,
   693,   694,   695,   254,   694,   695,   228,  1186,   229,   255,
   299,   639,   256,   619,   643,   270,   693,   644,   645,   647,
   694,   695,    99,   100,   101,   102,   287,   230,   103,   231,
  1188,   288,   299,   337,   338,   645,   664,   337,   338,   814,
   290,   304,   670,   486,   115,   116,   300,   719,   331,   527,
   465,   309,   205,   798,   680,   681,  1085,   206,  1088,   363,
  1091,  1190,   814,   684,  1206,   814,   316,  1207,   814,   318,
   986,   814,   323,   155,   337,   338,   156,   320,   468,   157,
   702,   158,   321,  1208,   426,   198,   232,   718,   233,   814,
   815,   814,   712,   814,   714,   715,   468,   300,   354,   337,
   338,   322,   359,   360,   337,   338,   324,   342,   337,   338,
   740,   508,   509,  1009,   325,  1005,    99,   100,   101,   102,
  1047,   334,   103,   326,  1049,   337,   338,   337,   338,   234,
  1146,   235,   760,   337,   338,   337,   338,   343,   327,   729,
   730,  1051,   236,  1110,   237,   367,   238,   910,   239,  1113,
   240,  1116,   241,   731,   732,   733,   734,   735,   736,   737,
   328,  1169,   299,  1172,   329,  1175,   741,   242,   244,   243,
   245,  1178,   749,   246,   330,   247,   788,   281,   282,   283,
   284,   285,   758,   248,   344,   249,   286,   471,   352,   472,
   299,   638,   250,  1196,   251,  1198,   471,  1200,   477,   471,
   611,   481,   612,   471,  1079,   622,   471,   772,   662,   773,
   345,   299,   830,   661,   471,   361,   780,   272,   273,   274,
   275,   276,   277,   278,   279,   280,   281,   282,   283,   284,
   285,   789,   865,   362,   866,   286,   369,   299,   299,   299,
   299,   471,   370,   872,  1010,   300,    28,    29,    30,    31,
   471,    33,   889,   646,   648,   471,   471,   917,   918,    38,
    39,   471,   471,   919,   920,   373,   939,   300,   940,   375,
   646,   837,   838,   377,   972,   842,   973,   718,  1018,   679,
  1019,   859,   272,   273,   274,   275,   276,   277,   278,   279,
   280,   281,   282,   283,   284,   285,  1092,   939,  1093,  1103,
   286,   698,   864,  1018,  1191,  1148,  1192,   378,   380,  1209,
   870,  1210,   431,   381,   873,   286,   272,   273,   274,   275,
   276,   277,   278,   279,   280,   281,   282,   283,   284,   285,
   441,   442,   891,   443,   286,   466,   831,   488,   494,   504,
   533,   543,   536,   739,   537,   615,   906,   907,   908,   546,
   616,   617,   946,   618,   628,   620,   621,   629,   633,   921,
   923,   640,   649,   924,   954,   650,   651,   653,   933,   654,
   655,   764,   656,   658,   659,   660,   930,   931,   932,   666,
   674,   675,   678,   676,   936,   677,   708,   709,   710,   942,
   711,   682,   781,   683,   725,   723,   724,   300,   728,   738,
   981,  1095,   727,   743,   744,   750,   947,   510,   745,   513,
   751,   754,   753,   757,   763,   759,   770,   776,   806,   807,
   808,   809,   957,   767,   777,   300,   783,   784,   785,   961,
   962,   786,   787,   790,   964,   791,   792,   793,   794,   795,
   796,   797,   810,   970,   971,   812,   300,   802,   811,   817,
   819,   820,   821,   980,   822,   823,   827,   704,   705,   832,
   803,   804,   805,   833,   834,   841,   867,   836,  1147,   861,
   852,   854,   300,   300,   300,   300,   860,   880,   874,   883,
   881,   882,   884,   886,   887,  1014,  1015,   888,   890,     5,
     6,   274,   275,   276,   277,   278,   279,   280,   281,   282,
   283,   284,   285,  1029,   909,   927,   928,   286,   929,   934,
   944,   948,   949,   951,  1037,   960,   956,   963,   965,  1021,
   521,    11,    12,   522,    14,    15,   523,    17,   524,    19,
   967,    20,  1044,    22,    23,   968,    25,    26,   969,   974,
   975,   510,   976,   513,   977,   978,   979,   989,   992,   995,
   997,   998,    37,  1057,   999,  1059,  1000,  1060,  1017,  1002,
  1022,  1062,  1023,    41,    42,    43,  1066,  1025,  1026,  1027,
  1028,   768,   769,  1036,   771,  1040,   774,   775,  1042,  1043,
   778,   779,  1053,  1058,  1055,  1067,  1045,  1068,  1048,   925,
  1071,  1073,  1050,  1052,  1056,  1083,  1069,  1086,  1074,  1089,
  1075,  1076,  1077,  1100,  1104,  1106,  1097,  1107,  1119,  1130,
  1120,  1101,  1102,  1123,  1128,  1132,   530,  1135,  1136,  1139,
  1105,  1140,  1143,  1144,  1152,  1153,  1155,  1157,  1108,   824,
   825,   826,  1159,   272,   273,   274,   275,   276,   277,   278,
   279,   280,   281,   282,   283,   284,   285,  1164,   942,  1168,
   958,   286,   959,  1170,  1165,   437,  1173,  1176,  1134,  1182,
  1180,  1138,  1183,  1185,  1142,  1187,  1189,  1195,  1145,  1193,
  1197,  1199,  1202,  1205,  1194,  1150,  1211,  1151,  1212,  1213,
  1215,  1217,  1218,   721,   869,   988,  1201,   991,  1204,   994,
    59,   879,    67,  1125,  1065,   950,     0,   885,     0,     0,
   271,     0,     0,     0,  1214,     0,   892,   893,   894,     0,
     0,   897,   898,   899,   900,   901,   902,   903,   275,   276,
   277,   278,   279,   280,   281,   282,   283,   284,   285,    71,
   293,     0,   922,   286,     0,    75,    76,    77,     0,     0,
    78,    79,    80,    81,    82,    83,    84,    85,    86,    87,
    88,    89,    90,    91,    92,    93,    94,    95,    96,    97,
    98,     0,     0,     0,     0,     0,     0,     0,     0,   294,
     0,     0,     0,     0,     0,     0,     0,   945,     0,     0,
     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     0,    28,    29,    30,    31,    32,    33,     0,     0,     0,
     0,     0,     0,     0,    38,    39,   272,   273,   274,   275,
   276,   277,   278,   279,   280,   281,   282,   283,   284,   285,
     0,  1084,     0,  1087,   286,  1090,     0,     0,     0,     0,
   104,   105,   106,   107,     0,     0,   277,   278,   279,   280,
   281,   282,   283,   284,   285,     0,     0,   112,   295,   286,
  1006,     0,   114,     0,     0,     0,     0,   117,     0,     0,
  1016,     0,   120,     0,  1020,   485,    71,   293,     0,     0,
     0,     0,    75,    76,    77,     0,     0,    78,    79,    80,
    81,    82,    83,    84,    85,    86,    87,    88,    89,    90,
    91,    92,    93,    94,    95,    96,    97,    98,     0,     0,
     0,     0,     0,     0,     0,     0,   294,     0,     0,     0,
     0,     0,     5,     6,     0,     0,     0,     0,     0,     0,
     0,     0,     0,  1054,     0,     0,     0,     0,    28,    29,
    30,    31,    32,    33,     0,     0,     0,     0,     0,     0,
     0,    38,    39,   521,    11,    12,   522,    14,    15,   523,
    17,   524,    19,     0,    20,     0,    22,    23,     0,    25,
    26,     0,     0,     0,     0,     0,     0,   104,   105,   106,
   107,     0,     0,     0,     0,    37,  1094,     0,     0,     0,
     0,     0,     0,     0,   112,   313,    41,    42,    43,   114,
     0,     0,     0,     0,   117,     0,     0,     0,     0,   120,
     0,   314,     0,    71,   293,     0,     0,     0,     0,    75,
    76,    77,     0,  1118,    78,    79,    80,    81,    82,    83,
    84,    85,    86,    87,    88,    89,    90,    91,    92,    93,
    94,    95,    96,    97,    98,     0,     0,     0,     0,   535,
     0,     0,     0,   294,     0,     0,     0,     0,     0,     5,
     6,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     0,     0,     0,     0,     0,    28,    29,    30,    31,    32,
    33,     0,     0,     0,     0,     0,     0,     0,    38,    39,
   521,    11,    12,   522,    14,    15,   523,    17,   524,    19,
     0,    20,     0,    22,    23,     0,    25,    26,     0,     0,
     0,     0,     0,     0,   104,   105,   106,   107,   444,     0,
     0,     0,    37,     0,     0,     0,     0,     0,     0,     0,
     0,   112,   295,    41,    42,    43,   114,     0,     0,     0,
     0,   117,     0,    71,   293,     0,   120,     0,   484,    75,
    76,    77,     0,     0,    78,    79,    80,    81,    82,    83,
    84,    85,    86,    87,    88,    89,    90,    91,    92,    93,
    94,    95,    96,    97,    98,     0,     0,     0,     0,     0,
     0,     0,     0,   294,     0,     0,   549,     0,     0,     0,
     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     0,     0,     0,     0,     0,    28,    29,    30,    31,    32,
    33,     0,     0,     0,     0,     0,     0,     0,    38,    39,
     0,     0,     0,     0,   272,   273,   274,   275,   276,   277,
   278,   279,   280,   281,   282,   283,   284,   285,     0,     0,
     0,     0,   286,     0,   104,   105,   106,   107,     0,     0,
     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     0,   112,   295,     0,     0,     0,   114,     0,     0,     0,
     0,   117,     0,    71,   257,     0,   120,     0,   663,    75,
    76,    77,     0,     0,    78,    79,    80,    81,    82,    83,
    84,    85,    86,    87,    88,    89,    90,    91,    92,    93,
    94,    95,    96,    97,    98,     0,     0,     0,    71,   257,
     5,     6,     0,     0,    75,    76,    77,     0,     0,    78,
    79,    80,    81,    82,    83,    84,    85,    86,    87,    88,
    89,    90,    91,    92,    93,    94,    95,    96,    97,    98,
     0,   521,    11,    12,   522,    14,    15,   523,    17,   524,
    19,     0,    20,     0,    22,    23,     0,    25,    26,     0,
     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     0,     0,     0,    37,   104,   105,   106,   107,     0,     0,
     0,     0,     0,     0,    41,    42,    43,     0,     0,     0,
     0,   112,   113,     0,     0,     0,   114,     0,     0,     0,
     0,   117,     0,     0,   262,     0,   120,     0,   263,   104,
   105,   106,   107,   460,     0,     0,     0,     0,     0,     0,
     0,     0,     0,     0,     0,     0,   112,   113,     0,     0,
     0,   114,     0,     0,     0,     0,   117,   550,     0,   641,
     0,   120,     0,   642,    71,   257,     0,     0,     0,     0,
    75,    76,    77,     0,     0,    78,    79,    80,    81,    82,
    83,    84,    85,    86,    87,    88,    89,    90,    91,    92,
    93,    94,    95,    96,    97,    98,     0,     0,     0,    71,
    72,    73,     0,    74,     0,    75,    76,    77,     0,     0,
    78,    79,    80,    81,    82,    83,    84,    85,    86,    87,
    88,    89,    90,    91,    92,    93,    94,    95,    96,    97,
    98,     0,    99,   100,   101,   102,     0,     0,   103,   272,
   273,   274,   275,   276,   277,   278,   279,   280,   281,   282,
   283,   284,   285,     0,     0,     0,     0,   286,     0,     0,
     0,     0,     0,     0,     0,   104,   105,   106,   107,   752,
     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     0,     0,   346,   347,     0,     0,     0,   114,     0,     0,
     0,     0,   348,     0,     0,     0,     0,   120,     0,   164,
   104,   105,   106,   107,   108,   109,   110,   111,   782,     0,
     0,     0,     0,     0,     0,     0,     0,   112,   113,     0,
     0,     0,   114,   115,   116,     0,     0,   117,     0,   118,
     0,   119,   120,    71,   293,     0,     0,     0,     0,    75,
    76,    77,     0,     0,    78,    79,    80,    81,    82,    83,
    84,    85,    86,    87,    88,    89,    90,    91,    92,    93,
    94,    95,    96,    97,    98,     0,     0,     0,     0,     0,
     0,     0,     0,   294,     0,   272,   273,   274,   275,   276,
   277,   278,   279,   280,   281,   282,   283,   284,   285,     0,
     0,     0,     0,   286,     0,    28,    29,    30,    31,    32,
    33,     0,     0,     0,     0,     0,     0,     0,    38,    39,
     0,     0,     0,     0,   272,   273,   274,   275,   276,   277,
   278,   279,   280,   281,   282,   283,   284,   285,   818,     0,
     0,     0,   286,     0,   104,   105,   106,   107,     0,     0,
     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     0,   112,   295,     0,     0,     0,   114,    71,   257,   198,
     0,   117,     0,    75,    76,    77,   120,     0,    78,    79,
    80,    81,    82,    83,    84,    85,    86,    87,    88,    89,
    90,    91,    92,    93,    94,    95,    96,    97,    98,     0,
    99,   100,   101,   102,    71,   257,   103,     0,     0,     0,
    75,    76,    77,     0,     0,    78,    79,    80,    81,    82,
    83,    84,    85,    86,    87,    88,    89,    90,    91,    92,
    93,    94,    95,    96,    97,    98,     0,     0,     0,     0,
     0,     0,     0,     0,   272,   273,   274,   275,   276,   277,
   278,   279,   280,   281,   282,   283,   284,   285,     0,     0,
     0,     0,   286,     0,     0,     0,     0,     0,   104,   105,
   106,   107,     0,     0,     0,     0,     0,     0,     0,     0,
     0,     0,     0,     0,     0,   112,   113,     0,     0,     0,
   114,     0,     0,     0,     0,   117,     0,     0,     0,     0,
   120,     0,     0,     0,     0,   104,   105,   106,   107,     5,
     6,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     0,     0,   112,   113,     0,     0,     0,   114,     0,     5,
     6,     0,   117,     0,     0,     0,     0,   120,     0,     0,
   521,    11,    12,   522,    14,    15,   523,    17,   524,    19,
     0,    20,     0,    22,    23,     0,    25,    26,     0,     0,
   521,    11,    12,   522,    14,    15,   523,    17,   524,    19,
   862,    20,    37,    22,    23,     0,    25,    26,     5,     6,
     0,     0,     0,    41,    42,    43,     0,     0,     0,     0,
     0,     0,    37,     0,     0,     0,     0,     0,     0,     0,
  1024,     0,     0,    41,    42,    43,     0,     0,     0,   521,
    11,    12,   522,    14,    15,   523,    17,   524,    19,  1038,
    20,     0,    22,    23,     0,    25,    26,     5,     6,     0,
     0,     0,     0,     0,     0,     0,   699,     0,     0,     0,
     0,    37,     0,     0,     0,     0,     0,     0,     0,  1039,
     0,     0,    41,    42,    43,     0,   713,     0,   521,    11,
    12,   522,    14,    15,   523,    17,   524,    19,  1041,    20,
     0,    22,    23,     0,    25,    26,   272,   273,   274,   275,
   276,   277,   278,   279,   280,   281,   282,   283,   284,   285,
    37,  1124,     0,     0,   286,     0,     0,     0,     0,     0,
     0,    41,    42,    43,     0,  1121,   272,   273,   274,   275,
   276,   277,   278,   279,   280,   281,   282,   283,   284,   285,
  1160,     0,     0,     0,   286,   272,   273,   274,   275,   276,
   277,   278,   279,   280,   281,   282,   283,   284,   285,     0,
     0,   469,     0,   286,     0,     0,     0,     0,     0,     0,
     0,     0,     0,     0,  1162,   272,   273,   274,   275,   276,
   277,   278,   279,   280,   281,   282,   283,   284,   285,   469,
     0,     0,     0,   286,   272,   273,   274,   275,   276,   277,
   278,   279,   280,   281,   282,   283,   284,   285,   547,     0,
     0,     0,   286,     0,     0,     0,     0,   272,   273,   274,
   275,   276,   277,   278,   279,   280,   281,   282,   283,   284,
   285,   634,     0,     0,     0,   286,     0,     0,     0,     0,
     0,     0,     0,     0,     0,     0,   272,   273,   274,   275,
   276,   277,   278,   279,   280,   281,   282,   283,   284,   285,
   766,     0,     0,     0,   286,   272,   273,   274,   275,   276,
   277,   278,   279,   280,   281,   282,   470,   284,   285,   829,
     0,     0,     0,   286,     0,     0,     0,     0,     0,     0,
     0,     0,     0,   272,   273,   274,   275,   276,   277,   278,
   279,   280,   281,   282,   487,   284,   285,     0,     0,     0,
     0,   286,   272,   273,   274,   275,   276,   277,   278,   279,
   280,   281,   282,   283,   284,   285,     0,     0,     0,     0,
   286,     0,     0,     0,     0,   272,   273,   274,   275,   276,
   277,   278,   279,   280,   281,   282,   283,   284,   285,     0,
     0,     0,     0,   286,     0,     0,     0,     0,     0,     0,
     0,     0,     0,     0,   272,   273,   274,   275,   276,   277,
   278,   279,   280,   281,   282,   283,   284,   285,     0,     0,
     0,     0,   286,   272,   273,   274,   275,   276,   277,   278,
   279,   280,   281,   282,   283,   284,   285,     0,    -3,     1,
     0,   286,    -3,     0,     0,     0,     0,     0,     0,     0,
    -3,    -3,     0,   272,   273,   274,   275,   276,   277,   278,
   279,   280,   281,   282,   283,   284,   285,     0,     0,     0,
     0,   286,     0,    -3,     0,     0,     0,     0,    -3,    -3,
   667,    -3,    -3,    -3,    -3,    -3,    -3,    -3,    -3,    -3,
    -3,     0,    -3,    -3,    -3,    -3,    -3,    -3,    -3,     0,
     0,     0,    -3,    -3,    -3,    -3,    -3,    -3,    -3,     0,
    -3,    -3,    -3,    -3,     0,     0,    -3,    -3,     0,     4,
     0,     0,     0,    -3,    -3,    -3,    -3,     5,     6,    -3,
     0,    -3,     0,    -3,    -3,    -3,    -3,    -3,    -3,    -3,
    -3,    -3,     0,     0,     0,     0,     0,     0,     0,     0,
     7,     0,     0,     0,     0,     8,     9,     0,    10,    11,
    12,    13,    14,    15,    16,    17,    18,    19,     0,    20,
    21,    22,    23,    24,    25,    26,     0,     0,     0,    27,
    28,    29,    30,    31,    32,    33,     0,    34,    35,    36,
    37,     5,     6,    38,    39,     0,     0,     0,     0,     0,
    40,    41,    42,    43,     0,     0,    44,     0,    45,     0,
    46,    47,    48,    49,    50,    51,    52,    53,    54,     0,
     0,     0,   521,    11,    12,   522,    14,    15,   523,    17,
   524,    19,     0,    20,     0,    22,    23,     0,    25,    26,
   272,   273,   274,   275,   276,   277,   278,   279,   280,   281,
   282,   283,   284,   285,    37,     0,     0,     0,   286,     0,
     0,     0,   552,     0,     0,    41,    42,    43,   272,   273,
   274,   275,   276,   277,   278,   279,   280,   281,   282,   283,
   284,   285,     0,     0,     0,     0,   286,     0,     0,     0,
     0,     0,     0,   984,     0,   985,   272,   273,   274,   275,
   276,   277,   278,   279,   280,   281,   282,   283,   284,   285,
     0,     0,     0,     0,   286,     0,     0,     0,     0,     0,
     0,  1007,     0,  1008,   272,   273,   274,   275,   276,   277,
   278,   279,   280,   281,   282,   283,   284,   285,     0,     0,
     0,     0,   286,     0,     0,     0,     0,     0,     0,  1080,
     0,  1081,   272,   273,   274,   275,   276,   277,   278,   279,
   280,   281,   282,   283,   284,   285,     0,     0,     0,     0,
   286,     0,     0,     0,     0,     0,     0,     0,     0,   671,
   272,   273,   274,   275,   276,   277,   278,   279,   280,   281,
   282,   283,   284,   285,     0,     0,     0,     0,   286,     0,
     0,     0,     0,     0,     0,     0,     0,   672,   272,   273,
   274,   275,   276,   277,   278,   279,   280,   281,   282,   283,
   284,   285,     0,     0,     0,     0,   286,     0,     0,     0,
     0,     0,     0,     0,     0,   720,   272,   273,   274,   275,
   276,   277,   278,   279,   280,   281,   282,   283,   284,   285,
     0,     0,     0,     0,   286,     0,     0,     0,     0,     0,
     0,     0,     0,   765,   272,   273,   274,   275,   276,   277,
   278,   279,   280,   281,   282,   283,   284,   285,     0,     0,
     0,     0,   286,     0,     0,     0,     0,     0,     0,     0,
     0,   801,   272,   273,   274,   275,   276,   277,   278,   279,
   280,   281,   282,   283,   284,   285,     0,     0,     0,     0,
   286,     0,     0,     0,     0,     0,     0,     0,     0,   982,
   272,   273,   274,   275,   276,   277,   278,   279,   280,   281,
   282,   283,   284,   285,     0,     0,     0,     0,   286,     0,
     0,     0,     0,     0,     0,     0,     0,  1004,   272,   273,
   274,   275,   276,   277,   278,   279,   280,   281,   282,   283,
   284,   285,     0,     0,     0,     0,   286,     0,     0,     0,
     0,     0,     0,     0,     0,  1030,   272,   273,   274,   275,
   276,   277,   278,   279,   280,   281,   282,   283,   284,   285,
     0,     0,     0,     0,   286,     0,     0,     0,     0,     0,
     0,     0,     0,  1033,   272,   273,   274,   275,   276,   277,
   278,   279,   280,   281,   282,   283,   284,   285,     0,     0,
     0,     0,   286,     0,     0,     0,     0,     0,     0,     0,
     0,  1034,   272,   273,   274,   275,   276,   277,   278,   279,
   280,   281,   282,   283,   284,   285,     0,     0,     0,     0,
   286,     0,     0,     0,     0,     0,     0,     0,     0,  1035,
   272,   273,   274,   275,   276,   277,   278,   279,   280,   281,
   282,   283,   284,   285,     0,     0,     0,     0,   286,     0,
     0,     0,     0,     0,     0,     0,     0,  1096,   272,   273,
   274,   275,   276,   277,   278,   279,   280,   281,   282,   283,
   284,   285,     0,     0,     0,     0,   286,     0,     0,     0,
     0,     0,     0,     0,     0,  1098,   272,   273,   274,   275,
   276,   277,   278,   279,   280,   281,   282,   283,   284,   285,
     0,     0,     0,     0,   286,     0,     0,     0,     0,     0,
     0,     0,     0,  1099,   272,   273,   274,   275,   276,   277,
   278,   279,   280,   281,   282,   283,   284,   285,     0,     0,
     0,     0,   286,     0,     0,     0,     0,     0,     0,     0,
     0,  1109,   272,   273,   274,   275,   276,   277,   278,   279,
   280,   281,   282,   283,   284,   285,     0,     0,     0,     0,
   286,     0,     0,     0,     0,     0,     0,     0,     0,  1112,
   272,   273,   274,   275,   276,   277,   278,   279,   280,   281,
   282,   283,   284,   285,     0,     0,     0,     0,   286,     0,
     0,     0,     0,     0,     0,     0,     0,  1115,   272,   273,
   274,   275,   276,   277,   278,   279,   280,   281,   282,   283,
   284,   285,     0,     0,     0,     0,   286,     0,     0,     0,
     0,     0,     0,     0,     0,  1131,   272,   273,   274,   275,
   276,   277,   278,   279,   280,   281,   282,   283,   284,   285,
     0,     0,     0,     0,   286,     0,     0,     0,     0,     0,
     0,     0,     0,  1154,   272,   273,   274,   275,   276,   277,
   278,   279,   280,   281,   282,   283,   284,   285,     0,     0,
     0,     0,   286,     0,     0,     0,     0,     0,     0,     0,
     0,  1156,   272,   273,   274,   275,   276,   277,   278,   279,
   280,   281,   282,   283,   284,   285,     0,     0,     0,     0,
   286,     0,     0,     0,     0,     0,     0,     0,     0,  1158,
   272,   273,   274,   275,   276,   277,   278,   279,   280,   281,
   282,   283,   284,   285,     0,     0,     0,     0,   286,     0,
     0,     0,     0,     0,     0,     0,     0,  1167,   272,   273,
   274,   275,   276,   277,   278,   279,   280,   281,   282,   283,
   284,   285,     0,     0,     0,     0,   286,     0,   433,     0,
     0,     0,     0,   506,   272,   273,   274,   275,   276,   277,
   278,   279,   280,   281,   282,   283,   284,   285,     0,     0,
     0,     0,   286,     0,     0,     0,     0,     0,     0,   463,
   272,   273,   274,   275,   276,   277,   278,   279,   280,   281,
   282,   283,   284,   285,     0,     0,     0,     0,   286,     0,
     0,     0,     0,     0,     0,   506,   272,   273,   274,   275,
   276,   277,   278,   279,   280,   281,   282,   283,   284,   285,
     0,     0,     0,     0,   286,     0,     0,     0,     0,     0,
     0,   507,   272,   273,   274,   275,   276,   277,   278,   279,
   280,   281,   282,   283,   284,   285,     0,     0,     0,     0,
   286,     0,     0,     0,     0,     0,     0,   544,   272,   273,
   274,   275,   276,   277,   278,   279,   280,   281,   282,   283,
   284,   285,     0,     0,     0,     0,   286,     0,     0,     0,
     0,     0,     0,   591,   272,   273,   274,   275,   276,   277,
   278,   279,   280,   281,   282,   283,   284,   285,     0,     0,
     0,     0,   286,     0,     0,     0,     0,     0,     0,   592,
   272,   273,   274,   275,   276,   277,   278,   279,   280,   281,
   282,   283,   284,   285,     0,     0,     0,     0,   286,     0,
     0,     0,     0,     0,     0,   605,   272,   273,   274,   275,
   276,   277,   278,   279,   280,   281,   282,   283,   284,   285,
     0,     0,     0,     0,   286,     0,     0,     0,     0,     0,
     0,   606,   272,   273,   274,   275,   276,   277,   278,   279,
   280,   281,   282,   283,   284,   285,     0,     0,     0,     0,
   286,     0,     0,     0,     0,     0,     0,   607,   272,   273,
   274,   275,   276,   277,   278,   279,   280,   281,   282,   283,
   284,   285,     0,     0,     0,     0,   286,     0,     0,     0,
     0,     0,     0,   608,   272,   273,   274,   275,   276,   277,
   278,   279,   280,   281,   282,   283,   284,   285,     0,     0,
     0,     0,   286,     0,     0,     0,     0,     0,     0,   609,
   272,   273,   274,   275,   276,   277,   278,   279,   280,   281,
   282,   283,   284,   285,     0,     0,     0,     0,   286,     0,
     0,     0,     0,     0,     0,   610,   272,   273,   274,   275,
   276,   277,   278,   279,   280,   281,   282,   283,   284,   285,
     0,     0,     0,     0,   286,     0,     0,     0,     0,     0,
     0,   686,   272,   273,   274,   275,   276,   277,   278,   279,
   280,   281,   282,   283,   284,   285,     0,     0,     0,     0,
   286,     0,     0,     0,     0,     0,     0,   687,   272,   273,
   274,   275,   276,   277,   278,   279,   280,   281,   282,   283,
   284,   285,     0,     0,     0,     0,   286,     0,     0,     0,
     0,     0,     0,   688,   272,   273,   274,   275,   276,   277,
   278,   279,   280,   281,   282,   283,   284,   285,     0,     0,
     0,     0,   286,     0,     0,     0,     0,     0,     0,   762,
   272,   273,   274,   275,   276,   277,   278,   279,   280,   281,
   282,   283,   284,   285,     0,     0,     0,     0,   286,     0,
     0,     0,     0,     0,     0,   799,   272,   273,   274,   275,
   276,   277,   278,   279,   280,   281,   282,   283,   284,   285,
     0,     0,     0,     0,   286,     0,     0,     0,     0,     0,
     0,   800,   272,   273,   274,   275,   276,   277,   278,   279,
   280,   281,   282,   283,   284,   285,     0,     0,     0,     0,
   286,     0,     0,     0,     0,     0,     0,   828,   272,   273,
   274,   275,   276,   277,   278,   279,   280,   281,   282,   283,
   284,   285,     0,     0,     0,     0,   286,     0,     0,     0,
     0,     0,     0,   937,   272,   273,   274,   275,   276,   277,
   278,   279,   280,   281,   282,   283,   284,   285,     0,     0,
     0,     0,   286,     0,     0,     0,     0,     0,     0,   938,
   272,   273,   274,   275,   276,   277,   278,   279,   280,   281,
   282,   283,   284,   285,     0,     0,     0,     0,   286,     0,
     0,     0,     0,     0,     0,   955,   272,   273,   274,   275,
   276,   277,   278,   279,   280,   281,   282,   283,   284,   285,
     0,     0,     0,     0,   286,     0,     0,     0,     0,     0,
     0,   966,   272,   273,   274,   275,   276,   277,   278,   279,
   280,   281,   282,   283,   284,   285,     0,     0,     0,     0,
   286,     0,     0,     0,     0,     0,     0,  1063,   272,   273,
   274,   275,   276,   277,   278,   279,   280,   281,   282,   283,
   284,   285,     0,     0,     0,     0,   286,     0,     0,     0,
     0,     0,     0,  1064,   272,   273,   274,   275,   276,   277,
   278,   279,   280,   281,   282,   283,   284,   285,     0,     0,
     0,     0,   286,     0,     0,     0,     0,     0,     0,  1072,
   272,   273,   274,   275,   276,   277,   278,   279,   280,   281,
   282,   283,   284,   285,     0,     0,     0,     0,   286,     0,
     0,     0,     0,     0,     0,  1078,   272,   273,   274,   275,
   276,   277,   278,   279,   280,   281,   282,   283,   284,   285,
     0,     0,     0,     0,   286,     0,     0,     0,     0,     0,
     0,  1127,   272,   273,   274,   275,   276,   277,   278,   279,
   280,   281,   282,   283,   284,   285,     0,     0,     0,     0,
   286,     0,     0,     0,     0,     0,     0,  1129,   272,   273,
   274,   275,   276,   277,   278,   279,   280,   281,   282,   283,
   284,   285,     0,     0,     0,     0,   286,     0,     0,     0,
   570,   272,   273,   274,   275,   276,   277,   278,   279,   280,
   281,   282,   283,   284,   285,     0,     0,     0,     0,   286,
     0,     0,     0,   572,   272,   273,   274,   275,   276,   277,
   278,   279,   280,   281,   282,   283,   284,   285,     0,     0,
     0,     0,   286,     0,     0,     0,   574,   272,   273,   274,
   275,   276,   277,   278,   279,   280,   281,   282,   283,   284,
   285,     0,     0,     0,     0,   286,     0,     0,     0,   576,
   272,   273,   274,   275,   276,   277,   278,   279,   280,   281,
   282,   283,   284,   285,     0,     0,     0,     0,   286,     0,
     0,     0,   578,   272,   273,   274,   275,   276,   277,   278,
   279,   280,   281,   282,   283,   284,   285,     0,     0,     0,
     0,   286,     0,     0,     0,   580,   272,   273,   274,   275,
   276,   277,   278,   279,   280,   281,   282,   283,   284,   285,
     0,     0,     0,     0,   286,     0,     0,     0,   582,   272,
   273,   274,   275,   276,   277,   278,   279,   280,   281,   282,
   283,   284,   285,     0,     0,     0,     0,   286,     0,     0,
     0,   584,   272,   273,   274,   275,   276,   277,   278,   279,
   280,   281,   282,   283,   284,   285,     0,     0,     0,     0,
   286,     0,     0,     0,   586,   272,   273,   274,   275,   276,
   277,   278,   279,   280,   281,   282,   283,   284,   285,     0,
     0,     0,     0,   286,     0,     0,     0,   588,   272,   273,
   274,   275,   276,   277,   278,   279,   280,   281,   282,   283,
   284,   285,     0,     0,     0,     0,   286,     0,     0,     0,
   590,   272,   273,   274,   275,   276,   277,   278,   279,   280,
   281,   282,   283,   284,   285,     0,     0,     0,     0,   286,
     0,     0,     0,   594,   272,   273,   274,   275,   276,   277,
   278,   279,   280,   281,   282,   283,   284,   285,     0,     0,
     0,     0,   286,     0,     0,     0,   596,   272,   273,   274,
   275,   276,   277,   278,   279,   280,   281,   282,   283,   284,
   285,     0,     0,     0,     0,   286,     0,     0,     0,   598,
   272,   273,   274,   275,   276,   277,   278,   279,   280,   281,
   282,   283,   284,   285,     0,     0,     0,     0,   286,     0,
     0,     0,   600,   272,   273,   274,   275,   276,   277,   278,
   279,   280,   281,   282,   283,   284,   285,     0,     0,     0,
     0,   286,     0,     0,     0,   602,   272,   273,   274,   275,
   276,   277,   278,   279,   280,   281,   282,   283,   284,   285,
     0,     0,     0,     0,   286,     0,     0,     0,   604,   272,
   273,   274,   275,   276,   277,   278,   279,   280,   281,   282,
   283,   284,   285,     0,     0,     0,     0,   286,     0,     0,
     0,   685,   272,   273,   274,   275,   276,   277,   278,   279,
   280,   281,   282,   283,   284,   285,     0,     0,     0,     0,
   286,     0,     0,     0,   701,   272,   273,   274,   275,   276,
   277,   278,   279,   280,   281,   282,   283,   284,   285,     0,
     0,     0,     0,   286,     0,     0,     0,   703,   272,   273,
   274,   275,   276,   277,   278,   279,   280,   281,   282,   283,
   284,   285,     0,     0,     0,     0,   286,     0,     0,     0,
   706,   272,   273,   274,   275,   276,   277,   278,   279,   280,
   281,   282,   283,   284,   285,     0,     0,     0,     0,   286,
     0,     0,     0,   707,   272,   273,   274,   275,   276,   277,
   278,   279,   280,   281,   282,   283,   284,   285,     0,     0,
     0,     0,   286,     0,     0,     0,   716,   272,   273,   274,
   275,   276,   277,   278,   279,   280,   281,   282,   283,   284,
   285,     0,     0,     0,     0,   286,     0,     0,     0,   742,
   272,   273,   274,   275,   276,   277,   278,   279,   280,   281,
   282,   283,   284,   285,     0,     0,     0,     0,   286,     0,
     0,     0,   844,   272,   273,   274,   275,   276,   277,   278,
   279,   280,   281,   282,   283,   284,   285,     0,     0,     0,
     0,   286,     0,     0,     0,   846,   272,   273,   274,   275,
   276,   277,   278,   279,   280,   281,   282,   283,   284,   285,
     0,     0,     0,     0,   286,     0,     0,     0,   848,   272,
   273,   274,   275,   276,   277,   278,   279,   280,   281,   282,
   283,   284,   285,     0,     0,     0,     0,   286,     0,     0,
     0,   850,   272,   273,   274,   275,   276,   277,   278,   279,
   280,   281,   282,   283,   284,   285,     0,     0,     0,     0,
   286,     0,     0,     0,   851,   272,   273,   274,   275,   276,
   277,   278,   279,   280,   281,   282,   283,   284,   285,     0,
     0,     0,     0,   286,     0,     0,     0,   952,   272,   273,
   274,   275,   276,   277,   278,   279,   280,   281,   282,   283,
   284,   285,     0,     0,     0,     0,   286,     0,   433,   272,
   273,   274,   275,   276,   277,   278,   279,   280,   281,   282,
   283,   284,   285,     0,     0,     0,     0,   286,     0,   464,
   272,   273,   274,   275,   276,   277,   278,   279,   280,   281,
   282,   283,   284,   285,     0,     0,     0,     0,   286,     0,
   473,   272,   273,   274,   275,   276,   277,   278,   279,   280,
   281,   282,   283,   284,   285,     0,     0,     0,     0,   286,
     0,   474,   272,   273,   274,   275,   276,   277,   278,   279,
   280,   281,   282,   283,   284,   285,     0,     0,     0,     0,
   286,     0,   476,   272,   273,   274,   275,   276,   277,   278,
   279,   280,   281,   282,   283,   284,   285,     0,     0,     0,
     0,   286,     0,   478,   272,   273,   274,   275,   276,   277,
   278,   279,   280,   281,   282,   283,   284,   285,     0,     0,
     0,     0,   286,     0,   479,   272,   273,   274,   275,   276,
   277,   278,   279,   280,   281,   282,   283,   284,   285,     0,
     0,     0,     0,   286,     0,   482,   272,   273,   274,   275,
   276,   277,   278,   279,   280,   281,   282,   283,   284,   285,
     0,     0,     0,     0,   286,     0,   483,   272,   273,   274,
   275,   276,   277,   278,   279,   280,   281,   282,   283,   284,
   285,     0,     0,     0,     0,   286,     0,   490,   272,   273,
   274,   275,   276,   277,   278,   279,   280,   281,   282,   283,
   284,   285,     0,     0,     0,     0,   286,     0,   540,   272,
   273,   274,   275,   276,   277,   278,   279,   280,   281,   282,
   283,   284,   285,     0,     0,     0,     0,   286,     0,   541,
   272,   273,   274,   275,   276,   277,   278,   279,   280,   281,
   282,   283,   284,   285,     0,     0,     0,     0,   286,     0,
   542,   272,   273,   274,   275,   276,   277,   278,   279,   280,
   281,   282,   283,   284,   285,     0,     0,     0,     0,   286,
     0,   548,   272,   273,   274,   275,   276,   277,   278,   279,
   280,   281,   282,   283,   284,   285,     0,     0,     0,     0,
   286,     0,   569,   272,   273,   274,   275,   276,   277,   278,
   279,   280,   281,   282,   283,   284,   285,     0,     0,     0,
     0,   286,     0,   571,   272,   273,   274,   275,   276,   277,
   278,   279,   280,   281,   282,   283,   284,   285,     0,     0,
     0,     0,   286,     0,   573,   272,   273,   274,   275,   276,
   277,   278,   279,   280,   281,   282,   283,   284,   285,     0,
     0,     0,     0,   286,     0,   575,   272,   273,   274,   275,
   276,   277,   278,   279,   280,   281,   282,   283,   284,   285,
     0,     0,     0,     0,   286,     0,   577,   272,   273,   274,
   275,   276,   277,   278,   279,   280,   281,   282,   283,   284,
   285,     0,     0,     0,     0,   286,     0,   579,   272,   273,
   274,   275,   276,   277,   278,   279,   280,   281,   282,   283,
   284,   285,     0,     0,     0,     0,   286,     0,   581,   272,
   273,   274,   275,   276,   277,   278,   279,   280,   281,   282,
   283,   284,   285,     0,     0,     0,     0,   286,     0,   583,
   272,   273,   274,   275,   276,   277,   278,   279,   280,   281,
   282,   283,   284,   285,     0,     0,     0,     0,   286,     0,
   585,   272,   273,   274,   275,   276,   277,   278,   279,   280,
   281,   282,   283,   284,   285,     0,     0,     0,     0,   286,
     0,   587,   272,   273,   274,   275,   276,   277,   278,   279,
   280,   281,   282,   283,   284,   285,     0,     0,     0,     0,
   286,     0,   589,   272,   273,   274,   275,   276,   277,   278,
   279,   280,   281,   282,   283,   284,   285,     0,     0,     0,
     0,   286,     0,   593,   272,   273,   274,   275,   276,   277,
   278,   279,   280,   281,   282,   283,   284,   285,     0,     0,
     0,     0,   286,     0,   595,   272,   273,   274,   275,   276,
   277,   278,   279,   280,   281,   282,   283,   284,   285,     0,
     0,     0,     0,   286,     0,   597,   272,   273,   274,   275,
   276,   277,   278,   279,   280,   281,   282,   283,   284,   285,
     0,     0,     0,     0,   286,     0,   599,   272,   273,   274,
   275,   276,   277,   278,   279,   280,   281,   282,   283,   284,
   285,     0,     0,     0,     0,   286,     0,   601,   272,   273,
   274,   275,   276,   277,   278,   279,   280,   281,   282,   283,
   284,   285,     0,     0,     0,     0,   286,     0,   603,   272,
   273,   274,   275,   276,   277,   278,   279,   280,   281,   282,
   283,   284,   285,     0,     0,     0,     0,   286,     0,   652,
   272,   273,   274,   275,   276,   277,   278,   279,   280,   281,
   282,   283,   284,   285,     0,     0,     0,     0,   286,     0,
   657,   272,   273,   274,   275,   276,   277,   278,   279,   280,
   281,   282,   283,   284,   285,     0,     0,     0,     0,   286,
     0,   665,   272,   273,   274,   275,   276,   277,   278,   279,
   280,   281,   282,   283,   284,   285,     0,     0,     0,     0,
   286,     0,   668,   272,   273,   274,   275,   276,   277,   278,
   279,   280,   281,   282,   283,   284,   285,     0,     0,     0,
     0,   286,     0,   669,   272,   273,   274,   275,   276,   277,
   278,   279,   280,   281,   282,   283,   284,   285,     0,     0,
     0,     0,   286,     0,   673,   272,   273,   274,   275,   276,
   277,   278,   279,   280,   281,   282,   283,   284,   285,     0,
     0,     0,     0,   286,     0,   843,   272,   273,   274,   275,
   276,   277,   278,   279,   280,   281,   282,   283,   284,   285,
     0,     0,     0,     0,   286,     0,   845,   272,   273,   274,
   275,   276,   277,   278,   279,   280,   281,   282,   283,   284,
   285,     0,     0,     0,     0,   286,     0,   847,   272,   273,
   274,   275,   276,   277,   278,   279,   280,   281,   282,   283,
   284,   285,     0,     0,     0,     0,   286,     0,   849,   272,
   273,   274,   275,   276,   277,   278,   279,   280,   281,   282,
   283,   284,   285,     0,     0,     0,     0,   286,     0,   855,
   272,   273,   274,   275,   276,   277,   278,   279,   280,   281,
   282,   283,   284,   285,     0,     0,     0,     0,   286,     0,
   943,   272,   273,   274,   275,   276,   277,   278,   279,   280,
   281,   282,   283,   284,   285,     0,     0,     0,     0,   286,
     0,   983,   272,   273,   274,   275,   276,   277,   278,   279,
   280,   281,   282,   283,   284,   285,     0,     0,     0,     0,
   286,     0,  1003,   272,   273,   274,   275,   276,   277,   278,
   279,   280,   281,   282,   283,   284,   285,     0,     0,     0,
     0,   286,     0,  1011,   272,   273,   274,   275,   276,   277,
   278,   279,   280,   281,   282,   283,   284,   285,     0,     0,
     0,     0,   286,     0,  1126,   272,   273,   274,   275,   276,
   277,   278,   279,   280,   281,   282,   283,   284,   285,     0,
     0,     0,     0,   286,     0,  1166,   272,   273,   274,   275,
   276,   277,   278,   279,   280,   281,   282,   283,   284,   285,
     0,     0,     0,     0,   286
};

static const short yycheck[] = {     4,
     2,   340,     2,   631,     7,   265,     4,     6,     4,     4,
     4,     4,     4,     4,     4,     4,    49,     4,   173,     7,
     6,   176,     5,     4,   179,     4,     6,     6,     4,    72,
    71,     6,     6,    76,    77,     6,    13,     6,     5,     4,
   131,   121,   122,     6,   199,    71,   201,   138,    53,    54,
   131,    71,     4,    36,    37,    38,    39,     6,   138,    42,
   121,   122,    43,   121,   122,    46,   121,   122,    49,    36,
    37,    38,    39,   131,     6,    42,     5,   138,     6,     7,
   138,    56,    56,   138,    80,    81,    82,    83,    84,   696,
    80,    81,    82,    83,    84,    49,   139,   138,   131,     7,
   121,   122,    91,    92,   131,   108,   133,    36,    37,    38,
    39,   131,   138,    42,   131,    91,    92,   138,   138,   131,
   108,   109,   110,   111,   131,   753,   138,    72,    53,   127,
   128,    76,    77,   119,   131,   133,   131,   135,    49,   138,
   121,   122,   140,   139,   138,   138,   138,   138,   119,   139,
   131,   138,   121,   122,   133,   138,    71,   138,   121,   122,
   112,   113,   114,    72,    49,   117,   118,    76,    77,   121,
   131,   138,   121,   122,   132,   127,   131,   437,   130,   137,
   132,   133,   134,   135,   132,   137,   138,   139,   140,   137,
   142,   143,   144,   131,   139,   147,   351,   131,   127,   128,
   108,   109,   110,   111,   138,   132,   135,    49,   700,   816,
   137,   163,   164,    51,   369,     7,   131,   121,   122,   127,
   128,   173,   138,   138,   127,   128,    46,   135,   138,    49,
   139,    51,   135,   137,   186,   187,   188,   865,   190,   121,
   122,   193,   194,   131,     7,   133,   132,   252,   253,   254,
   255,   137,   204,    43,   131,   137,    46,   139,   210,   211,
   212,   213,   214,   215,   216,   217,   218,   219,   220,   221,
   222,   223,   224,   225,   226,   227,   228,   229,   230,   231,
   232,   233,   234,   235,   236,   237,   238,   239,   240,   241,
   242,   243,   244,   245,   246,   247,   248,   249,   250,   251,
   265,   127,   128,    29,    30,   132,    32,   133,    72,   135,
   137,   263,    76,    77,   140,    49,   108,   109,   110,   111,
   272,   273,   274,   275,   276,   277,   278,   279,   280,   281,
   282,   283,   284,   285,   286,   127,   128,   339,   340,   339,
   340,   127,   128,   295,     8,   108,   109,   110,   111,   131,
    72,   133,   304,     6,    76,    77,     4,   309,   328,   329,
   330,   313,   314,     4,   127,   128,   318,   138,   320,   321,
   322,   142,   324,   325,   326,   327,   328,   329,   330,    72,
   123,   124,   125,    76,    77,   121,   122,   130,   121,   122,
   342,   343,   344,   345,   346,   347,   348,  1025,    72,     4,
   352,   137,    76,    77,   137,   357,   139,    72,   131,   361,
   362,    76,    77,     6,     7,   380,   133,   139,   131,   121,
   122,   138,   131,    72,   133,   142,   378,    76,    77,   381,
   131,   131,   133,   438,   160,   137,   162,   139,     6,  1046,
    72,   131,   168,   133,    76,    77,   139,   173,   112,   113,
   114,   115,   116,   117,   118,   119,   120,   121,   122,   123,
   124,   125,   131,    72,   133,   139,   130,    76,    77,   131,
   131,   133,   437,     4,   139,   139,     4,   131,  1085,   133,
   432,  1088,   208,     4,  1091,   745,   746,   439,    62,    63,
   139,     5,   263,   131,    72,   987,   131,    72,    76,    77,
    72,    76,    77,   131,    76,    77,   131,   139,   133,   131,
   462,   463,   131,   465,   466,     6,    72,   469,   470,   471,
    76,    77,    36,    37,    38,    39,     6,   131,    42,   133,
   139,     6,   484,   121,   122,   487,   488,   121,   122,  1146,
     5,   131,   494,   314,   127,   128,   263,   552,     4,   137,
   133,   131,   135,   137,   506,   507,  1048,   140,  1050,     6,
  1052,   139,  1169,   515,   139,  1172,   145,   139,  1175,   131,
   909,  1178,   151,    43,   121,   122,    46,   138,   295,    49,
   532,    51,   131,   139,     4,     5,   131,   552,   133,  1196,
   137,  1198,   544,  1200,   546,   547,   313,   314,   177,   121,
   122,   131,   181,   182,   121,   122,   138,   133,   121,   122,
   615,   337,   338,     8,   138,   137,    36,    37,    38,    39,
   137,   347,    42,   131,   137,   121,   122,   121,   122,   131,
  1122,   133,   637,   121,   122,   121,   122,   138,   131,   591,
   592,   137,   131,   137,   133,   135,   131,   802,   133,   137,
   131,   137,   133,   605,   606,   607,   608,   609,   610,   611,
   131,  1153,   614,  1155,   131,  1157,   618,   131,   131,   133,
   133,  1163,   624,   131,   131,   133,     6,   121,   122,   123,
   124,   125,   634,   131,   138,   133,   130,   137,   133,   139,
   642,   462,   131,  1185,   133,  1187,   137,  1189,   139,   137,
   133,   139,   135,   137,  1043,   139,   137,    49,   139,    51,
   138,   663,     8,   484,   137,   133,   139,   112,   113,   114,
   115,   116,   117,   118,   119,   120,   121,   122,   123,   124,
   125,    61,   137,   133,   139,   130,   138,   689,   690,   691,
   692,   137,    94,   139,   139,   462,    65,    66,    67,    68,
   137,    70,   139,   470,   471,   137,   137,   139,   139,    78,
    79,   137,   137,   139,   139,     6,   137,   484,   139,     6,
   487,   723,   724,     6,     4,   727,     6,   742,   137,   505,
   139,   746,   112,   113,   114,   115,   116,   117,   118,   119,
   120,   121,   122,   123,   124,   125,   137,   137,   139,   139,
   130,   527,   754,   137,   137,   139,   139,   133,     4,   137,
   762,   139,     5,   138,   766,   130,   112,   113,   114,   115,
   116,   117,   118,   119,   120,   121,   122,   123,   124,   125,
   135,     7,   784,   133,   130,   138,   132,     7,     7,   132,
     6,    91,     7,   614,     7,   137,   798,   799,   800,   138,
   132,   132,   857,   137,     6,   434,   435,     4,   134,   811,
   812,     7,    94,   815,   869,     7,     7,     7,   833,    94,
     7,   642,     7,    94,     7,     7,   828,   829,   830,     7,
   132,   132,   135,   132,   836,   132,     7,     7,     7,   841,
   135,   139,   663,   139,   138,   131,   131,   614,     6,     4,
   905,  1056,   131,     6,     6,     6,   858,   909,   134,   909,
     6,   133,     7,     6,   640,   119,     7,     7,   689,   690,
   691,   692,   874,    49,    51,   642,     7,   138,     7,   881,
   882,     7,     7,     7,   886,     7,     7,     7,     7,     7,
     7,     4,     6,   895,   896,   131,   663,   138,   138,     6,
     6,     6,     6,   905,     6,     6,     4,   536,   537,     6,
   686,   687,   688,     4,     6,   138,     6,   131,  1123,     7,
   132,   132,   689,   690,   691,   692,   135,     6,   138,     6,
   138,   138,     6,   138,     6,   937,   938,     6,     5,    12,
    13,   114,   115,   116,   117,   118,   119,   120,   121,   122,
   123,   124,   125,   955,   138,     6,     6,   130,    90,     6,
   135,     6,     4,     6,   966,     6,   134,     6,     5,     4,
    43,    44,    45,    46,    47,    48,    49,    50,    51,    52,
     6,    54,   984,    56,    57,     6,    59,    60,     6,     6,
     6,  1043,     6,  1043,     6,     6,     6,     6,     6,     6,
     6,     6,    75,  1005,     6,  1007,     6,  1009,   138,   137,
     6,  1013,     6,    86,    87,    88,  1018,     7,     6,   135,
     6,   650,   651,     5,   653,     6,   655,   656,     6,   138,
   659,   660,     6,    89,     7,     6,   139,     6,   138,   815,
    92,     6,   138,   138,   138,  1047,   132,  1049,     6,  1051,
     6,     6,     6,   138,     6,     5,  1058,   139,     6,   137,
    61,  1063,  1064,   138,     6,     6,   139,     6,     6,     6,
  1072,     6,     6,   139,     5,   138,   138,   138,  1080,   708,
   709,   710,     6,   112,   113,   114,   115,   116,   117,   118,
   119,   120,   121,   122,   123,   124,   125,     6,  1100,   137,
   876,   130,   878,     6,   138,   134,     6,     6,  1110,     6,
  1165,  1113,     5,   138,  1116,   138,   138,     6,  1120,   138,
     6,     6,     6,     6,   139,  1127,     6,  1129,     6,     6,
     6,     0,     0,   555,   761,   911,  1191,   913,  1193,   915,
     2,   770,     2,  1100,  1017,   861,    -1,   776,    -1,    -1,
     6,    -1,    -1,    -1,  1209,    -1,   785,   786,   787,    -1,
    -1,   790,   791,   792,   793,   794,   795,   796,   115,   116,
   117,   118,   119,   120,   121,   122,   123,   124,   125,     3,
     4,    -1,   811,   130,    -1,     9,    10,    11,    -1,    -1,
    14,    15,    16,    17,    18,    19,    20,    21,    22,    23,
    24,    25,    26,    27,    28,    29,    30,    31,    32,    33,
    34,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    43,
    -1,    -1,    -1,    -1,    -1,    -1,    -1,   856,    -1,    -1,
    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    -1,    65,    66,    67,    68,    69,    70,    -1,    -1,    -1,
    -1,    -1,    -1,    -1,    78,    79,   112,   113,   114,   115,
   116,   117,   118,   119,   120,   121,   122,   123,   124,   125,
    -1,  1047,    -1,  1049,   130,  1051,    -1,    -1,    -1,    -1,
   104,   105,   106,   107,    -1,    -1,   117,   118,   119,   120,
   121,   122,   123,   124,   125,    -1,    -1,   121,   122,   130,
   929,    -1,   126,    -1,    -1,    -1,    -1,   131,    -1,    -1,
   939,    -1,   136,    -1,   943,   139,     3,     4,    -1,    -1,
    -1,    -1,     9,    10,    11,    -1,    -1,    14,    15,    16,
    17,    18,    19,    20,    21,    22,    23,    24,    25,    26,
    27,    28,    29,    30,    31,    32,    33,    34,    -1,    -1,
    -1,    -1,    -1,    -1,    -1,    -1,    43,    -1,    -1,    -1,
    -1,    -1,    12,    13,    -1,    -1,    -1,    -1,    -1,    -1,
    -1,    -1,    -1,  1002,    -1,    -1,    -1,    -1,    65,    66,
    67,    68,    69,    70,    -1,    -1,    -1,    -1,    -1,    -1,
    -1,    78,    79,    43,    44,    45,    46,    47,    48,    49,
    50,    51,    52,    -1,    54,    -1,    56,    57,    -1,    59,
    60,    -1,    -1,    -1,    -1,    -1,    -1,   104,   105,   106,
   107,    -1,    -1,    -1,    -1,    75,  1055,    -1,    -1,    -1,
    -1,    -1,    -1,    -1,   121,   122,    86,    87,    88,   126,
    -1,    -1,    -1,    -1,   131,    -1,    -1,    -1,    -1,   136,
    -1,   138,    -1,     3,     4,    -1,    -1,    -1,    -1,     9,
    10,    11,    -1,  1092,    14,    15,    16,    17,    18,    19,
    20,    21,    22,    23,    24,    25,    26,    27,    28,    29,
    30,    31,    32,    33,    34,    -1,    -1,    -1,    -1,   139,
    -1,    -1,    -1,    43,    -1,    -1,    -1,    -1,    -1,    12,
    13,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    -1,    -1,    -1,    -1,    -1,    65,    66,    67,    68,    69,
    70,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    78,    79,
    43,    44,    45,    46,    47,    48,    49,    50,    51,    52,
    -1,    54,    -1,    56,    57,    -1,    59,    60,    -1,    -1,
    -1,    -1,    -1,    -1,   104,   105,   106,   107,     6,    -1,
    -1,    -1,    75,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    -1,   121,   122,    86,    87,    88,   126,    -1,    -1,    -1,
    -1,   131,    -1,     3,     4,    -1,   136,    -1,   138,     9,
    10,    11,    -1,    -1,    14,    15,    16,    17,    18,    19,
    20,    21,    22,    23,    24,    25,    26,    27,    28,    29,
    30,    31,    32,    33,    34,    -1,    -1,    -1,    -1,    -1,
    -1,    -1,    -1,    43,    -1,    -1,   139,    -1,    -1,    -1,
    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    -1,    -1,    -1,    -1,    -1,    65,    66,    67,    68,    69,
    70,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    78,    79,
    -1,    -1,    -1,    -1,   112,   113,   114,   115,   116,   117,
   118,   119,   120,   121,   122,   123,   124,   125,    -1,    -1,
    -1,    -1,   130,    -1,   104,   105,   106,   107,    -1,    -1,
    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    -1,   121,   122,    -1,    -1,    -1,   126,    -1,    -1,    -1,
    -1,   131,    -1,     3,     4,    -1,   136,    -1,   138,     9,
    10,    11,    -1,    -1,    14,    15,    16,    17,    18,    19,
    20,    21,    22,    23,    24,    25,    26,    27,    28,    29,
    30,    31,    32,    33,    34,    -1,    -1,    -1,     3,     4,
    12,    13,    -1,    -1,     9,    10,    11,    -1,    -1,    14,
    15,    16,    17,    18,    19,    20,    21,    22,    23,    24,
    25,    26,    27,    28,    29,    30,    31,    32,    33,    34,
    -1,    43,    44,    45,    46,    47,    48,    49,    50,    51,
    52,    -1,    54,    -1,    56,    57,    -1,    59,    60,    -1,
    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    -1,    -1,    -1,    75,   104,   105,   106,   107,    -1,    -1,
    -1,    -1,    -1,    -1,    86,    87,    88,    -1,    -1,    -1,
    -1,   121,   122,    -1,    -1,    -1,   126,    -1,    -1,    -1,
    -1,   131,    -1,    -1,   134,    -1,   136,    -1,   138,   104,
   105,   106,   107,     6,    -1,    -1,    -1,    -1,    -1,    -1,
    -1,    -1,    -1,    -1,    -1,    -1,   121,   122,    -1,    -1,
    -1,   126,    -1,    -1,    -1,    -1,   131,   139,    -1,   134,
    -1,   136,    -1,   138,     3,     4,    -1,    -1,    -1,    -1,
     9,    10,    11,    -1,    -1,    14,    15,    16,    17,    18,
    19,    20,    21,    22,    23,    24,    25,    26,    27,    28,
    29,    30,    31,    32,    33,    34,    -1,    -1,    -1,     3,
     4,     5,    -1,     7,    -1,     9,    10,    11,    -1,    -1,
    14,    15,    16,    17,    18,    19,    20,    21,    22,    23,
    24,    25,    26,    27,    28,    29,    30,    31,    32,    33,
    34,    -1,    36,    37,    38,    39,    -1,    -1,    42,   112,
   113,   114,   115,   116,   117,   118,   119,   120,   121,   122,
   123,   124,   125,    -1,    -1,    -1,    -1,   130,    -1,    -1,
    -1,    -1,    -1,    -1,    -1,   104,   105,   106,   107,     6,
    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    -1,    -1,   121,   122,    -1,    -1,    -1,   126,    -1,    -1,
    -1,    -1,   131,    -1,    -1,    -1,    -1,   136,    -1,   138,
   104,   105,   106,   107,   108,   109,   110,   111,     6,    -1,
    -1,    -1,    -1,    -1,    -1,    -1,    -1,   121,   122,    -1,
    -1,    -1,   126,   127,   128,    -1,    -1,   131,    -1,   133,
    -1,   135,   136,     3,     4,    -1,    -1,    -1,    -1,     9,
    10,    11,    -1,    -1,    14,    15,    16,    17,    18,    19,
    20,    21,    22,    23,    24,    25,    26,    27,    28,    29,
    30,    31,    32,    33,    34,    -1,    -1,    -1,    -1,    -1,
    -1,    -1,    -1,    43,    -1,   112,   113,   114,   115,   116,
   117,   118,   119,   120,   121,   122,   123,   124,   125,    -1,
    -1,    -1,    -1,   130,    -1,    65,    66,    67,    68,    69,
    70,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    78,    79,
    -1,    -1,    -1,    -1,   112,   113,   114,   115,   116,   117,
   118,   119,   120,   121,   122,   123,   124,   125,     6,    -1,
    -1,    -1,   130,    -1,   104,   105,   106,   107,    -1,    -1,
    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    -1,   121,   122,    -1,    -1,    -1,   126,     3,     4,     5,
    -1,   131,    -1,     9,    10,    11,   136,    -1,    14,    15,
    16,    17,    18,    19,    20,    21,    22,    23,    24,    25,
    26,    27,    28,    29,    30,    31,    32,    33,    34,    -1,
    36,    37,    38,    39,     3,     4,    42,    -1,    -1,    -1,
     9,    10,    11,    -1,    -1,    14,    15,    16,    17,    18,
    19,    20,    21,    22,    23,    24,    25,    26,    27,    28,
    29,    30,    31,    32,    33,    34,    -1,    -1,    -1,    -1,
    -1,    -1,    -1,    -1,   112,   113,   114,   115,   116,   117,
   118,   119,   120,   121,   122,   123,   124,   125,    -1,    -1,
    -1,    -1,   130,    -1,    -1,    -1,    -1,    -1,   104,   105,
   106,   107,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    -1,    -1,    -1,    -1,    -1,   121,   122,    -1,    -1,    -1,
   126,    -1,    -1,    -1,    -1,   131,    -1,    -1,    -1,    -1,
   136,    -1,    -1,    -1,    -1,   104,   105,   106,   107,    12,
    13,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    -1,    -1,   121,   122,    -1,    -1,    -1,   126,    -1,    12,
    13,    -1,   131,    -1,    -1,    -1,    -1,   136,    -1,    -1,
    43,    44,    45,    46,    47,    48,    49,    50,    51,    52,
    -1,    54,    -1,    56,    57,    -1,    59,    60,    -1,    -1,
    43,    44,    45,    46,    47,    48,    49,    50,    51,    52,
     6,    54,    75,    56,    57,    -1,    59,    60,    12,    13,
    -1,    -1,    -1,    86,    87,    88,    -1,    -1,    -1,    -1,
    -1,    -1,    75,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     6,    -1,    -1,    86,    87,    88,    -1,    -1,    -1,    43,
    44,    45,    46,    47,    48,    49,    50,    51,    52,     6,
    54,    -1,    56,    57,    -1,    59,    60,    12,    13,    -1,
    -1,    -1,    -1,    -1,    -1,    -1,   139,    -1,    -1,    -1,
    -1,    75,    -1,    -1,    -1,    -1,    -1,    -1,    -1,     6,
    -1,    -1,    86,    87,    88,    -1,   139,    -1,    43,    44,
    45,    46,    47,    48,    49,    50,    51,    52,     6,    54,
    -1,    56,    57,    -1,    59,    60,   112,   113,   114,   115,
   116,   117,   118,   119,   120,   121,   122,   123,   124,   125,
    75,     6,    -1,    -1,   130,    -1,    -1,    -1,    -1,    -1,
    -1,    86,    87,    88,    -1,   139,   112,   113,   114,   115,
   116,   117,   118,   119,   120,   121,   122,   123,   124,   125,
     6,    -1,    -1,    -1,   130,   112,   113,   114,   115,   116,
   117,   118,   119,   120,   121,   122,   123,   124,   125,    -1,
    -1,     8,    -1,   130,    -1,    -1,    -1,    -1,    -1,    -1,
    -1,    -1,    -1,    -1,   139,   112,   113,   114,   115,   116,
   117,   118,   119,   120,   121,   122,   123,   124,   125,     8,
    -1,    -1,    -1,   130,   112,   113,   114,   115,   116,   117,
   118,   119,   120,   121,   122,   123,   124,   125,     8,    -1,
    -1,    -1,   130,    -1,    -1,    -1,    -1,   112,   113,   114,
   115,   116,   117,   118,   119,   120,   121,   122,   123,   124,
   125,     8,    -1,    -1,    -1,   130,    -1,    -1,    -1,    -1,
    -1,    -1,    -1,    -1,    -1,    -1,   112,   113,   114,   115,
   116,   117,   118,   119,   120,   121,   122,   123,   124,   125,
     8,    -1,    -1,    -1,   130,   112,   113,   114,   115,   116,
   117,   118,   119,   120,   121,   122,   123,   124,   125,     8,
    -1,    -1,    -1,   130,    -1,    -1,    -1,    -1,    -1,    -1,
    -1,    -1,    -1,   112,   113,   114,   115,   116,   117,   118,
   119,   120,   121,   122,   123,   124,   125,    -1,    -1,    -1,
    -1,   130,   112,   113,   114,   115,   116,   117,   118,   119,
   120,   121,   122,   123,   124,   125,    -1,    -1,    -1,    -1,
   130,    -1,    -1,    -1,    -1,   112,   113,   114,   115,   116,
   117,   118,   119,   120,   121,   122,   123,   124,   125,    -1,
    -1,    -1,    -1,   130,    -1,    -1,    -1,    -1,    -1,    -1,
    -1,    -1,    -1,    -1,   112,   113,   114,   115,   116,   117,
   118,   119,   120,   121,   122,   123,   124,   125,    -1,    -1,
    -1,    -1,   130,   112,   113,   114,   115,   116,   117,   118,
   119,   120,   121,   122,   123,   124,   125,    -1,     0,     1,
    -1,   130,     4,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    12,    13,    -1,   112,   113,   114,   115,   116,   117,   118,
   119,   120,   121,   122,   123,   124,   125,    -1,    -1,    -1,
    -1,   130,    -1,    35,    -1,    -1,    -1,    -1,    40,    41,
   139,    43,    44,    45,    46,    47,    48,    49,    50,    51,
    52,    -1,    54,    55,    56,    57,    58,    59,    60,    -1,
    -1,    -1,    64,    65,    66,    67,    68,    69,    70,    -1,
    72,    73,    74,    75,    -1,    -1,    78,    79,    -1,     4,
    -1,    -1,    -1,    85,    86,    87,    88,    12,    13,    91,
    -1,    93,    -1,    95,    96,    97,    98,    99,   100,   101,
   102,   103,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    35,    -1,    -1,    -1,    -1,    40,    41,    -1,    43,    44,
    45,    46,    47,    48,    49,    50,    51,    52,    -1,    54,
    55,    56,    57,    58,    59,    60,    -1,    -1,    -1,    64,
    65,    66,    67,    68,    69,    70,    -1,    72,    73,    74,
    75,    12,    13,    78,    79,    -1,    -1,    -1,    -1,    -1,
    85,    86,    87,    88,    -1,    -1,    91,    -1,    93,    -1,
    95,    96,    97,    98,    99,   100,   101,   102,   103,    -1,
    -1,    -1,    43,    44,    45,    46,    47,    48,    49,    50,
    51,    52,    -1,    54,    -1,    56,    57,    -1,    59,    60,
   112,   113,   114,   115,   116,   117,   118,   119,   120,   121,
   122,   123,   124,   125,    75,    -1,    -1,    -1,   130,    -1,
    -1,    -1,   134,    -1,    -1,    86,    87,    88,   112,   113,
   114,   115,   116,   117,   118,   119,   120,   121,   122,   123,
   124,   125,    -1,    -1,    -1,    -1,   130,    -1,    -1,    -1,
    -1,    -1,    -1,   137,    -1,   139,   112,   113,   114,   115,
   116,   117,   118,   119,   120,   121,   122,   123,   124,   125,
    -1,    -1,    -1,    -1,   130,    -1,    -1,    -1,    -1,    -1,
    -1,   137,    -1,   139,   112,   113,   114,   115,   116,   117,
   118,   119,   120,   121,   122,   123,   124,   125,    -1,    -1,
    -1,    -1,   130,    -1,    -1,    -1,    -1,    -1,    -1,   137,
    -1,   139,   112,   113,   114,   115,   116,   117,   118,   119,
   120,   121,   122,   123,   124,   125,    -1,    -1,    -1,    -1,
   130,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   139,
   112,   113,   114,   115,   116,   117,   118,   119,   120,   121,
   122,   123,   124,   125,    -1,    -1,    -1,    -1,   130,    -1,
    -1,    -1,    -1,    -1,    -1,    -1,    -1,   139,   112,   113,
   114,   115,   116,   117,   118,   119,   120,   121,   122,   123,
   124,   125,    -1,    -1,    -1,    -1,   130,    -1,    -1,    -1,
    -1,    -1,    -1,    -1,    -1,   139,   112,   113,   114,   115,
   116,   117,   118,   119,   120,   121,   122,   123,   124,   125,
    -1,    -1,    -1,    -1,   130,    -1,    -1,    -1,    -1,    -1,
    -1,    -1,    -1,   139,   112,   113,   114,   115,   116,   117,
   118,   119,   120,   121,   122,   123,   124,   125,    -1,    -1,
    -1,    -1,   130,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    -1,   139,   112,   113,   114,   115,   116,   117,   118,   119,
   120,   121,   122,   123,   124,   125,    -1,    -1,    -1,    -1,
   130,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   139,
   112,   113,   114,   115,   116,   117,   118,   119,   120,   121,
   122,   123,   124,   125,    -1,    -1,    -1,    -1,   130,    -1,
    -1,    -1,    -1,    -1,    -1,    -1,    -1,   139,   112,   113,
   114,   115,   116,   117,   118,   119,   120,   121,   122,   123,
   124,   125,    -1,    -1,    -1,    -1,   130,    -1,    -1,    -1,
    -1,    -1,    -1,    -1,    -1,   139,   112,   113,   114,   115,
   116,   117,   118,   119,   120,   121,   122,   123,   124,   125,
    -1,    -1,    -1,    -1,   130,    -1,    -1,    -1,    -1,    -1,
    -1,    -1,    -1,   139,   112,   113,   114,   115,   116,   117,
   118,   119,   120,   121,   122,   123,   124,   125,    -1,    -1,
    -1,    -1,   130,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    -1,   139,   112,   113,   114,   115,   116,   117,   118,   119,
   120,   121,   122,   123,   124,   125,    -1,    -1,    -1,    -1,
   130,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   139,
   112,   113,   114,   115,   116,   117,   118,   119,   120,   121,
   122,   123,   124,   125,    -1,    -1,    -1,    -1,   130,    -1,
    -1,    -1,    -1,    -1,    -1,    -1,    -1,   139,   112,   113,
   114,   115,   116,   117,   118,   119,   120,   121,   122,   123,
   124,   125,    -1,    -1,    -1,    -1,   130,    -1,    -1,    -1,
    -1,    -1,    -1,    -1,    -1,   139,   112,   113,   114,   115,
   116,   117,   118,   119,   120,   121,   122,   123,   124,   125,
    -1,    -1,    -1,    -1,   130,    -1,    -1,    -1,    -1,    -1,
    -1,    -1,    -1,   139,   112,   113,   114,   115,   116,   117,
   118,   119,   120,   121,   122,   123,   124,   125,    -1,    -1,
    -1,    -1,   130,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    -1,   139,   112,   113,   114,   115,   116,   117,   118,   119,
   120,   121,   122,   123,   124,   125,    -1,    -1,    -1,    -1,
   130,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   139,
   112,   113,   114,   115,   116,   117,   118,   119,   120,   121,
   122,   123,   124,   125,    -1,    -1,    -1,    -1,   130,    -1,
    -1,    -1,    -1,    -1,    -1,    -1,    -1,   139,   112,   113,
   114,   115,   116,   117,   118,   119,   120,   121,   122,   123,
   124,   125,    -1,    -1,    -1,    -1,   130,    -1,    -1,    -1,
    -1,    -1,    -1,    -1,    -1,   139,   112,   113,   114,   115,
   116,   117,   118,   119,   120,   121,   122,   123,   124,   125,
    -1,    -1,    -1,    -1,   130,    -1,    -1,    -1,    -1,    -1,
    -1,    -1,    -1,   139,   112,   113,   114,   115,   116,   117,
   118,   119,   120,   121,   122,   123,   124,   125,    -1,    -1,
    -1,    -1,   130,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    -1,   139,   112,   113,   114,   115,   116,   117,   118,   119,
   120,   121,   122,   123,   124,   125,    -1,    -1,    -1,    -1,
   130,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   139,
   112,   113,   114,   115,   116,   117,   118,   119,   120,   121,
   122,   123,   124,   125,    -1,    -1,    -1,    -1,   130,    -1,
    -1,    -1,    -1,    -1,    -1,    -1,    -1,   139,   112,   113,
   114,   115,   116,   117,   118,   119,   120,   121,   122,   123,
   124,   125,    -1,    -1,    -1,    -1,   130,    -1,   132,    -1,
    -1,    -1,    -1,   137,   112,   113,   114,   115,   116,   117,
   118,   119,   120,   121,   122,   123,   124,   125,    -1,    -1,
    -1,    -1,   130,    -1,    -1,    -1,    -1,    -1,    -1,   137,
   112,   113,   114,   115,   116,   117,   118,   119,   120,   121,
   122,   123,   124,   125,    -1,    -1,    -1,    -1,   130,    -1,
    -1,    -1,    -1,    -1,    -1,   137,   112,   113,   114,   115,
   116,   117,   118,   119,   120,   121,   122,   123,   124,   125,
    -1,    -1,    -1,    -1,   130,    -1,    -1,    -1,    -1,    -1,
    -1,   137,   112,   113,   114,   115,   116,   117,   118,   119,
   120,   121,   122,   123,   124,   125,    -1,    -1,    -1,    -1,
   130,    -1,    -1,    -1,    -1,    -1,    -1,   137,   112,   113,
   114,   115,   116,   117,   118,   119,   120,   121,   122,   123,
   124,   125,    -1,    -1,    -1,    -1,   130,    -1,    -1,    -1,
    -1,    -1,    -1,   137,   112,   113,   114,   115,   116,   117,
   118,   119,   120,   121,   122,   123,   124,   125,    -1,    -1,
    -1,    -1,   130,    -1,    -1,    -1,    -1,    -1,    -1,   137,
   112,   113,   114,   115,   116,   117,   118,   119,   120,   121,
   122,   123,   124,   125,    -1,    -1,    -1,    -1,   130,    -1,
    -1,    -1,    -1,    -1,    -1,   137,   112,   113,   114,   115,
   116,   117,   118,   119,   120,   121,   122,   123,   124,   125,
    -1,    -1,    -1,    -1,   130,    -1,    -1,    -1,    -1,    -1,
    -1,   137,   112,   113,   114,   115,   116,   117,   118,   119,
   120,   121,   122,   123,   124,   125,    -1,    -1,    -1,    -1,
   130,    -1,    -1,    -1,    -1,    -1,    -1,   137,   112,   113,
   114,   115,   116,   117,   118,   119,   120,   121,   122,   123,
   124,   125,    -1,    -1,    -1,    -1,   130,    -1,    -1,    -1,
    -1,    -1,    -1,   137,   112,   113,   114,   115,   116,   117,
   118,   119,   120,   121,   122,   123,   124,   125,    -1,    -1,
    -1,    -1,   130,    -1,    -1,    -1,    -1,    -1,    -1,   137,
   112,   113,   114,   115,   116,   117,   118,   119,   120,   121,
   122,   123,   124,   125,    -1,    -1,    -1,    -1,   130,    -1,
    -1,    -1,    -1,    -1,    -1,   137,   112,   113,   114,   115,
   116,   117,   118,   119,   120,   121,   122,   123,   124,   125,
    -1,    -1,    -1,    -1,   130,    -1,    -1,    -1,    -1,    -1,
    -1,   137,   112,   113,   114,   115,   116,   117,   118,   119,
   120,   121,   122,   123,   124,   125,    -1,    -1,    -1,    -1,
   130,    -1,    -1,    -1,    -1,    -1,    -1,   137,   112,   113,
   114,   115,   116,   117,   118,   119,   120,   121,   122,   123,
   124,   125,    -1,    -1,    -1,    -1,   130,    -1,    -1,    -1,
    -1,    -1,    -1,   137,   112,   113,   114,   115,   116,   117,
   118,   119,   120,   121,   122,   123,   124,   125,    -1,    -1,
    -1,    -1,   130,    -1,    -1,    -1,    -1,    -1,    -1,   137,
   112,   113,   114,   115,   116,   117,   118,   119,   120,   121,
   122,   123,   124,   125,    -1,    -1,    -1,    -1,   130,    -1,
    -1,    -1,    -1,    -1,    -1,   137,   112,   113,   114,   115,
   116,   117,   118,   119,   120,   121,   122,   123,   124,   125,
    -1,    -1,    -1,    -1,   130,    -1,    -1,    -1,    -1,    -1,
    -1,   137,   112,   113,   114,   115,   116,   117,   118,   119,
   120,   121,   122,   123,   124,   125,    -1,    -1,    -1,    -1,
   130,    -1,    -1,    -1,    -1,    -1,    -1,   137,   112,   113,
   114,   115,   116,   117,   118,   119,   120,   121,   122,   123,
   124,   125,    -1,    -1,    -1,    -1,   130,    -1,    -1,    -1,
    -1,    -1,    -1,   137,   112,   113,   114,   115,   116,   117,
   118,   119,   120,   121,   122,   123,   124,   125,    -1,    -1,
    -1,    -1,   130,    -1,    -1,    -1,    -1,    -1,    -1,   137,
   112,   113,   114,   115,   116,   117,   118,   119,   120,   121,
   122,   123,   124,   125,    -1,    -1,    -1,    -1,   130,    -1,
    -1,    -1,    -1,    -1,    -1,   137,   112,   113,   114,   115,
   116,   117,   118,   119,   120,   121,   122,   123,   124,   125,
    -1,    -1,    -1,    -1,   130,    -1,    -1,    -1,    -1,    -1,
    -1,   137,   112,   113,   114,   115,   116,   117,   118,   119,
   120,   121,   122,   123,   124,   125,    -1,    -1,    -1,    -1,
   130,    -1,    -1,    -1,    -1,    -1,    -1,   137,   112,   113,
   114,   115,   116,   117,   118,   119,   120,   121,   122,   123,
   124,   125,    -1,    -1,    -1,    -1,   130,    -1,    -1,    -1,
    -1,    -1,    -1,   137,   112,   113,   114,   115,   116,   117,
   118,   119,   120,   121,   122,   123,   124,   125,    -1,    -1,
    -1,    -1,   130,    -1,    -1,    -1,    -1,    -1,    -1,   137,
   112,   113,   114,   115,   116,   117,   118,   119,   120,   121,
   122,   123,   124,   125,    -1,    -1,    -1,    -1,   130,    -1,
    -1,    -1,    -1,    -1,    -1,   137,   112,   113,   114,   115,
   116,   117,   118,   119,   120,   121,   122,   123,   124,   125,
    -1,    -1,    -1,    -1,   130,    -1,    -1,    -1,    -1,    -1,
    -1,   137,   112,   113,   114,   115,   116,   117,   118,   119,
   120,   121,   122,   123,   124,   125,    -1,    -1,    -1,    -1,
   130,    -1,    -1,    -1,    -1,    -1,    -1,   137,   112,   113,
   114,   115,   116,   117,   118,   119,   120,   121,   122,   123,
   124,   125,    -1,    -1,    -1,    -1,   130,    -1,    -1,    -1,
   134,   112,   113,   114,   115,   116,   117,   118,   119,   120,
   121,   122,   123,   124,   125,    -1,    -1,    -1,    -1,   130,
    -1,    -1,    -1,   134,   112,   113,   114,   115,   116,   117,
   118,   119,   120,   121,   122,   123,   124,   125,    -1,    -1,
    -1,    -1,   130,    -1,    -1,    -1,   134,   112,   113,   114,
   115,   116,   117,   118,   119,   120,   121,   122,   123,   124,
   125,    -1,    -1,    -1,    -1,   130,    -1,    -1,    -1,   134,
   112,   113,   114,   115,   116,   117,   118,   119,   120,   121,
   122,   123,   124,   125,    -1,    -1,    -1,    -1,   130,    -1,
    -1,    -1,   134,   112,   113,   114,   115,   116,   117,   118,
   119,   120,   121,   122,   123,   124,   125,    -1,    -1,    -1,
    -1,   130,    -1,    -1,    -1,   134,   112,   113,   114,   115,
   116,   117,   118,   119,   120,   121,   122,   123,   124,   125,
    -1,    -1,    -1,    -1,   130,    -1,    -1,    -1,   134,   112,
   113,   114,   115,   116,   117,   118,   119,   120,   121,   122,
   123,   124,   125,    -1,    -1,    -1,    -1,   130,    -1,    -1,
    -1,   134,   112,   113,   114,   115,   116,   117,   118,   119,
   120,   121,   122,   123,   124,   125,    -1,    -1,    -1,    -1,
   130,    -1,    -1,    -1,   134,   112,   113,   114,   115,   116,
   117,   118,   119,   120,   121,   122,   123,   124,   125,    -1,
    -1,    -1,    -1,   130,    -1,    -1,    -1,   134,   112,   113,
   114,   115,   116,   117,   118,   119,   120,   121,   122,   123,
   124,   125,    -1,    -1,    -1,    -1,   130,    -1,    -1,    -1,
   134,   112,   113,   114,   115,   116,   117,   118,   119,   120,
   121,   122,   123,   124,   125,    -1,    -1,    -1,    -1,   130,
    -1,    -1,    -1,   134,   112,   113,   114,   115,   116,   117,
   118,   119,   120,   121,   122,   123,   124,   125,    -1,    -1,
    -1,    -1,   130,    -1,    -1,    -1,   134,   112,   113,   114,
   115,   116,   117,   118,   119,   120,   121,   122,   123,   124,
   125,    -1,    -1,    -1,    -1,   130,    -1,    -1,    -1,   134,
   112,   113,   114,   115,   116,   117,   118,   119,   120,   121,
   122,   123,   124,   125,    -1,    -1,    -1,    -1,   130,    -1,
    -1,    -1,   134,   112,   113,   114,   115,   116,   117,   118,
   119,   120,   121,   122,   123,   124,   125,    -1,    -1,    -1,
    -1,   130,    -1,    -1,    -1,   134,   112,   113,   114,   115,
   116,   117,   118,   119,   120,   121,   122,   123,   124,   125,
    -1,    -1,    -1,    -1,   130,    -1,    -1,    -1,   134,   112,
   113,   114,   115,   116,   117,   118,   119,   120,   121,   122,
   123,   124,   125,    -1,    -1,    -1,    -1,   130,    -1,    -1,
    -1,   134,   112,   113,   114,   115,   116,   117,   118,   119,
   120,   121,   122,   123,   124,   125,    -1,    -1,    -1,    -1,
   130,    -1,    -1,    -1,   134,   112,   113,   114,   115,   116,
   117,   118,   119,   120,   121,   122,   123,   124,   125,    -1,
    -1,    -1,    -1,   130,    -1,    -1,    -1,   134,   112,   113,
   114,   115,   116,   117,   118,   119,   120,   121,   122,   123,
   124,   125,    -1,    -1,    -1,    -1,   130,    -1,    -1,    -1,
   134,   112,   113,   114,   115,   116,   117,   118,   119,   120,
   121,   122,   123,   124,   125,    -1,    -1,    -1,    -1,   130,
    -1,    -1,    -1,   134,   112,   113,   114,   115,   116,   117,
   118,   119,   120,   121,   122,   123,   124,   125,    -1,    -1,
    -1,    -1,   130,    -1,    -1,    -1,   134,   112,   113,   114,
   115,   116,   117,   118,   119,   120,   121,   122,   123,   124,
   125,    -1,    -1,    -1,    -1,   130,    -1,    -1,    -1,   134,
   112,   113,   114,   115,   116,   117,   118,   119,   120,   121,
   122,   123,   124,   125,    -1,    -1,    -1,    -1,   130,    -1,
    -1,    -1,   134,   112,   113,   114,   115,   116,   117,   118,
   119,   120,   121,   122,   123,   124,   125,    -1,    -1,    -1,
    -1,   130,    -1,    -1,    -1,   134,   112,   113,   114,   115,
   116,   117,   118,   119,   120,   121,   122,   123,   124,   125,
    -1,    -1,    -1,    -1,   130,    -1,    -1,    -1,   134,   112,
   113,   114,   115,   116,   117,   118,   119,   120,   121,   122,
   123,   124,   125,    -1,    -1,    -1,    -1,   130,    -1,    -1,
    -1,   134,   112,   113,   114,   115,   116,   117,   118,   119,
   120,   121,   122,   123,   124,   125,    -1,    -1,    -1,    -1,
   130,    -1,    -1,    -1,   134,   112,   113,   114,   115,   116,
   117,   118,   119,   120,   121,   122,   123,   124,   125,    -1,
    -1,    -1,    -1,   130,    -1,    -1,    -1,   134,   112,   113,
   114,   115,   116,   117,   118,   119,   120,   121,   122,   123,
   124,   125,    -1,    -1,    -1,    -1,   130,    -1,   132,   112,
   113,   114,   115,   116,   117,   118,   119,   120,   121,   122,
   123,   124,   125,    -1,    -1,    -1,    -1,   130,    -1,   132,
   112,   113,   114,   115,   116,   117,   118,   119,   120,   121,
   122,   123,   124,   125,    -1,    -1,    -1,    -1,   130,    -1,
   132,   112,   113,   114,   115,   116,   117,   118,   119,   120,
   121,   122,   123,   124,   125,    -1,    -1,    -1,    -1,   130,
    -1,   132,   112,   113,   114,   115,   116,   117,   118,   119,
   120,   121,   122,   123,   124,   125,    -1,    -1,    -1,    -1,
   130,    -1,   132,   112,   113,   114,   115,   116,   117,   118,
   119,   120,   121,   122,   123,   124,   125,    -1,    -1,    -1,
    -1,   130,    -1,   132,   112,   113,   114,   115,   116,   117,
   118,   119,   120,   121,   122,   123,   124,   125,    -1,    -1,
    -1,    -1,   130,    -1,   132,   112,   113,   114,   115,   116,
   117,   118,   119,   120,   121,   122,   123,   124,   125,    -1,
    -1,    -1,    -1,   130,    -1,   132,   112,   113,   114,   115,
   116,   117,   118,   119,   120,   121,   122,   123,   124,   125,
    -1,    -1,    -1,    -1,   130,    -1,   132,   112,   113,   114,
   115,   116,   117,   118,   119,   120,   121,   122,   123,   124,
   125,    -1,    -1,    -1,    -1,   130,    -1,   132,   112,   113,
   114,   115,   116,   117,   118,   119,   120,   121,   122,   123,
   124,   125,    -1,    -1,    -1,    -1,   130,    -1,   132,   112,
   113,   114,   115,   116,   117,   118,   119,   120,   121,   122,
   123,   124,   125,    -1,    -1,    -1,    -1,   130,    -1,   132,
   112,   113,   114,   115,   116,   117,   118,   119,   120,   121,
   122,   123,   124,   125,    -1,    -1,    -1,    -1,   130,    -1,
   132,   112,   113,   114,   115,   116,   117,   118,   119,   120,
   121,   122,   123,   124,   125,    -1,    -1,    -1,    -1,   130,
    -1,   132,   112,   113,   114,   115,   116,   117,   118,   119,
   120,   121,   122,   123,   124,   125,    -1,    -1,    -1,    -1,
   130,    -1,   132,   112,   113,   114,   115,   116,   117,   118,
   119,   120,   121,   122,   123,   124,   125,    -1,    -1,    -1,
    -1,   130,    -1,   132,   112,   113,   114,   115,   116,   117,
   118,   119,   120,   121,   122,   123,   124,   125,    -1,    -1,
    -1,    -1,   130,    -1,   132,   112,   113,   114,   115,   116,
   117,   118,   119,   120,   121,   122,   123,   124,   125,    -1,
    -1,    -1,    -1,   130,    -1,   132,   112,   113,   114,   115,
   116,   117,   118,   119,   120,   121,   122,   123,   124,   125,
    -1,    -1,    -1,    -1,   130,    -1,   132,   112,   113,   114,
   115,   116,   117,   118,   119,   120,   121,   122,   123,   124,
   125,    -1,    -1,    -1,    -1,   130,    -1,   132,   112,   113,
   114,   115,   116,   117,   118,   119,   120,   121,   122,   123,
   124,   125,    -1,    -1,    -1,    -1,   130,    -1,   132,   112,
   113,   114,   115,   116,   117,   118,   119,   120,   121,   122,
   123,   124,   125,    -1,    -1,    -1,    -1,   130,    -1,   132,
   112,   113,   114,   115,   116,   117,   118,   119,   120,   121,
   122,   123,   124,   125,    -1,    -1,    -1,    -1,   130,    -1,
   132,   112,   113,   114,   115,   116,   117,   118,   119,   120,
   121,   122,   123,   124,   125,    -1,    -1,    -1,    -1,   130,
    -1,   132,   112,   113,   114,   115,   116,   117,   118,   119,
   120,   121,   122,   123,   124,   125,    -1,    -1,    -1,    -1,
   130,    -1,   132,   112,   113,   114,   115,   116,   117,   118,
   119,   120,   121,   122,   123,   124,   125,    -1,    -1,    -1,
    -1,   130,    -1,   132,   112,   113,   114,   115,   116,   117,
   118,   119,   120,   121,   122,   123,   124,   125,    -1,    -1,
    -1,    -1,   130,    -1,   132,   112,   113,   114,   115,   116,
   117,   118,   119,   120,   121,   122,   123,   124,   125,    -1,
    -1,    -1,    -1,   130,    -1,   132,   112,   113,   114,   115,
   116,   117,   118,   119,   120,   121,   122,   123,   124,   125,
    -1,    -1,    -1,    -1,   130,    -1,   132,   112,   113,   114,
   115,   116,   117,   118,   119,   120,   121,   122,   123,   124,
   125,    -1,    -1,    -1,    -1,   130,    -1,   132,   112,   113,
   114,   115,   116,   117,   118,   119,   120,   121,   122,   123,
   124,   125,    -1,    -1,    -1,    -1,   130,    -1,   132,   112,
   113,   114,   115,   116,   117,   118,   119,   120,   121,   122,
   123,   124,   125,    -1,    -1,    -1,    -1,   130,    -1,   132,
   112,   113,   114,   115,   116,   117,   118,   119,   120,   121,
   122,   123,   124,   125,    -1,    -1,    -1,    -1,   130,    -1,
   132,   112,   113,   114,   115,   116,   117,   118,   119,   120,
   121,   122,   123,   124,   125,    -1,    -1,    -1,    -1,   130,
    -1,   132,   112,   113,   114,   115,   116,   117,   118,   119,
   120,   121,   122,   123,   124,   125,    -1,    -1,    -1,    -1,
   130,    -1,   132,   112,   113,   114,   115,   116,   117,   118,
   119,   120,   121,   122,   123,   124,   125,    -1,    -1,    -1,
    -1,   130,    -1,   132,   112,   113,   114,   115,   116,   117,
   118,   119,   120,   121,   122,   123,   124,   125,    -1,    -1,
    -1,    -1,   130,    -1,   132,   112,   113,   114,   115,   116,
   117,   118,   119,   120,   121,   122,   123,   124,   125,    -1,
    -1,    -1,    -1,   130,    -1,   132,   112,   113,   114,   115,
   116,   117,   118,   119,   120,   121,   122,   123,   124,   125,
    -1,    -1,    -1,    -1,   130,    -1,   132,   112,   113,   114,
   115,   116,   117,   118,   119,   120,   121,   122,   123,   124,
   125,    -1,    -1,    -1,    -1,   130,    -1,   132,   112,   113,
   114,   115,   116,   117,   118,   119,   120,   121,   122,   123,
   124,   125,    -1,    -1,    -1,    -1,   130,    -1,   132,   112,
   113,   114,   115,   116,   117,   118,   119,   120,   121,   122,
   123,   124,   125,    -1,    -1,    -1,    -1,   130,    -1,   132,
   112,   113,   114,   115,   116,   117,   118,   119,   120,   121,
   122,   123,   124,   125,    -1,    -1,    -1,    -1,   130,    -1,
   132,   112,   113,   114,   115,   116,   117,   118,   119,   120,
   121,   122,   123,   124,   125,    -1,    -1,    -1,    -1,   130,
    -1,   132,   112,   113,   114,   115,   116,   117,   118,   119,
   120,   121,   122,   123,   124,   125,    -1,    -1,    -1,    -1,
   130,    -1,   132,   112,   113,   114,   115,   116,   117,   118,
   119,   120,   121,   122,   123,   124,   125,    -1,    -1,    -1,
    -1,   130,    -1,   132,   112,   113,   114,   115,   116,   117,
   118,   119,   120,   121,   122,   123,   124,   125,    -1,    -1,
    -1,    -1,   130,    -1,   132,   112,   113,   114,   115,   116,
   117,   118,   119,   120,   121,   122,   123,   124,   125,    -1,
    -1,    -1,    -1,   130,    -1,   132,   112,   113,   114,   115,
   116,   117,   118,   119,   120,   121,   122,   123,   124,   125,
    -1,    -1,    -1,    -1,   130
};
/* -*-C-*-  Note some compilers choke on comments on `#line' lines.  */
#line 3 "/usr/share/bison.simple"
/* This file comes from bison-1.28.  */

/* Skeleton output parser for bison,
   Copyright (C) 1984, 1989, 1990 Free Software Foundation, Inc.

   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2, or (at your option)
   any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 59 Temple Place - Suite 330,
   Boston, MA 02111-1307, USA.  */

/* As a special exception, when this file is copied by Bison into a
   Bison output file, you may use that output file without restriction.
   This special exception was added by the Free Software Foundation
   in version 1.24 of Bison.  */

/* This is the parser code that is written into each bison parser
  when the %semantic_parser declaration is not specified in the grammar.
  It was written by Richard Stallman by simplifying the hairy parser
  used when %semantic_parser is specified.  */

#ifndef YYSTACK_USE_ALLOCA
#ifdef alloca
#define YYSTACK_USE_ALLOCA
#else /* alloca not defined */
#ifdef __GNUC__
#define YYSTACK_USE_ALLOCA
#define alloca __builtin_alloca
#else /* not GNU C.  */
#if (!defined (__STDC__) && defined (sparc)) || defined (__sparc__) || defined (__sparc) || defined (__sgi) || (defined (__sun) && defined (__i386))
#define YYSTACK_USE_ALLOCA
#include <alloca.h>
#else /* not sparc */
/* We think this test detects Watcom and Microsoft C.  */
/* This used to test MSDOS, but that is a bad idea
   since that symbol is in the user namespace.  */
#if (defined (_MSDOS) || defined (_MSDOS_)) && !defined (__TURBOC__)
#if 0 /* No need for malloc.h, which pollutes the namespace;
	 instead, just don't use alloca.  */
#include <malloc.h>
#endif
#else /* not MSDOS, or __TURBOC__ */
#if defined(_AIX)
/* I don't know what this was needed for, but it pollutes the namespace.
   So I turned it off.   rms, 2 May 1997.  */
/* #include <malloc.h>  */
 #pragma alloca
#define YYSTACK_USE_ALLOCA
#else /* not MSDOS, or __TURBOC__, or _AIX */
#if 0
#ifdef __hpux /* haible@ilog.fr says this works for HPUX 9.05 and up,
		 and on HPUX 10.  Eventually we can turn this on.  */
#define YYSTACK_USE_ALLOCA
#define alloca __builtin_alloca
#endif /* __hpux */
#endif
#endif /* not _AIX */
#endif /* not MSDOS, or __TURBOC__ */
#endif /* not sparc */
#endif /* not GNU C */
#endif /* alloca not defined */
#endif /* YYSTACK_USE_ALLOCA not defined */

#ifdef YYSTACK_USE_ALLOCA
#define YYSTACK_ALLOC alloca
#else
#define YYSTACK_ALLOC malloc
#endif

/* Note: there must be only one dollar sign in this file.
   It is replaced by the list of actions, each action
   as one case of the switch.  */

#define yyerrok		(yyerrstatus = 0)
#define yyclearin	(yychar = YYEMPTY)
#define YYEMPTY		-2
#define YYEOF		0
#define YYACCEPT	goto yyacceptlab
#define YYABORT 	goto yyabortlab
#define YYERROR		goto yyerrlab1
/* Like YYERROR except do call yyerror.
   This remains here temporarily to ease the
   transition to the new meaning of YYERROR, for GCC.
   Once GCC version 2 has supplanted version 1, this can go.  */
#define YYFAIL		goto yyerrlab
#define YYRECOVERING()  (!!yyerrstatus)
#define YYBACKUP(token, value) \
do								\
  if (yychar == YYEMPTY && yylen == 1)				\
    { yychar = (token), yylval = (value);			\
      yychar1 = YYTRANSLATE (yychar);				\
      YYPOPSTACK;						\
      goto yybackup;						\
    }								\
  else								\
    { yyerror ("syntax error: cannot back up"); YYERROR; }	\
while (0)

#define YYTERROR	1
#define YYERRCODE	256

#ifndef YYPURE
#define YYLEX		yylex()
#endif

#ifdef YYPURE
#ifdef YYLSP_NEEDED
#ifdef YYLEX_PARAM
#define YYLEX		yylex(&yylval, &yylloc, YYLEX_PARAM)
#else
#define YYLEX		yylex(&yylval, &yylloc)
#endif
#else /* not YYLSP_NEEDED */
#ifdef YYLEX_PARAM
#define YYLEX		yylex(&yylval, YYLEX_PARAM)
#else
#define YYLEX		yylex(&yylval)
#endif
#endif /* not YYLSP_NEEDED */
#endif

/* If nonreentrant, generate the variables here */

#ifndef YYPURE

int	yychar;			/*  the lookahead symbol		*/
YYSTYPE	yylval;			/*  the semantic value of the		*/
				/*  lookahead symbol			*/

#ifdef YYLSP_NEEDED
YYLTYPE yylloc;			/*  location data for the lookahead	*/
				/*  symbol				*/
#endif

int yynerrs;			/*  number of parse errors so far       */
#endif  /* not YYPURE */

#if YYDEBUG != 0
int yydebug;			/*  nonzero means print parse trace	*/
/* Since this is uninitialized, it does not stop multiple parsers
   from coexisting.  */
#endif

/*  YYINITDEPTH indicates the initial size of the parser's stacks	*/

#ifndef	YYINITDEPTH
#define YYINITDEPTH 200
#endif

/*  YYMAXDEPTH is the maximum size the stacks can grow to
    (effective only if the built-in stack extension method is used).  */

#if YYMAXDEPTH == 0
#undef YYMAXDEPTH
#endif

#ifndef YYMAXDEPTH
#define YYMAXDEPTH 10000
#endif

/* Define __yy_memcpy.  Note that the size argument
   should be passed with type unsigned int, because that is what the non-GCC
   definitions require.  With GCC, __builtin_memcpy takes an arg
   of type size_t, but it can handle unsigned int.  */

#if __GNUC__ > 1		/* GNU C and GNU C++ define this.  */
#define __yy_memcpy(TO,FROM,COUNT)	__builtin_memcpy(TO,FROM,COUNT)
#else				/* not GNU C or C++ */
#ifndef __cplusplus

/* This is the most reliable way to avoid incompatibilities
   in available built-in functions on various systems.  */
static void
__yy_memcpy (to, from, count)
     char *to;
     char *from;
     unsigned int count;
{
  register char *f = from;
  register char *t = to;
  register int i = count;

  while (i-- > 0)
    *t++ = *f++;
}

#else /* __cplusplus */

/* This is the most reliable way to avoid incompatibilities
   in available built-in functions on various systems.  */
static void
__yy_memcpy (char *to, char *from, unsigned int count)
{
  register char *t = to;
  register char *f = from;
  register int i = count;

  while (i-- > 0)
    *t++ = *f++;
}

#endif
#endif

#line 217 "/usr/share/bison.simple"

/* The user can define YYPARSE_PARAM as the name of an argument to be passed
   into yyparse.  The argument should have type void *.
   It should actually point to an object.
   Grammar actions can access the variable by casting it
   to the proper pointer type.  */

#ifdef YYPARSE_PARAM
#ifdef __cplusplus
#define YYPARSE_PARAM_ARG void *YYPARSE_PARAM
#define YYPARSE_PARAM_DECL
#else /* not __cplusplus */
#define YYPARSE_PARAM_ARG YYPARSE_PARAM
#define YYPARSE_PARAM_DECL void *YYPARSE_PARAM;
#endif /* not __cplusplus */
#else /* not YYPARSE_PARAM */
#define YYPARSE_PARAM_ARG
#define YYPARSE_PARAM_DECL
#endif /* not YYPARSE_PARAM */

/* Prevent warning if -Wstrict-prototypes.  */
#ifdef __GNUC__
#ifdef YYPARSE_PARAM
int yyparse (void *);
#else
int yyparse (void);
#endif
#endif

int
yyparse(YYPARSE_PARAM_ARG)
     YYPARSE_PARAM_DECL
{
  register int yystate;
  register int yyn;
  register short *yyssp;
  register YYSTYPE *yyvsp;
  int yyerrstatus;	/*  number of tokens to shift before error messages enabled */
  int yychar1 = 0;		/*  lookahead token as an internal (translated) token number */

  short	yyssa[YYINITDEPTH];	/*  the state stack			*/
  YYSTYPE yyvsa[YYINITDEPTH];	/*  the semantic value stack		*/

  short *yyss = yyssa;		/*  refer to the stacks thru separate pointers */
  YYSTYPE *yyvs = yyvsa;	/*  to allow yyoverflow to reallocate them elsewhere */

#ifdef YYLSP_NEEDED
  YYLTYPE yylsa[YYINITDEPTH];	/*  the location stack			*/
  YYLTYPE *yyls = yylsa;
  YYLTYPE *yylsp;

#define YYPOPSTACK   (yyvsp--, yyssp--, yylsp--)
#else
#define YYPOPSTACK   (yyvsp--, yyssp--)
#endif

  int yystacksize = YYINITDEPTH;
  int yyfree_stacks = 0;

#ifdef YYPURE
  int yychar;
  YYSTYPE yylval;
  int yynerrs;
#ifdef YYLSP_NEEDED
  YYLTYPE yylloc;
#endif
#endif

  YYSTYPE yyval;		/*  the variable used to return		*/
				/*  semantic values from the action	*/
				/*  routines				*/

  int yylen;

#if YYDEBUG != 0
  if (yydebug)
    fprintf(stderr, "Starting parse\n");
#endif

  yystate = 0;
  yyerrstatus = 0;
  yynerrs = 0;
  yychar = YYEMPTY;		/* Cause a token to be read.  */

  /* Initialize stack pointers.
     Waste one element of value and location stack
     so that they stay on the same level as the state stack.
     The wasted elements are never initialized.  */

  yyssp = yyss - 1;
  yyvsp = yyvs;
#ifdef YYLSP_NEEDED
  yylsp = yyls;
#endif

/* Push a new state, which is found in  yystate  .  */
/* In all cases, when you get here, the value and location stacks
   have just been pushed. so pushing a state here evens the stacks.  */
yynewstate:

  *++yyssp = yystate;

  if (yyssp >= yyss + yystacksize - 1)
    {
      /* Give user a chance to reallocate the stack */
      /* Use copies of these so that the &'s don't force the real ones into memory. */
      YYSTYPE *yyvs1 = yyvs;
      short *yyss1 = yyss;
#ifdef YYLSP_NEEDED
      YYLTYPE *yyls1 = yyls;
#endif

      /* Get the current used size of the three stacks, in elements.  */
      int size = yyssp - yyss + 1;

#ifdef yyoverflow
      /* Each stack pointer address is followed by the size of
	 the data in use in that stack, in bytes.  */
#ifdef YYLSP_NEEDED
      /* This used to be a conditional around just the two extra args,
	 but that might be undefined if yyoverflow is a macro.  */
      yyoverflow("parser stack overflow",
		 &yyss1, size * sizeof (*yyssp),
		 &yyvs1, size * sizeof (*yyvsp),
		 &yyls1, size * sizeof (*yylsp),
		 &yystacksize);
#else
      yyoverflow("parser stack overflow",
		 &yyss1, size * sizeof (*yyssp),
		 &yyvs1, size * sizeof (*yyvsp),
		 &yystacksize);
#endif

      yyss = yyss1; yyvs = yyvs1;
#ifdef YYLSP_NEEDED
      yyls = yyls1;
#endif
#else /* no yyoverflow */
      /* Extend the stack our own way.  */
      if (yystacksize >= YYMAXDEPTH)
	{
	  yyerror("parser stack overflow");
	  if (yyfree_stacks)
	    {
	      free (yyss);
	      free (yyvs);
#ifdef YYLSP_NEEDED
	      free (yyls);
#endif
	    }
	  return 2;
	}
      yystacksize *= 2;
      if (yystacksize > YYMAXDEPTH)
	yystacksize = YYMAXDEPTH;
#ifndef YYSTACK_USE_ALLOCA
      yyfree_stacks = 1;
#endif
      yyss = (short *) YYSTACK_ALLOC (yystacksize * sizeof (*yyssp));
      __yy_memcpy ((char *)yyss, (char *)yyss1,
		   size * (unsigned int) sizeof (*yyssp));
      yyvs = (YYSTYPE *) YYSTACK_ALLOC (yystacksize * sizeof (*yyvsp));
      __yy_memcpy ((char *)yyvs, (char *)yyvs1,
		   size * (unsigned int) sizeof (*yyvsp));
#ifdef YYLSP_NEEDED
      yyls = (YYLTYPE *) YYSTACK_ALLOC (yystacksize * sizeof (*yylsp));
      __yy_memcpy ((char *)yyls, (char *)yyls1,
		   size * (unsigned int) sizeof (*yylsp));
#endif
#endif /* no yyoverflow */

      yyssp = yyss + size - 1;
      yyvsp = yyvs + size - 1;
#ifdef YYLSP_NEEDED
      yylsp = yyls + size - 1;
#endif

#if YYDEBUG != 0
      if (yydebug)
	fprintf(stderr, "Stack size increased to %d\n", yystacksize);
#endif

      if (yyssp >= yyss + yystacksize - 1)
	YYABORT;
    }

#if YYDEBUG != 0
  if (yydebug)
    fprintf(stderr, "Entering state %d\n", yystate);
#endif

  goto yybackup;
 yybackup:

/* Do appropriate processing given the current state.  */
/* Read a lookahead token if we need one and don't already have one.  */
/* yyresume: */

  /* First try to decide what to do without reference to lookahead token.  */

  yyn = yypact[yystate];
  if (yyn == YYFLAG)
    goto yydefault;

  /* Not known => get a lookahead token if don't already have one.  */

  /* yychar is either YYEMPTY or YYEOF
     or a valid token in external form.  */

  if (yychar == YYEMPTY)
    {
#if YYDEBUG != 0
      if (yydebug)
	fprintf(stderr, "Reading a token: ");
#endif
      yychar = YYLEX;
    }

  /* Convert token to internal form (in yychar1) for indexing tables with */

  if (yychar <= 0)		/* This means end of input. */
    {
      yychar1 = 0;
      yychar = YYEOF;		/* Don't call YYLEX any more */

#if YYDEBUG != 0
      if (yydebug)
	fprintf(stderr, "Now at end of input.\n");
#endif
    }
  else
    {
      yychar1 = YYTRANSLATE(yychar);

#if YYDEBUG != 0
      if (yydebug)
	{
	  fprintf (stderr, "Next token is %d (%s", yychar, yytname[yychar1]);
	  /* Give the individual parser a way to print the precise meaning
	     of a token, for further debugging info.  */
#ifdef YYPRINT
	  YYPRINT (stderr, yychar, yylval);
#endif
	  fprintf (stderr, ")\n");
	}
#endif
    }

  yyn += yychar1;
  if (yyn < 0 || yyn > YYLAST || yycheck[yyn] != yychar1)
    goto yydefault;

  yyn = yytable[yyn];

  /* yyn is what to do for this token type in this state.
     Negative => reduce, -yyn is rule number.
     Positive => shift, yyn is new state.
       New state is final state => don't bother to shift,
       just return success.
     0, or most negative number => error.  */

  if (yyn < 0)
    {
      if (yyn == YYFLAG)
	goto yyerrlab;
      yyn = -yyn;
      goto yyreduce;
    }
  else if (yyn == 0)
    goto yyerrlab;

  if (yyn == YYFINAL)
    YYACCEPT;

  /* Shift the lookahead token.  */

#if YYDEBUG != 0
  if (yydebug)
    fprintf(stderr, "Shifting token %d (%s), ", yychar, yytname[yychar1]);
#endif

  /* Discard the token being shifted unless it is eof.  */
  if (yychar != YYEOF)
    yychar = YYEMPTY;

  *++yyvsp = yylval;
#ifdef YYLSP_NEEDED
  *++yylsp = yylloc;
#endif

  /* count tokens shifted since error; after three, turn off error status.  */
  if (yyerrstatus) yyerrstatus--;

  yystate = yyn;
  goto yynewstate;

/* Do the default action for the current state.  */
yydefault:

  yyn = yydefact[yystate];
  if (yyn == 0)
    goto yyerrlab;

/* Do a reduction.  yyn is the number of a rule to reduce with.  */
yyreduce:
  yylen = yyr2[yyn];
  if (yylen > 0)
    yyval = yyvsp[1-yylen]; /* implement default value of the action */

#if YYDEBUG != 0
  if (yydebug)
    {
      int i;

      fprintf (stderr, "Reducing via rule %d (line %d), ",
	       yyn, yyrline[yyn]);

      /* Print the symbols being reduced, and their result.  */
      for (i = yyprhs[yyn]; yyrhs[i] > 0; i++)
	fprintf (stderr, "%s ", yytname[yyrhs[i]]);
      fprintf (stderr, " -> %s\n", yytname[yyr1[yyn]]);
    }
#endif


  switch (yyn) {

case 2:
#line 145 "Gmsh.y"
{ yyerrok; return 1; ;
    break;}
case 5:
#line 156 "Gmsh.y"
{ return 1; ;
    break;}
case 6:
#line 157 "Gmsh.y"
{ return 1; ;
    break;}
case 7:
#line 158 "Gmsh.y"
{ return 1; ;
    break;}
case 8:
#line 159 "Gmsh.y"
{ return 1; ;
    break;}
case 9:
#line 160 "Gmsh.y"
{ List_Delete(yyvsp[0].l); return 1; ;
    break;}
case 10:
#line 161 "Gmsh.y"
{ List_Delete(yyvsp[0].l); return 1; ;
    break;}
case 11:
#line 162 "Gmsh.y"
{ return 1; ;
    break;}
case 12:
#line 163 "Gmsh.y"
{ return 1; ;
    break;}
case 13:
#line 164 "Gmsh.y"
{ return 1; ;
    break;}
case 14:
#line 165 "Gmsh.y"
{ List_Delete(yyvsp[0].l); return 1; ;
    break;}
case 15:
#line 166 "Gmsh.y"
{ return 1; ;
    break;}
case 16:
#line 167 "Gmsh.y"
{ return 1; ;
    break;}
case 17:
#line 168 "Gmsh.y"
{ return 1; ;
    break;}
case 18:
#line 169 "Gmsh.y"
{ return 1; ;
    break;}
case 19:
#line 170 "Gmsh.y"
{ return 1; ;
    break;}
case 20:
#line 175 "Gmsh.y"
{
      yyval.c = "w";
    ;
    break;}
case 21:
#line 179 "Gmsh.y"
{
      yyval.c = "a";
    ;
    break;}
case 22:
#line 186 "Gmsh.y"
{
      Msg(DIRECT, yyvsp[-2].c);
      Free(yyvsp[-2].c);
    ;
    break;}
case 23:
#line 191 "Gmsh.y"
{
      char tmpstring[1024];
      FixRelativePath(yyvsp[-1].c, tmpstring);
      FILE *fp = fopen(tmpstring, yyvsp[-2].c);
      if(!fp){
	yymsg(GERROR, "Unable to open file '%s'", tmpstring);
      }
      else{
	fprintf(fp, "%s\n", yyvsp[-4].c);
	fclose(fp);
      }
      Free(yyvsp[-4].c);
      Free(yyvsp[-1].c);
    ;
    break;}
case 24:
#line 206 "Gmsh.y"
{
      char tmpstring[1024];
      int i = PrintListOfDouble(yyvsp[-4].c, yyvsp[-2].l, tmpstring);
      if(i < 0) 
	yymsg(GERROR, "Too few arguments in Printf");
      else if(i > 0)
	yymsg(GERROR, "%d extra argument%s in Printf", i, (i>1)?"s":"");
      else
	Msg(DIRECT, tmpstring);
      Free(yyvsp[-4].c);
      List_Delete(yyvsp[-2].l);
    ;
    break;}
case 25:
#line 219 "Gmsh.y"
{
      char tmpstring[1024];
      int i = PrintListOfDouble(yyvsp[-6].c, yyvsp[-4].l, tmpstring);
      if(i < 0) 
	yymsg(GERROR, "Too few arguments in Printf");
      else if(i > 0)
	yymsg(GERROR, "%d extra argument%s in Printf", i, (i>1)?"s":"");
      else{
	char tmpstring2[1024];
	FixRelativePath(yyvsp[-1].c, tmpstring2);
	FILE *fp = fopen(tmpstring2, yyvsp[-2].c);
	if(!fp){
	  yymsg(GERROR, "Unable to open file '%s'", tmpstring2);
	}
	else{
	  fprintf(fp, "%s\n", tmpstring);
	  fclose(fp);
	}
      }
      Free(yyvsp[-6].c);
      Free(yyvsp[-1].c);
      List_Delete(yyvsp[-4].l);
    ;
    break;}
case 26:
#line 248 "Gmsh.y"
{ 
      if(!strcmp(yyvsp[-5].c, "View") && !CheckViewErrorFlags(View)){
	EndView(View, 0, yyname, yyvsp[-4].c);
      }
      Free(yyvsp[-5].c); Free(yyvsp[-4].c);
    ;
    break;}
case 27:
#line 255 "Gmsh.y"
{
      if(!strcmp(yyvsp[-7].c, "View") && !CheckViewErrorFlags(View)){
	EndView(View, 0, yyname, yyvsp[-6].c);
      }
      Free(yyvsp[-7].c); Free(yyvsp[-6].c); Free(yyvsp[-5].c);
    ;
    break;}
case 28:
#line 265 "Gmsh.y"
{
      View = BeginView(1); 
      for(int i = 0; i < VIEW_NB_ELEMENT_TYPES; i++){
	ViewErrorFlags[i] = 0;
      }
    ;
    break;}
case 35:
#line 281 "Gmsh.y"
{ ViewCoord[ViewCoordIdx] = yyvsp[0].d; ViewCoordIdx++; ;
    break;}
case 36:
#line 283 "Gmsh.y"
{ ViewCoord[ViewCoordIdx] = yyvsp[0].d; ViewCoordIdx++; ;
    break;}
case 37:
#line 288 "Gmsh.y"
{ if(ViewValueList) List_Add(ViewValueList, &yyvsp[0].d); ;
    break;}
case 38:
#line 290 "Gmsh.y"
{ if(ViewValueList) List_Add(ViewValueList, &yyvsp[0].d); ;
    break;}
case 39:
#line 295 "Gmsh.y"
{
      if(!strcmp(yyvsp[0].c, "SP")){
	ViewElementIdx = 0; ViewNumNodes = 1; ViewNumComp = 1;
	ViewValueList = View->SP; ViewNumList = &View->NbSP;
      }
      else if(!strcmp(yyvsp[0].c, "VP")){
	ViewElementIdx = 1; ViewNumNodes = 1; ViewNumComp = 3;
	ViewValueList = View->VP; ViewNumList = &View->NbVP;
      }
      else if(!strcmp(yyvsp[0].c, "TP")){
	ViewElementIdx = 2; ViewNumNodes = 1; ViewNumComp = 9;
	ViewValueList = View->TP; ViewNumList = &View->NbTP;
      }
      else if(!strcmp(yyvsp[0].c, "SL")){
	ViewElementIdx = 3; ViewNumNodes = 2; ViewNumComp = 1;
	ViewValueList = View->SL; ViewNumList = &View->NbSL;
      }
      else if(!strcmp(yyvsp[0].c, "VL")){
	ViewElementIdx = 4; ViewNumNodes = 2; ViewNumComp = 3;
	ViewValueList = View->VL; ViewNumList = &View->NbVL;
      }
      else if(!strcmp(yyvsp[0].c, "TL")){
	ViewElementIdx = 5; ViewNumNodes = 2; ViewNumComp = 9;
	ViewValueList = View->TL; ViewNumList = &View->NbTL;
      }
      else if(!strcmp(yyvsp[0].c, "ST")){
	ViewElementIdx = 6; ViewNumNodes = 3; ViewNumComp = 1;
	ViewValueList = View->ST; ViewNumList = &View->NbST;
      }
      else if(!strcmp(yyvsp[0].c, "VT")){
	ViewElementIdx = 7; ViewNumNodes = 3; ViewNumComp = 3;
	ViewValueList = View->VT; ViewNumList = &View->NbVT;
      }
      else if(!strcmp(yyvsp[0].c, "TT")){
	ViewElementIdx = 8; ViewNumNodes = 3; ViewNumComp = 9;
	ViewValueList = View->TT; ViewNumList = &View->NbTT;
      }
      else if(!strcmp(yyvsp[0].c, "SQ")){
	ViewElementIdx = 9; ViewNumNodes = 4; ViewNumComp = 1;
	ViewValueList = View->SQ; ViewNumList = &View->NbSQ;
      }
      else if(!strcmp(yyvsp[0].c, "VQ")){
	ViewElementIdx = 10; ViewNumNodes = 4; ViewNumComp = 3;
	ViewValueList = View->VQ; ViewNumList = &View->NbVQ;
      }
      else if(!strcmp(yyvsp[0].c, "TQ")){
	ViewElementIdx = 11; ViewNumNodes = 4; ViewNumComp = 9;
	ViewValueList = View->TQ; ViewNumList = &View->NbTQ;
      }
      else if(!strcmp(yyvsp[0].c, "SS")){
	ViewElementIdx = 12; ViewNumNodes = 4; ViewNumComp = 1;
	ViewValueList = View->SS; ViewNumList = &View->NbSS;
      }
      else if(!strcmp(yyvsp[0].c, "VS")){
	ViewElementIdx = 13; ViewNumNodes = 4; ViewNumComp = 3;
	ViewValueList = View->VS; ViewNumList = &View->NbVS;
      }
      else if(!strcmp(yyvsp[0].c, "TS")){
	ViewElementIdx = 14; ViewNumNodes = 4; ViewNumComp = 9;
	ViewValueList = View->TS; ViewNumList = &View->NbTS;
      }
      else if(!strcmp(yyvsp[0].c, "SH")){
	ViewElementIdx = 15; ViewNumNodes = 8; ViewNumComp = 1;
	ViewValueList = View->SH; ViewNumList = &View->NbSH;
      }
      else if(!strcmp(yyvsp[0].c, "VH")){
	ViewElementIdx = 16; ViewNumNodes = 8; ViewNumComp = 3;
	ViewValueList = View->VH; ViewNumList = &View->NbVH;
      }
      else if(!strcmp(yyvsp[0].c, "TH")){
	ViewElementIdx = 17; ViewNumNodes = 8; ViewNumComp = 9;
	ViewValueList = View->TH; ViewNumList = &View->NbTH;
      }
      else if(!strcmp(yyvsp[0].c, "SI")){
	ViewElementIdx = 18; ViewNumNodes = 6; ViewNumComp = 1;
	ViewValueList = View->SI; ViewNumList = &View->NbSI;
      }
      else if(!strcmp(yyvsp[0].c, "VI")){
	ViewElementIdx = 19; ViewNumNodes = 6; ViewNumComp = 3;
	ViewValueList = View->VI; ViewNumList = &View->NbVI;
      }
      else if(!strcmp(yyvsp[0].c, "TI")){
	ViewElementIdx = 20; ViewNumNodes = 6; ViewNumComp = 9;
	ViewValueList = View->TI; ViewNumList = &View->NbTI;
      }
      else if(!strcmp(yyvsp[0].c, "SY")){
	ViewElementIdx = 21; ViewNumNodes = 5; ViewNumComp = 1;
	ViewValueList = View->SY; ViewNumList = &View->NbSY;
      }
      else if(!strcmp(yyvsp[0].c, "VY")){
	ViewElementIdx = 22; ViewNumNodes = 5; ViewNumComp = 3;
	ViewValueList = View->VY; ViewNumList = &View->NbVY;
      }
      else if(!strcmp(yyvsp[0].c, "TY")){
	ViewElementIdx = 23; ViewNumNodes = 5; ViewNumComp = 9;
	ViewValueList = View->TY; ViewNumList = &View->NbTY;
      }
      else if(!strcmp(yyvsp[0].c, "SL2")){
	ViewElementIdx = 3; ViewNumNodes = 3; ViewNumComp = 1;
	ViewValueList = View->SL2; ViewNumList = &View->NbSL2;
      }
      else if(!strcmp(yyvsp[0].c, "VL2")){
	ViewElementIdx = 4; ViewNumNodes = 3; ViewNumComp = 3;
	ViewValueList = View->VL2; ViewNumList = &View->NbVL2;
      }
      else if(!strcmp(yyvsp[0].c, "TL2")){
	ViewElementIdx = 5; ViewNumNodes = 3; ViewNumComp = 9;
	ViewValueList = View->TL2; ViewNumList = &View->NbTL2;
      }
      else if(!strcmp(yyvsp[0].c, "ST2")){
	ViewElementIdx = 6; ViewNumNodes = 6; ViewNumComp = 1;
	ViewValueList = View->ST2; ViewNumList = &View->NbST2;
      }
      else if(!strcmp(yyvsp[0].c, "VT2")){
	ViewElementIdx = 7; ViewNumNodes = 6; ViewNumComp = 3;
	ViewValueList = View->VT2; ViewNumList = &View->NbVT2;
      }
      else if(!strcmp(yyvsp[0].c, "TT2")){
	ViewElementIdx = 8; ViewNumNodes = 6; ViewNumComp = 9;
	ViewValueList = View->TT2; ViewNumList = &View->NbTT2;
      }
      else if(!strcmp(yyvsp[0].c, "SQ2")){
	ViewElementIdx = 9; ViewNumNodes = 9; ViewNumComp = 1;
	ViewValueList = View->SQ2; ViewNumList = &View->NbSQ2;
      }
      else if(!strcmp(yyvsp[0].c, "VQ2")){
	ViewElementIdx = 10; ViewNumNodes = 9; ViewNumComp = 3;
	ViewValueList = View->VQ2; ViewNumList = &View->NbVQ2;
      }
      else if(!strcmp(yyvsp[0].c, "TQ2")){
	ViewElementIdx = 11; ViewNumNodes = 9; ViewNumComp = 9;
	ViewValueList = View->TQ2; ViewNumList = &View->NbTQ2;
      }
      else if(!strcmp(yyvsp[0].c, "SS2")){
	ViewElementIdx = 12; ViewNumNodes = 10; ViewNumComp = 1;
	ViewValueList = View->SS2; ViewNumList = &View->NbSS2;
      }
      else if(!strcmp(yyvsp[0].c, "VS2")){
	ViewElementIdx = 13; ViewNumNodes = 10; ViewNumComp = 3;
	ViewValueList = View->VS2; ViewNumList = &View->NbVS2;
      }
      else if(!strcmp(yyvsp[0].c, "TS2")){
	ViewElementIdx = 14; ViewNumNodes = 10; ViewNumComp = 9;
	ViewValueList = View->TS2; ViewNumList = &View->NbTS2;
      }
      else if(!strcmp(yyvsp[0].c, "SH2")){
	ViewElementIdx = 15; ViewNumNodes = 27; ViewNumComp = 1;
	ViewValueList = View->SH2; ViewNumList = &View->NbSH2;
      }
      else if(!strcmp(yyvsp[0].c, "VH2")){
	ViewElementIdx = 16; ViewNumNodes = 27; ViewNumComp = 3;
	ViewValueList = View->VH2; ViewNumList = &View->NbVH2;
      }
      else if(!strcmp(yyvsp[0].c, "TH2")){
	ViewElementIdx = 17; ViewNumNodes = 27; ViewNumComp = 9;
	ViewValueList = View->TH2; ViewNumList = &View->NbTH2;
      }
      else if(!strcmp(yyvsp[0].c, "SI2")){
	ViewElementIdx = 18; ViewNumNodes = 18; ViewNumComp = 1;
	ViewValueList = View->SI2; ViewNumList = &View->NbSI2;
      }
      else if(!strcmp(yyvsp[0].c, "VI2")){
	ViewElementIdx = 19; ViewNumNodes = 18; ViewNumComp = 3;
	ViewValueList = View->VI2; ViewNumList = &View->NbVI2;
      }
      else if(!strcmp(yyvsp[0].c, "TI2")){
	ViewElementIdx = 20; ViewNumNodes = 18; ViewNumComp = 9;
	ViewValueList = View->TI2; ViewNumList = &View->NbTI2;
      }
      else if(!strcmp(yyvsp[0].c, "SY2")){
	ViewElementIdx = 21; ViewNumNodes = 14; ViewNumComp = 1;
	ViewValueList = View->SY2; ViewNumList = &View->NbSY2;
      }
      else if(!strcmp(yyvsp[0].c, "VY2")){
	ViewElementIdx = 22; ViewNumNodes = 14; ViewNumComp = 3;
	ViewValueList = View->VY2; ViewNumList = &View->NbVY2;
      }
      else if(!strcmp(yyvsp[0].c, "TY2")){
	ViewElementIdx = 23; ViewNumNodes = 14; ViewNumComp = 9;
	ViewValueList = View->TY2; ViewNumList = &View->NbTY2;
      }
      else{
	yymsg(GERROR, "Unknown element type '%s'", yyvsp[0].c);	
	ViewElementIdx = -1; ViewNumNodes = 0; ViewNumComp = 0;
	ViewValueList = NULL; ViewNumList = NULL;
      }
      Free(yyvsp[0].c);
      ViewCoordIdx = 0;
    ;
    break;}
case 40:
#line 485 "Gmsh.y"
{
      if(ViewValueList){
	if(ViewCoordIdx != 3 * ViewNumNodes){
	  yymsg(GERROR, "Wrong number of node coordinates (%d != %d)", 
		ViewCoordIdx, 3 * ViewNumNodes);
	  double d = 0;
	  for(int i = 0; i < 3 * ViewNumNodes; i++)
	    List_Add(ViewValueList, &d);
	}
	else{
	  for(int i = 0; i < 3; i++)
	    for(int j = 0; j < ViewNumNodes; j++)
	      List_Add(ViewValueList, &ViewCoord[3*j+i]);
	}
	ViewNumListTmp = List_Nbr(ViewValueList);
      }
    ;
    break;}
case 41:
#line 503 "Gmsh.y"
{
      if(ViewValueList){  
	if((List_Nbr(ViewValueList) - ViewNumListTmp) % (ViewNumComp * ViewNumNodes)) 
	  ViewErrorFlags[ViewElementIdx]++;
	(*ViewNumList)++;
      }
    ;
    break;}
case 42:
#line 514 "Gmsh.y"
{ 
      for(int i = 0; i < (int)strlen(yyvsp[0].c)+1; i++) List_Add(View->T2C, &yyvsp[0].c[i]); 
      Free(yyvsp[0].c);
    ;
    break;}
case 43:
#line 519 "Gmsh.y"
{ 
      for(int i = 0; i < (int)strlen(yyvsp[0].c)+1; i++) List_Add(View->T2C, &yyvsp[0].c[i]); 
      Free(yyvsp[0].c);
    ;
    break;}
case 44:
#line 527 "Gmsh.y"
{ 
      List_Add(View->T2D, &yyvsp[-5].d); List_Add(View->T2D, &yyvsp[-3].d);
      List_Add(View->T2D, &yyvsp[-1].d); 
      double d = List_Nbr(View->T2C);
      List_Add(View->T2D, &d); 
    ;
    break;}
case 45:
#line 534 "Gmsh.y"
{
      View->NbT2++;
    ;
    break;}
case 46:
#line 541 "Gmsh.y"
{ 
      for(int i = 0; i < (int)strlen(yyvsp[0].c)+1; i++) List_Add(View->T3C, &yyvsp[0].c[i]); 
      Free(yyvsp[0].c);
    ;
    break;}
case 47:
#line 546 "Gmsh.y"
{ 
      for(int i = 0; i < (int)strlen(yyvsp[0].c)+1; i++) List_Add(View->T3C, &yyvsp[0].c[i]); 
      Free(yyvsp[0].c);
    ;
    break;}
case 48:
#line 554 "Gmsh.y"
{ 
      List_Add(View->T3D, &yyvsp[-7].d); List_Add(View->T3D, &yyvsp[-5].d);
      List_Add(View->T3D, &yyvsp[-3].d); List_Add(View->T3D, &yyvsp[-1].d); 
      double d = List_Nbr(View->T3C);
      List_Add(View->T3D, &d); 
    ;
    break;}
case 49:
#line 561 "Gmsh.y"
{
      View->NbT3++;
    ;
    break;}
case 50:
#line 569 "Gmsh.y"
{
      View->adaptive = new Adaptive_Post_View(View, yyvsp[-5].l, yyvsp[-2].l);
    ;
    break;}
case 51:
#line 576 "Gmsh.y"
{
      ViewValueList = View->Time;
    ;
    break;}
case 52:
#line 580 "Gmsh.y"
{
    ;
    break;}
case 53:
#line 585 "Gmsh.y"
{
      (*View->Grains) [(int)yyvsp[-3].d] = yyvsp[-1].l;
    ;
    break;}
case 54:
#line 593 "Gmsh.y"
{ yyval.i = 0; ;
    break;}
case 55:
#line 594 "Gmsh.y"
{ yyval.i = 1; ;
    break;}
case 56:
#line 595 "Gmsh.y"
{ yyval.i = 2; ;
    break;}
case 57:
#line 596 "Gmsh.y"
{ yyval.i = 3; ;
    break;}
case 58:
#line 597 "Gmsh.y"
{ yyval.i = 4; ;
    break;}
case 59:
#line 601 "Gmsh.y"
{ yyval.i = 1; ;
    break;}
case 60:
#line 602 "Gmsh.y"
{ yyval.i = -1; ;
    break;}
case 61:
#line 610 "Gmsh.y"
{
      Symbol TheSymbol;
      TheSymbol.Name = yyvsp[-3].c;
      Symbol *pSymbol;
      if(!(pSymbol = (Symbol*)Tree_PQuery(Symbol_T, &TheSymbol))){
	if(!yyvsp[-2].i){
	  TheSymbol.val = List_Create(1, 1, sizeof(double));
	  List_Put(TheSymbol.val, 0, &yyvsp[-1].d);
	  Tree_Add(Symbol_T, &TheSymbol);
	}
	else{
	  yymsg(GERROR, "Unknown variable '%s'", yyvsp[-3].c);
	  Free(yyvsp[-3].c);
	}
      }
      else{
	double *pd = (double*)List_Pointer_Fast(pSymbol->val, 0); 
	switch(yyvsp[-2].i){
	case 0 : *pd = yyvsp[-1].d; break;
	case 1 : *pd += yyvsp[-1].d; break;
	case 2 : *pd -= yyvsp[-1].d; break;
	case 3 : *pd *= yyvsp[-1].d; break;
	case 4 : 
	  if(yyvsp[-1].d) *pd /= yyvsp[-1].d; 
	  else yymsg(GERROR, "Division by zero in '%s /= %g'", yyvsp[-3].c, yyvsp[-1].d);
	  break;
	}
	Free(yyvsp[-3].c);
      }
    ;
    break;}
case 62:
#line 641 "Gmsh.y"
{
      Symbol TheSymbol;
      TheSymbol.Name = yyvsp[-6].c;
      Symbol *pSymbol;
      if(!(pSymbol = (Symbol*)Tree_PQuery(Symbol_T, &TheSymbol))){
	if(!yyvsp[-2].i){
	  TheSymbol.val = List_Create(5, 5, sizeof(double));
	  List_Put(TheSymbol.val, (int)yyvsp[-4].d, &yyvsp[-1].d);
	  Tree_Add(Symbol_T, &TheSymbol);
	}
	else{
	  yymsg(GERROR, "Unknown variable '%s'", yyvsp[-6].c);
	  Free(yyvsp[-6].c);
	}
      }
      else{
	double *pd;
	if((pd = (double*)List_Pointer_Test(pSymbol->val, (int)yyvsp[-4].d))){
	  switch(yyvsp[-2].i){
	  case 0 : *pd = yyvsp[-1].d; break;
	  case 1 : *pd += yyvsp[-1].d; break;
	  case 2 : *pd -= yyvsp[-1].d; break;
	  case 3 : *pd *= yyvsp[-1].d; break;
	  case 4 : 
	    if(yyvsp[-1].d) *pd /= yyvsp[-1].d; 
	    else yymsg(GERROR, "Division by zero in '%s[%d] /= %g'", yyvsp[-6].c, (int)yyvsp[-4].d, yyvsp[-1].d);
	    break;
	  }
	}
	else{
	  if(!yyvsp[-2].i)
	    List_Put(pSymbol->val, (int)yyvsp[-4].d, &yyvsp[-1].d);
	  else
	    yymsg(GERROR, "Uninitialized variable '%s[%d]'", yyvsp[-6].c, (int)yyvsp[-4].d);
	}
	Free(yyvsp[-6].c);
      }
    ;
    break;}
case 63:
#line 680 "Gmsh.y"
{
      if(List_Nbr(yyvsp[-5].l) != List_Nbr(yyvsp[-1].l)){
	yymsg(GERROR, "Incompatible array dimensions in affectation");
	Free(yyvsp[-8].c);
      }
      else{
	Symbol TheSymbol;
	TheSymbol.Name = yyvsp[-8].c;
	Symbol *pSymbol;
	if(!(pSymbol = (Symbol*)Tree_PQuery(Symbol_T, &TheSymbol))){
	  if(!yyvsp[-2].i){
	    TheSymbol.val = List_Create(5, 5, sizeof(double));
	    for(int i = 0; i < List_Nbr(yyvsp[-5].l); i++){
	      List_Put(TheSymbol.val, (int)(*(double*)List_Pointer(yyvsp[-5].l, i)),
		       (double*)List_Pointer(yyvsp[-1].l, i));
	    }
	    Tree_Add(Symbol_T, &TheSymbol);
	  }
	  else{
	    yymsg(GERROR, "Unknown variable '%s'", yyvsp[-8].c);
	    Free(yyvsp[-8].c);
	  }
	}
	else{
	  for(int i = 0; i < List_Nbr(yyvsp[-5].l); i++){
	    int j = (int)(*(double*)List_Pointer(yyvsp[-5].l, i));
	    double d = *(double*)List_Pointer(yyvsp[-1].l, i);
	    double *pd;
	    if((pd = (double*)List_Pointer_Test(pSymbol->val, j))){
	      switch(yyvsp[-2].i){
	      case 0 : *pd = d; break;
	      case 1 : *pd += d; break;
	      case 2 : *pd -= d; break;
	      case 3 : *pd *= d; break;
	      case 4 : 
		if(yyvsp[-1].l) *pd /= d; 
		else yymsg(GERROR, "Division by zero in '%s[%d] /= %g'", yyvsp[-8].c, j, d);
		break;
	      }
	    }
	    else{
	      if(!yyvsp[-2].i)
		List_Put(pSymbol->val, j, &d);
	      else
		yymsg(GERROR, "Uninitialized variable '%s[%d]'", yyvsp[-8].c, j);	  
	    }
	  }
	  Free(yyvsp[-8].c);
	}
      }
      List_Delete(yyvsp[-5].l);
      List_Delete(yyvsp[-1].l);
    ;
    break;}
case 64:
#line 734 "Gmsh.y"
{
      Symbol TheSymbol;
      TheSymbol.Name = yyvsp[-5].c;
      Symbol *pSymbol;
      if(!(pSymbol = (Symbol*)Tree_PQuery(Symbol_T, &TheSymbol))){
	TheSymbol.val = List_Create(5, 5, sizeof(double));
	List_Copy(yyvsp[-1].l, TheSymbol.val);
	Tree_Add(Symbol_T, &TheSymbol);
      }
      else{
	List_Reset(pSymbol->val);
	List_Copy(yyvsp[-1].l, pSymbol->val);
	Free(yyvsp[-5].c);
      }
      List_Delete(yyvsp[-1].l);
    ;
    break;}
case 65:
#line 751 "Gmsh.y"
{
      // appends to the list
      Symbol TheSymbol;
      TheSymbol.Name = yyvsp[-5].c;
      Symbol *pSymbol;
      if(!(pSymbol = (Symbol*)Tree_PQuery(Symbol_T, &TheSymbol))){
	TheSymbol.val = List_Create(5, 5, sizeof(double));
	List_Copy(yyvsp[-1].l, TheSymbol.val);
	Tree_Add(Symbol_T, &TheSymbol);
      }
      else{
	for(int i = 0; i < List_Nbr(yyvsp[-1].l); i++)
	  List_Add(pSymbol->val, List_Pointer(yyvsp[-1].l, i));
	Free(yyvsp[-5].c);
      }
      List_Delete(yyvsp[-1].l);
    ;
    break;}
case 66:
#line 769 "Gmsh.y"
{
      Symbol TheSymbol;
      TheSymbol.Name = yyvsp[-2].c;
      Symbol *pSymbol;
      if(!(pSymbol = (Symbol*)Tree_PQuery(Symbol_T, &TheSymbol)))
	yymsg(GERROR, "Unknown variable '%s'", yyvsp[-2].c); 
      else
	*(double*)List_Pointer_Fast(pSymbol->val, 0) += yyvsp[-1].i;
      Free(yyvsp[-2].c);
    ;
    break;}
case 67:
#line 780 "Gmsh.y"
{
      Symbol TheSymbol;
      TheSymbol.Name = yyvsp[-5].c;
      Symbol *pSymbol;
      if(!(pSymbol = (Symbol*)Tree_PQuery(Symbol_T, &TheSymbol)))
	yymsg(GERROR, "Unknown variable '%s'", yyvsp[-5].c); 
      else{
	double *pd;
	if((pd = (double*)List_Pointer_Test(pSymbol->val, (int)yyvsp[-3].d)))
	  *pd += yyvsp[-1].i;
	else
	  yymsg(GERROR, "Uninitialized variable '%s[%d]'", yyvsp[-5].c, (int)yyvsp[-3].d);
      }
      Free(yyvsp[-5].c);
    ;
    break;}
case 68:
#line 799 "Gmsh.y"
{ 
      char* (*pStrOpt)(int num, int action, char *value);
      StringXString *pStrCat;
      if(!(pStrCat = Get_StringOptionCategory(yyvsp[-5].c)))
	yymsg(GERROR, "Unknown string option class '%s'", yyvsp[-5].c);
      else{
	if(!(pStrOpt = (char *(*) (int, int, char *))Get_StringOption(yyvsp[-3].c, pStrCat)))
	  yymsg(GERROR, "Unknown string option '%s.%s'", yyvsp[-5].c, yyvsp[-3].c);
	else
	  pStrOpt(0, GMSH_SET|GMSH_GUI, yyvsp[-1].c);
      }
      Free(yyvsp[-5].c); Free(yyvsp[-3].c); //FIXME: somtimes leak $5
    ;
    break;}
case 69:
#line 813 "Gmsh.y"
{ 
      char* (*pStrOpt)(int num, int action, char *value);
      StringXString *pStrCat;
      if(!(pStrCat = Get_StringOptionCategory(yyvsp[-8].c)))
	yymsg(GERROR, "Unknown string option class '%s'", yyvsp[-8].c);
      else{
	if(!(pStrOpt = (char *(*) (int, int, char *))Get_StringOption(yyvsp[-3].c, pStrCat)))
	  yymsg(GERROR, "Unknown string option '%s[%d].%s'", yyvsp[-8].c, (int)yyvsp[-6].d, yyvsp[-3].c);
	else
	  pStrOpt((int)yyvsp[-6].d, GMSH_SET|GMSH_GUI, yyvsp[-1].c);
      }
      Free(yyvsp[-8].c); Free(yyvsp[-3].c); //FIXME: somtimes leak $8
    ;
    break;}
case 70:
#line 830 "Gmsh.y"
{
      double (*pNumOpt)(int num, int action, double value);
      StringXNumber *pNumCat;
      if(!(pNumCat = Get_NumberOptionCategory(yyvsp[-5].c)))
	yymsg(GERROR, "Unknown numeric option class '%s'", yyvsp[-5].c);
      else{
	if(!(pNumOpt = (double (*) (int, int, double))Get_NumberOption(yyvsp[-3].c, pNumCat)))
	  yymsg(GERROR, "Unknown numeric option '%s.%s'", yyvsp[-5].c, yyvsp[-3].c);
	else{
	  double d = 0;
	  switch(yyvsp[-2].i){
	  case 0 : d = yyvsp[-1].d; break;
	  case 1 : d = pNumOpt(0, GMSH_GET, 0) + yyvsp[-1].d; break;
	  case 2 : d = pNumOpt(0, GMSH_GET, 0) - yyvsp[-1].d; break;
	  case 3 : d = pNumOpt(0, GMSH_GET, 0) * yyvsp[-1].d; break;
	  case 4 : 
	    if(yyvsp[-1].d) d = pNumOpt(0, GMSH_GET, 0) / yyvsp[-1].d; 
	    else yymsg(GERROR, "Division by zero in '%s.%s /= %g'", yyvsp[-5].c, yyvsp[-3].c, yyvsp[-1].d);
	    break;
	  }
	  pNumOpt(0, GMSH_SET|GMSH_GUI, d);
	}
      }
      Free(yyvsp[-5].c); Free(yyvsp[-3].c);
    ;
    break;}
case 71:
#line 856 "Gmsh.y"
{
      double (*pNumOpt)(int num, int action, double value);
      StringXNumber *pNumCat;
      if(!(pNumCat = Get_NumberOptionCategory(yyvsp[-8].c)))
	yymsg(GERROR, "Unknown numeric option class '%s'", yyvsp[-8].c);
      else{
	if(!(pNumOpt =  (double (*) (int, int, double))Get_NumberOption(yyvsp[-3].c, pNumCat)))
	  yymsg(GERROR, "Unknown numeric option '%s[%d].%s'", yyvsp[-8].c, (int)yyvsp[-6].d, yyvsp[-3].c);
	else{
	  double d = 0;
	  switch(yyvsp[-2].i){
	  case 0 : d = yyvsp[-1].d; break;
	  case 1 : d = pNumOpt((int)yyvsp[-6].d, GMSH_GET, 0) + yyvsp[-1].d; break;
	  case 2 : d = pNumOpt((int)yyvsp[-6].d, GMSH_GET, 0) - yyvsp[-1].d; break;
	  case 3 : d = pNumOpt((int)yyvsp[-6].d, GMSH_GET, 0) * yyvsp[-1].d; break;
	  case 4 : 
	    if(yyvsp[-1].d) d = pNumOpt((int)yyvsp[-6].d, GMSH_GET, 0) / yyvsp[-1].d;
	    else yymsg(GERROR, "Division by zero in '%s[%d].%s /= %g'", 
		       yyvsp[-8].c, (int)yyvsp[-6].d, yyvsp[-3].c, yyvsp[-1].d);
	    break;
	  }
	  pNumOpt((int)yyvsp[-6].d, GMSH_SET|GMSH_GUI, d);
	}
      }
      Free(yyvsp[-8].c); Free(yyvsp[-3].c);
    ;
    break;}
case 72:
#line 883 "Gmsh.y"
{
      double (*pNumOpt)(int num, int action, double value);
      StringXNumber *pNumCat;
      if(!(pNumCat = Get_NumberOptionCategory(yyvsp[-4].c)))
	yymsg(GERROR, "Unknown numeric option class '%s'", yyvsp[-4].c);
      else{
	if(!(pNumOpt =  (double (*) (int, int, double))Get_NumberOption(yyvsp[-2].c, pNumCat)))
	  yymsg(GERROR, "Unknown numeric option '%s.%s'", yyvsp[-4].c, yyvsp[-2].c);
	else
	  pNumOpt(0, GMSH_SET|GMSH_GUI, pNumOpt(0, GMSH_GET, 0)+yyvsp[-1].i);
      }
      Free(yyvsp[-4].c); Free(yyvsp[-2].c);
    ;
    break;}
case 73:
#line 897 "Gmsh.y"
{
      double (*pNumOpt)(int num, int action, double value);
      StringXNumber *pNumCat;
      if(!(pNumCat = Get_NumberOptionCategory(yyvsp[-7].c)))
	yymsg(GERROR, "Unknown numeric option class '%s'", yyvsp[-7].c);
      else{
	if(!(pNumOpt =  (double (*) (int, int, double))Get_NumberOption(yyvsp[-2].c, pNumCat)))
	  yymsg(GERROR, "Unknown numeric option '%s[%d].%s'", yyvsp[-7].c, (int)yyvsp[-5].d, yyvsp[-2].c);
	else
	  pNumOpt((int)yyvsp[-5].d, GMSH_SET|GMSH_GUI, pNumOpt((int)yyvsp[-5].d, GMSH_GET, 0)+yyvsp[-1].i);
      }
      Free(yyvsp[-7].c); Free(yyvsp[-2].c);
    ;
    break;}
case 74:
#line 914 "Gmsh.y"
{
      unsigned int (*pColOpt)(int num, int action, unsigned int value);
      StringXColor *pColCat;
      if(!(pColCat = Get_ColorOptionCategory(yyvsp[-7].c)))
	yymsg(GERROR, "Unknown color option class '%s'", yyvsp[-7].c);
      else{
	if(!(pColOpt =  (unsigned int (*) (int, int, unsigned int))Get_ColorOption(yyvsp[-3].c, pColCat)))
	  yymsg(GERROR, "Unknown color option '%s.Color.%s'", yyvsp[-7].c, yyvsp[-3].c);
	else
	  pColOpt(0, GMSH_SET|GMSH_GUI, yyvsp[-1].u);
      }
      Free(yyvsp[-7].c); Free(yyvsp[-3].c);
    ;
    break;}
case 75:
#line 928 "Gmsh.y"
{
      unsigned int (*pColOpt)(int num, int action, unsigned int value);
      StringXColor *pColCat;
      if(!(pColCat = Get_ColorOptionCategory(yyvsp[-10].c)))
	yymsg(GERROR, "Unknown color option class '%s'", yyvsp[-10].c);
      else{
	if(!(pColOpt =  (unsigned int (*) (int, int, unsigned int))Get_ColorOption(yyvsp[-3].c, pColCat)))
	  yymsg(GERROR, "Unknown color option '%s[%d].Color.%s'", yyvsp[-10].c, (int)yyvsp[-8].d, yyvsp[-3].c);
	else
	  pColOpt((int)yyvsp[-8].d, GMSH_SET|GMSH_GUI, yyvsp[-1].u);
      }
      Free(yyvsp[-10].c); Free(yyvsp[-3].c);
    ;
    break;}
case 76:
#line 945 "Gmsh.y"
{
      GmshColorTable *ct = Get_ColorTable(0);
      if(!ct)
	yymsg(GERROR, "View[%d] does not exist", 0);
      else{
	ct->size = List_Nbr(yyvsp[-1].l);
	if(ct->size > COLORTABLE_NBMAX_COLOR)
	  yymsg(GERROR, "Too many (%d>%d) colors in View[%d].ColorTable", 
		ct->size, COLORTABLE_NBMAX_COLOR, 0);
	else
	  for(int i = 0; i < ct->size; i++) List_Read(yyvsp[-1].l, i, &ct->table[i]);
	if(ct->size == 1){
	  ct->size = 2;
	  ct->table[1] = ct->table[0];
	}
      }
      Free(yyvsp[-5].c);
      List_Delete(yyvsp[-1].l);
    ;
    break;}
case 77:
#line 965 "Gmsh.y"
{
      GmshColorTable *ct = Get_ColorTable((int)yyvsp[-6].d);
      if(!ct)
	yymsg(GERROR, "View[%d] does not exist", (int)yyvsp[-6].d);
      else{
	ct->size = List_Nbr(yyvsp[-1].l);
	if(ct->size > COLORTABLE_NBMAX_COLOR)
	  yymsg(GERROR, "Too many (%d>%d) colors in View[%d].ColorTable", 
		   ct->size, COLORTABLE_NBMAX_COLOR, (int)yyvsp[-6].d);
	else
	  for(int i = 0; i < ct->size; i++) List_Read(yyvsp[-1].l, i, &ct->table[i]);
	if(ct->size == 1){
	  ct->size = 2;
	  ct->table[1] = ct->table[0];
	}
      }
      Free(yyvsp[-8].c);
      List_Delete(yyvsp[-1].l);
    ;
    break;}
case 78:
#line 988 "Gmsh.y"
{
      try {
	GMSH_PluginManager::instance()->setPluginOption(yyvsp[-6].c, yyvsp[-3].c, yyvsp[-1].d); 
      }
      catch (...) {
	yymsg(GERROR, "Unknown option '%s' or plugin '%s'", yyvsp[-3].c, yyvsp[-6].c);
      }
      Free(yyvsp[-6].c); Free(yyvsp[-3].c);
    ;
    break;}
case 79:
#line 998 "Gmsh.y"
{
      try {
	GMSH_PluginManager::instance()->setPluginOption(yyvsp[-6].c, yyvsp[-3].c, yyvsp[-1].c); 
      }
      catch (...) {
	yymsg(GERROR, "Unknown option '%s' or plugin '%s'", yyvsp[-3].c, yyvsp[-6].c);
      }
      Free(yyvsp[-6].c); Free(yyvsp[-3].c); // FIXME: sometimes leak $8
    ;
    break;}
case 80:
#line 1013 "Gmsh.y"
{ 
      yyval.i = (int)yyvsp[0].d; 
    ;
    break;}
case 81:
#line 1017 "Gmsh.y"
{ 
      yyval.i = GMODEL->setPhysicalName(std::string(yyvsp[0].c), ++THEM->MaxPhysicalNum);
      Free(yyvsp[0].c);
    ;
    break;}
case 82:
#line 1029 "Gmsh.y"
{
      int num = (int)yyvsp[-4].d;
      if(FindPoint(num)){
	yymsg(GERROR, "Point %d already exists", num);
      }
      else{
	double x = CTX.geom.scaling_factor * yyvsp[-1].v[0];
	double y = CTX.geom.scaling_factor * yyvsp[-1].v[1];
	double z = CTX.geom.scaling_factor * yyvsp[-1].v[2];
	double lc = CTX.geom.scaling_factor * yyvsp[-1].v[3];
	Vertex *v;
	if(!myGmshSurface)
	  v = Create_Vertex(num, x, y, z, lc, 1.0);
	else
	  v = Create_Vertex(num, x, y, myGmshSurface, lc);
	Tree_Add(THEM->Points, &v);
	AddToTemporaryBoundingBox(v->Pos.X, v->Pos.Y, v->Pos.Z);
      }
      yyval.s.Type = MSH_POINT;
      yyval.s.Num = num;
    ;
    break;}
case 83:
#line 1051 "Gmsh.y"
{
      int num = (int)yyvsp[-4].i;
      if(FindPhysicalGroup(num, MSH_PHYSICAL_POINT)){
	yymsg(GERROR, "Physical point %d already exists", num);
      }
      else{
	List_T *temp = ListOfDouble2ListOfInt(yyvsp[-1].l);
	PhysicalGroup *p = Create_PhysicalGroup(num, MSH_PHYSICAL_POINT, temp);
	List_Delete(temp);
	List_Add(THEM->PhysicalGroups, &p);
      }
      List_Delete(yyvsp[-1].l);
      yyval.s.Type = MSH_PHYSICAL_POINT;
      yyval.s.Num = num;
    ;
    break;}
case 84:
#line 1067 "Gmsh.y"
{
      double pars[] = { CTX.lc/10, CTX.lc/100., CTX.lc/20, 10, 3 };
      for(int i = 0; i < List_Nbr(yyvsp[-1].l); i++){
	if(i > 4) 
	  yymsg(GERROR, "Too many paramaters for attractor line (max = 5)");	  
	else
	  List_Read(yyvsp[-1].l, i, &pars[i]);
      }
      // treshold attractor: first parameter is the treshold, next two
      // are the in and out size fields, last is transition factor
      Attractor *att = tresholdAttractor::New(pars[0], pars[1], pars[2], pars[4]);
      for(int i = 0; i < List_Nbr(yyvsp[-3].l); i++){
	double d;
	List_Read(yyvsp[-3].l, i, &d);
	Vertex *v = FindPoint((int)d); 
	if(v)
	  att->addPoint(v->Pos.X, v->Pos.Y, v->Pos.Z);
	else{
	  GVertex *gv = GMODEL->vertexByTag((int)d);
	  if(gv) 
	    att->addPoint(gv->x(), gv->y(), gv->z());
	}
      }
      att->buildFastSearchStructures();
      // dummy values
      yyval.s.Type = 0;
      yyval.s.Num = 0;
    ;
    break;}
case 85:
#line 1096 "Gmsh.y"
{
      double pars[] = { CTX.lc/10, CTX.lc/100., CTX.lc/20, 10, 3 };
      for(int i = 0; i < List_Nbr(yyvsp[-1].l); i++){
	if(i > 4) 
	  yymsg(GERROR, "Too many paramaters for attractor line (max = 5)");	  
	else
	  List_Read(yyvsp[-1].l, i, &pars[i]);
      }
      // treshold attractor: first parameter is the treshold, next two
      // are the in and out size fields, last is transition factor
      Attractor *att = tresholdAttractor::New(pars[0], pars[1], pars[2], pars[4]);
      for(int i = 0; i < List_Nbr(yyvsp[-3].l); i++){
	double d;
	List_Read(yyvsp[-3].l, i, &d);
	Curve *c = FindCurve((int)d); 
	if(c){
	  buildListOfPoints(att, c, (int)pars[3]);
	}
	else{
	  GEdge *ge = GMODEL->edgeByTag((int)d);
	  if(ge){
	    buildListOfPoints(att, ge, (int)pars[3]);
	  }
	}
      }
      att->buildFastSearchStructures();
      // dummy values
      yyval.s.Type = 0;
      yyval.s.Num = 0;
    ;
    break;}
case 86:
#line 1127 "Gmsh.y"
{      
      for(int i = 0; i < List_Nbr(yyvsp[-3].l); i++){
	double d;
	List_Read(yyvsp[-3].l, i, &d);
	Vertex *v = FindPoint((int)d); 	 
	if(v)
	  v->lc = yyvsp[-1].d;
	else{
	  GVertex *gv = GMODEL->vertexByTag((int)d);
	  if(gv) 
	    gv->setPrescribedMeshSizeAtVertex(yyvsp[-1].d);
	}
      }
      List_Delete(yyvsp[-3].l);
      // dummy values
      yyval.s.Type = 0;
      yyval.s.Num = 0;
    ;
    break;}
case 87:
#line 1149 "Gmsh.y"
{
      int num = (int)yyvsp[-4].d;
      if(FindCurve(num)){
	yymsg(GERROR, "Curve %d already exists", num);
      }
      else{
	List_T *temp = ListOfDouble2ListOfInt(yyvsp[-1].l);
	Curve *c = Create_Curve(num, MSH_SEGM_LINE, 1, temp, NULL,
				-1, -1, 0., 1.);
	Tree_Add(THEM->Curves, &c);
	CreateReversedCurve(c);
	List_Delete(temp);
      }
      List_Delete(yyvsp[-1].l);
      yyval.s.Type = MSH_SEGM_LINE;
      yyval.s.Num = num;
    ;
    break;}
case 88:
#line 1167 "Gmsh.y"
{
      int num = (int)yyvsp[-4].d;
      if(FindCurve(num)){
	yymsg(GERROR, "Curve %d already exists", num);
      }
      else{
	List_T *temp = ListOfDouble2ListOfInt(yyvsp[-1].l);
	Curve *c = Create_Curve(num, MSH_SEGM_SPLN, 3, temp, NULL,
				-1, -1, 0., 1.);
	Tree_Add(THEM->Curves, &c);
	CreateReversedCurve(c);
	List_Delete(temp);
      }
      List_Delete(yyvsp[-1].l);
      yyval.s.Type = MSH_SEGM_SPLN;
      yyval.s.Num = num;
    ;
    break;}
case 89:
#line 1185 "Gmsh.y"
{
      int num = (int)yyvsp[-4].d;
      if(FindCurve(num)){
	yymsg(GERROR, "Curve %d already exists", num);
      }
      else{
	List_T *temp = ListOfDouble2ListOfInt(yyvsp[-1].l);
	Curve *c = Create_Curve(num, MSH_SEGM_CIRC, 2, temp, NULL,
				-1, -1, 0., 1.);
	Tree_Add(THEM->Curves, &c);
	CreateReversedCurve(c);
	List_Delete(temp);
      }
      List_Delete(yyvsp[-1].l);
      yyval.s.Type = MSH_SEGM_CIRC;
      yyval.s.Num = num;
    ;
    break;}
case 90:
#line 1203 "Gmsh.y"
{
      int num = (int)yyvsp[-6].d;
      if(FindCurve(num)){
	yymsg(GERROR, "Curve %d already exists", num);
      }
      else{
	List_T *temp = ListOfDouble2ListOfInt(yyvsp[-3].l);
	Curve *c = Create_Curve(num, MSH_SEGM_CIRC, 2, temp, NULL,
				-1, -1, 0., 1.);
	c->Circle.n[0] = yyvsp[-1].v[0];
	c->Circle.n[1] = yyvsp[-1].v[1];
	c->Circle.n[2] = yyvsp[-1].v[2];
	End_Curve(c);
	Tree_Add(THEM->Curves, &c);
	Curve *rc = CreateReversedCurve(c);
	rc->Circle.n[0] = yyvsp[-1].v[0];
	rc->Circle.n[1] = yyvsp[-1].v[1];
	rc->Circle.n[2] = yyvsp[-1].v[2];
	End_Curve(rc);
	List_Delete(temp);
      }
      List_Delete(yyvsp[-3].l);
      yyval.s.Type = MSH_SEGM_CIRC;
      yyval.s.Num = num;
    ;
    break;}
case 91:
#line 1229 "Gmsh.y"
{
      int num = (int)yyvsp[-4].d;
      if(FindCurve(num)){
	yymsg(GERROR, "Curve %d already exists", num);
      }
      else{
	List_T *temp = ListOfDouble2ListOfInt(yyvsp[-1].l);
	Curve *c = Create_Curve(num, MSH_SEGM_ELLI, 2, temp, NULL,
				-1, -1, 0., 1.);
	Tree_Add(THEM->Curves, &c);
	CreateReversedCurve(c);
	List_Delete(temp);
      }
      List_Delete(yyvsp[-1].l);
      yyval.s.Type = MSH_SEGM_ELLI;
      yyval.s.Num = num;
    ;
    break;}
case 92:
#line 1247 "Gmsh.y"
{
      int num = (int)yyvsp[-6].d;
      if(FindCurve(num)){
	yymsg(GERROR, "Curve %d already exists", num);
      }
      else{
	List_T *temp = ListOfDouble2ListOfInt(yyvsp[-3].l);
	Curve *c = Create_Curve(num, MSH_SEGM_ELLI, 2, temp, NULL,
				-1, -1, 0., 1.);
	c->Circle.n[0] = yyvsp[-1].v[0];
	c->Circle.n[1] = yyvsp[-1].v[1];
	c->Circle.n[2] = yyvsp[-1].v[2];
	End_Curve(c);
	Tree_Add(THEM->Curves, &c);
	Curve *rc = CreateReversedCurve(c);
	rc->Circle.n[0] = yyvsp[-1].v[0];
	rc->Circle.n[1] = yyvsp[-1].v[1];
	rc->Circle.n[2] = yyvsp[-1].v[2];
	End_Curve(c);
	List_Delete(temp);
      }
      List_Delete(yyvsp[-3].l);
      yyval.s.Type = MSH_SEGM_ELLI;
      yyval.s.Num = num;
    ;
    break;}
case 93:
#line 1274 "Gmsh.y"
{
      int num = (int)yyvsp[-14].d;
      if(FindCurve(num)){
	yymsg(GERROR, "Curve %d already exists", num);
      }
      else{
	Curve *c = Create_Curve(num, MSH_SEGM_PARAMETRIC, 2, NULL, NULL,
				-1, -1, yyvsp[-10].d, yyvsp[-8].d);
	strcpy(c->functu, yyvsp[-6].c);
	strcpy(c->functv, yyvsp[-4].c);
	strcpy(c->functw, yyvsp[-2].c);
	Tree_Add(THEM->Curves, &c);
	CreateReversedCurve(c);
      }
      Free(yyvsp[-6].c); Free(yyvsp[-4].c); Free(yyvsp[-2].c);
      yyval.s.Type = MSH_SEGM_PARAMETRIC;
      yyval.s.Num = num;
    ;
    break;}
case 94:
#line 1293 "Gmsh.y"
{
      int num = (int)yyvsp[-4].d;
      if(List_Nbr(yyvsp[-1].l) < 4){
	yymsg(GERROR, "Too few control points for BSpline %d (%d < 4)", num,
	      List_Nbr(yyvsp[-1].l));
      }
      else{
	if(FindCurve(num)){
	  yymsg(GERROR, "Curve %d already exists", num);
	}
	else{
	  List_T *temp = ListOfDouble2ListOfInt(yyvsp[-1].l);
	  Curve *c = Create_Curve(num, MSH_SEGM_BSPLN, 2, temp, NULL,
				  -1, -1, 0., 1.);
	  Tree_Add(THEM->Curves, &c);
	  CreateReversedCurve(c);
	  List_Delete(temp);
	}
      }
      List_Delete(yyvsp[-1].l);
      yyval.s.Type = MSH_SEGM_BSPLN;
      yyval.s.Num = num;
    ;
    break;}
case 95:
#line 1317 "Gmsh.y"
{
      int num = (int)yyvsp[-4].d;
      if(List_Nbr(yyvsp[-1].l) < 4){
	yymsg(GERROR, "Too few control points for Bezier curve %d (%d < 4)", num,
	      List_Nbr(yyvsp[-1].l));
      }
      else{
	if(FindCurve(num)){
	  yymsg(GERROR, "Curve %d already exists", num);
	}
	else{
	  List_T *temp = ListOfDouble2ListOfInt(yyvsp[-1].l);
	  Curve *c = Create_Curve(num, MSH_SEGM_BEZIER, 2, temp, NULL,
				  -1, -1, 0., 1.);
	  Tree_Add(THEM->Curves, &c);
	  CreateReversedCurve(c);
	  List_Delete(temp);
	}
      }
      List_Delete(yyvsp[-1].l);
      yyval.s.Type = MSH_SEGM_BEZIER;
      yyval.s.Num = num;
    ;
    break;}
case 96:
#line 1341 "Gmsh.y"
{
      int num = (int)yyvsp[-8].d;
      if(List_Nbr(yyvsp[-5].l) + (int)yyvsp[-1].d + 1 != List_Nbr(yyvsp[-3].l)){
	yymsg(GERROR, "Wrong definition of Nurbs Curve %d: "
	      "got %d knots, need N + D + 1 = %d + %d + 1 = %d",
	      (int)yyvsp[-8].d, List_Nbr(yyvsp[-3].l), List_Nbr(yyvsp[-5].l), (int)yyvsp[-1].d, List_Nbr(yyvsp[-5].l) + (int)yyvsp[-1].d + 1);
      }
      else{
	if(FindCurve(num)){
	  yymsg(GERROR, "Curve %d already exists", num);
	}
	else{
	  List_T *temp = ListOfDouble2ListOfInt(yyvsp[-5].l);
	  Curve *c = Create_Curve(num, MSH_SEGM_NURBS, (int)yyvsp[-1].d, temp, yyvsp[-3].l,
				  -1, -1, 0., 1.);
	  Tree_Add(THEM->Curves, &c);
	  CreateReversedCurve(c);
	  List_Delete(temp);
	}
      }
      List_Delete(yyvsp[-5].l);
      List_Delete(yyvsp[-3].l);
      yyval.s.Type = MSH_SEGM_NURBS;
      yyval.s.Num = num;
    ;
    break;}
case 97:
#line 1367 "Gmsh.y"
{
      int num = (int)yyvsp[-4].d;
      if(FindEdgeLoop(num)){
	yymsg(GERROR, "Line loop %d already exists", num);
      }
      else{
	List_T *temp = ListOfDouble2ListOfInt(yyvsp[-1].l);
	sortEdgesInLoop(num, temp);
	EdgeLoop *l = Create_EdgeLoop(num, temp);
	Tree_Add(THEM->EdgeLoops, &l);
	List_Delete(temp);
      }
      List_Delete(yyvsp[-1].l);
      yyval.s.Type = MSH_SEGM_LOOP;
      yyval.s.Num = num;
    ;
    break;}
case 98:
#line 1384 "Gmsh.y"
{
      int num = (int)yyvsp[-4].i;
      if(FindPhysicalGroup(num, MSH_PHYSICAL_LINE)){
	yymsg(GERROR, "Physical line %d already exists", num);
      }
      else{
	List_T *temp = ListOfDouble2ListOfInt(yyvsp[-1].l);
	PhysicalGroup *p = Create_PhysicalGroup(num, MSH_PHYSICAL_LINE, temp);
	List_Delete(temp);
	List_Add(THEM->PhysicalGroups, &p);
      }
      List_Delete(yyvsp[-1].l);
      yyval.s.Type = MSH_PHYSICAL_LINE;
      yyval.s.Num = num;
    ;
    break;}
case 99:
#line 1403 "Gmsh.y"
{
      int num = (int)yyvsp[-4].d;
      if(FindSurface(num)){
	yymsg(GERROR, "Surface %d already exists", num);
      }
      else{
	Surface *s = Create_Surface(num, MSH_SURF_PLAN);
	List_T *temp = ListOfDouble2ListOfInt(yyvsp[-1].l);
	setSurfaceGeneratrices(s, temp);
	List_Delete(temp);
	End_Surface(s);
	Tree_Add(THEM->Surfaces, &s);
      }
      List_Delete(yyvsp[-1].l);
      yyval.s.Type = MSH_SURF_PLAN;
      yyval.s.Num = num;
    ;
    break;}
case 100:
#line 1421 "Gmsh.y"
{
      int num = (int)yyvsp[-4].d, type = 0;
      if(FindSurface(num)){
	yymsg(GERROR, "Surface %d already exists", num);
      }
      else{
	double d;
	List_Read(yyvsp[-1].l, 0, &d);
	EdgeLoop *el = FindEdgeLoop((int)fabs(d));
	if(!el){
	  yymsg(GERROR, "Unknown line loop %d", (int)d);
	}
	else{
	  int j = List_Nbr(el->Curves);
	  if(j == 4){
	    type = MSH_SURF_REGL;
	  }
	  else if(j == 3){
	    type = MSH_SURF_TRIC;
	  }
	  else{
	    yymsg(GERROR, "Wrong definition of Ruled Surface %d: "
		  "%d borders instead of 3 or 4", num, j);
	    type = MSH_SURF_PLAN;
	  }
	  Surface *s = Create_Surface(num, type);
	  List_T *temp = ListOfDouble2ListOfInt(yyvsp[-1].l);
	  setSurfaceGeneratrices(s, temp);
	  List_Delete(temp);
	  End_Surface(s);
	  Tree_Add(THEM->Surfaces, &s);
	}
      }
      List_Delete(yyvsp[-1].l);
      yyval.s.Type = type;
      yyval.s.Num = num;
    ;
    break;}
case 101:
#line 1460 "Gmsh.y"
{
    myGmshSurface = 0;
  ;
    break;}
case 102:
#line 1465 "Gmsh.y"
{
    myGmshSurface = gmshSurface :: surfaceByTag ( (int) yyvsp[-1].d);
  ;
    break;}
case 103:
#line 1470 "Gmsh.y"
{
    int num = (int)yyvsp[-6].d, type = 0;
    myGmshSurface = gmshParametricSurface::NewParametricSurface ((int)yyvsp[-6].d,yyvsp[-3].c,yyvsp[-2].c,yyvsp[-1].c);
  ;
    break;}
case 104:
#line 1476 "Gmsh.y"
{
      int num = (int)yyvsp[-4].d, type = 0;
      if (List_Nbr(yyvsp[-1].l) != 2){
	yymsg(GERROR, "Sphere %d has to be defined using 2 points (center + "
	      "any point) and not %d", num, List_Nbr(yyvsp[-1].l));
      }
      else{
	double p1,p2;
	List_Read(yyvsp[-1].l, 0, &p1);
	List_Read(yyvsp[-1].l, 1, &p2);
	Vertex *v1 = FindPoint((int)p1);
	Vertex *v2 = FindPoint((int)p2);
	if(!v1) yymsg(GERROR, "Sphere %d : unknown point %d", num, (int)p1);
	if(!v2) yymsg(GERROR, "Sphere %d : unknown point %d", num, (int)p2);
	myGmshSurface = gmshSphere::NewSphere
	  (num, v1->Pos.X, v1->Pos.Y, v1->Pos.Z,
	   sqrt((v2->Pos.X - v1->Pos.X) * (v2->Pos.X - v1->Pos.X) +
		(v2->Pos.Y - v1->Pos.Y) * (v2->Pos.Y - v1->Pos.Y) +
		(v2->Pos.Z - v1->Pos.Z) * (v2->Pos.Z - v1->Pos.Z)));
      }      
    ;
    break;}
case 105:
#line 1498 "Gmsh.y"
{
      int num = (int)yyvsp[-4].d, type = 0;
      if (List_Nbr(yyvsp[-1].l) != 2){
	yymsg(GERROR, "PolarSphere %d has to be defined using 2 points (center + "
	      "any point) and not %d", num, List_Nbr(yyvsp[-1].l));
      }
      else{
	double p1,p2;
	List_Read(yyvsp[-1].l, 0, &p1);
	List_Read(yyvsp[-1].l, 1, &p2);
	Vertex *v1 = FindPoint((int)p1);
	Vertex *v2 = FindPoint((int)p2);
	if(!v1) yymsg(GERROR, "PolarSphere %d : unknown point %d", num, (int)p1);
	if(!v2) yymsg(GERROR, "PolarSphere %d : unknown point %d", num, (int)p2);
	myGmshSurface = gmshPolarSphere::NewPolarSphere
	  (num, v1->Pos.X, v1->Pos.Y, v1->Pos.Z,
	   sqrt((v2->Pos.X - v1->Pos.X) * (v2->Pos.X - v1->Pos.X) +
		(v2->Pos.Y - v1->Pos.Y) * (v2->Pos.Y - v1->Pos.Y) +
		(v2->Pos.Z - v1->Pos.Z) * (v2->Pos.Z - v1->Pos.Z)));
      }      
    ;
    break;}
case 106:
#line 1520 "Gmsh.y"
{
      int num = (int)yyvsp[-4].d;
      if(FindSurfaceLoop(num)){
	yymsg(GERROR, "Surface loop %d already exists", num);
      }
      else{
	List_T *temp = ListOfDouble2ListOfInt(yyvsp[-1].l);
	SurfaceLoop *l = Create_SurfaceLoop(num, temp);
	Tree_Add(THEM->SurfaceLoops, &l);
	List_Delete(temp);
      }
      List_Delete(yyvsp[-1].l);
      yyval.s.Type = MSH_SURF_LOOP;
      yyval.s.Num = num;
    ;
    break;}
case 107:
#line 1536 "Gmsh.y"
{
      int num = (int)yyvsp[-4].i;
      if(FindPhysicalGroup(num, MSH_PHYSICAL_SURFACE)){
	yymsg(GERROR, "Physical surface %d already exists", num);
      }
      else{
	List_T *temp = ListOfDouble2ListOfInt(yyvsp[-1].l);
	PhysicalGroup *p = Create_PhysicalGroup(num, MSH_PHYSICAL_SURFACE, temp);
	List_Delete(temp);
	List_Add(THEM->PhysicalGroups, &p);
      }
      List_Delete(yyvsp[-1].l);
      yyval.s.Type = MSH_PHYSICAL_SURFACE;
      yyval.s.Num = num;
    ;
    break;}
case 108:
#line 1556 "Gmsh.y"
{
      int num = (int)yyvsp[-4].d;
      if(FindVolume(num)){
	yymsg(GERROR, "Volume %d already exists", num);
      }
      else{
	Volume *v = Create_Volume(num, MSH_VOLUME);
	List_T *temp = ListOfDouble2ListOfInt(yyvsp[-1].l);
	setVolumeSurfaces(v, temp);
	List_Delete(temp);
	Tree_Add(THEM->Volumes, &v);
      }
      List_Delete(yyvsp[-1].l);
      yyval.s.Type = MSH_VOLUME;
      yyval.s.Num = num;
    ;
    break;}
case 109:
#line 1573 "Gmsh.y"
{
      int num = (int)yyvsp[-4].d;
      if(FindVolume(num)){
	yymsg(GERROR, "Volume %d already exists", num);
      }
      else{
	Volume *v = Create_Volume(num, MSH_VOLUME);
	List_T *temp = ListOfDouble2ListOfInt(yyvsp[-1].l);
	setVolumeSurfaces(v, temp);
	List_Delete(temp);
	Tree_Add(THEM->Volumes, &v);
      }
      List_Delete(yyvsp[-1].l);
      yyval.s.Type = MSH_VOLUME;
      yyval.s.Num = num;
    ;
    break;}
case 110:
#line 1590 "Gmsh.y"
{
      int num = (int)yyvsp[-4].i;
      if(FindPhysicalGroup(num, MSH_PHYSICAL_VOLUME)){
	yymsg(GERROR, "Physical volume %d already exists", num);
      }
      else{
	List_T *temp = ListOfDouble2ListOfInt(yyvsp[-1].l);
	PhysicalGroup *p = Create_PhysicalGroup(num, MSH_PHYSICAL_VOLUME, temp);
	List_Delete(temp);
	List_Add(THEM->PhysicalGroups, &p);
      }
      List_Delete(yyvsp[-1].l);
      yyval.s.Type = MSH_PHYSICAL_VOLUME;
      yyval.s.Num = num;
    ;
    break;}
case 111:
#line 1611 "Gmsh.y"
{
      TranslateShapes(yyvsp[-3].v[0], yyvsp[-3].v[1], yyvsp[-3].v[2], yyvsp[-1].l);
      yyval.l = yyvsp[-1].l;
    ;
    break;}
case 112:
#line 1616 "Gmsh.y"
{
      RotateShapes(yyvsp[-8].v[0], yyvsp[-8].v[1], yyvsp[-8].v[2], yyvsp[-6].v[0], yyvsp[-6].v[1], yyvsp[-6].v[2], yyvsp[-4].d, yyvsp[-1].l);
      yyval.l = yyvsp[-1].l;
    ;
    break;}
case 113:
#line 1621 "Gmsh.y"
{
      SymmetryShapes(yyvsp[-3].v[0], yyvsp[-3].v[1], yyvsp[-3].v[2], yyvsp[-3].v[3], yyvsp[-1].l);
      yyval.l = yyvsp[-1].l;
    ;
    break;}
case 114:
#line 1626 "Gmsh.y"
{
      DilatShapes(yyvsp[-6].v[0], yyvsp[-6].v[1], yyvsp[-6].v[2], yyvsp[-4].d, yyvsp[-1].l);
      yyval.l = yyvsp[-1].l;
    ;
    break;}
case 115:
#line 1633 "Gmsh.y"
{ yyval.l = yyvsp[0].l; ;
    break;}
case 116:
#line 1634 "Gmsh.y"
{ yyval.l = yyvsp[0].l; ;
    break;}
case 117:
#line 1635 "Gmsh.y"
{ yyval.l = yyvsp[0].l; ;
    break;}
case 118:
#line 1640 "Gmsh.y"
{
      yyval.l = List_Create(3, 3, sizeof(Shape));
    ;
    break;}
case 119:
#line 1644 "Gmsh.y"
{
      List_Add(yyval.l, &yyvsp[0].s);
    ;
    break;}
case 120:
#line 1648 "Gmsh.y"
{
      for(int i = 0; i < List_Nbr(yyvsp[-2].l); i++){
	double d;
	List_Read(yyvsp[-2].l, i, &d);
	Shape TheShape;
	TheShape.Num = (int)d;
	Vertex *v = FindPoint(TheShape.Num);
	if(v){
	  TheShape.Type = MSH_POINT;
	  List_Add(yyval.l, &TheShape);
	}
	else{
	  GVertex *gv = GMODEL->vertexByTag(TheShape.Num);
	  if(gv){
	    TheShape.Type = MSH_POINT_FROM_GMODEL;
	    List_Add(yyval.l, &TheShape);
	  }
	  else
	    yymsg(WARNING, "Unknown point %d", TheShape.Num);
	}
      }
    ;
    break;}
case 121:
#line 1671 "Gmsh.y"
{
      for(int i = 0; i < List_Nbr(yyvsp[-2].l); i++){
	double d;
	List_Read(yyvsp[-2].l, i, &d);
	Shape TheShape;
	TheShape.Num = (int)d;
	Curve *c = FindCurve(TheShape.Num);
	if(c){
	  TheShape.Type = c->Typ;
	  List_Add(yyval.l, &TheShape);
	}
	else{
	  GEdge *ge = GMODEL->edgeByTag(TheShape.Num);
	  if(ge){
	    TheShape.Type = MSH_SEGM_FROM_GMODEL;
	    List_Add(yyval.l, &TheShape);
	  }
	  else
	    yymsg(WARNING, "Unknown curve %d", TheShape.Num);
	}
      }
    ;
    break;}
case 122:
#line 1694 "Gmsh.y"
{
      for(int i = 0; i < List_Nbr(yyvsp[-2].l); i++){
	double d;
	List_Read(yyvsp[-2].l, i, &d);
	Shape TheShape;
	TheShape.Num = (int)d;
	Surface *s = FindSurface(TheShape.Num);
	if(s){
	  TheShape.Type = s->Typ;
	  List_Add(yyval.l, &TheShape);
	}
	else{
	  GFace *gf = GMODEL->faceByTag(TheShape.Num);
	  if(gf){
	    TheShape.Type = MSH_SURF_FROM_GMODEL;
	    List_Add(yyval.l, &TheShape);
	  }
	  else
	    yymsg(WARNING, "Unknown surface %d", TheShape.Num);
	}
      }
    ;
    break;}
case 123:
#line 1717 "Gmsh.y"
{
      for(int i = 0; i < List_Nbr(yyvsp[-2].l); i++){
	double d;
	List_Read(yyvsp[-2].l, i, &d);
	Shape TheShape;
	TheShape.Num = (int)d;
	Volume *v = FindVolume(TheShape.Num);
	if(v){
	  TheShape.Type = v->Typ;
	  List_Add(yyval.l, &TheShape);
	}
	else{
	  GRegion *gr = GMODEL->regionByTag(TheShape.Num);
	  if(gr){
	    TheShape.Type = MSH_VOLUME_FROM_GMODEL;
	    List_Add(yyval.l, &TheShape);
	  }
	  else
	    yymsg(WARNING, "Unknown volume %d", TheShape.Num);
	}
      }
    ;
    break;}
case 124:
#line 1745 "Gmsh.y"
{
      yyval.l = List_Create(3, 3, sizeof(Shape));
      for(int i = 0; i < List_Nbr(yyvsp[-1].l); i++){
	Shape TheShape;
	List_Read(yyvsp[-1].l, i, &TheShape);
	CopyShape(TheShape.Type, TheShape.Num, &TheShape.Num);
	List_Add(yyval.l, &TheShape);
      }
      List_Delete(yyvsp[-1].l);
    ;
    break;}
case 125:
#line 1757 "Gmsh.y"
{
      if(!strcmp(yyvsp[-4].c, "View")) AliasView((int)yyvsp[-2].d, 0);
      Free(yyvsp[-4].c);
      yyval.l = NULL;
    ;
    break;}
case 126:
#line 1763 "Gmsh.y"
{
      if(!strcmp(yyvsp[-4].c, "View")) AliasView((int)yyvsp[-2].d, 0);
      Free(yyvsp[-4].c);
      yyval.l = NULL;
    ;
    break;}
case 127:
#line 1769 "Gmsh.y"
{
      if(!strcmp(yyvsp[-4].c, "View")) AliasView((int)yyvsp[-2].d, 1);
      Free(yyvsp[-4].c);
      yyval.l = NULL;
    ;
    break;}
case 128:
#line 1781 "Gmsh.y"
{
      for(int i = 0; i < List_Nbr(yyvsp[-1].l); i++){
	Shape TheShape;
	List_Read(yyvsp[-1].l, i, &TheShape);
	DeleteShape(TheShape.Type, TheShape.Num);
      }
      List_Delete(yyvsp[-1].l);
    ;
    break;}
case 129:
#line 1790 "Gmsh.y"
{
      if(!strcmp(yyvsp[-4].c, "View")){
	RemoveViewByIndex((int)yyvsp[-2].d);
      }
      else{
	yymsg(GERROR, "Unknown command 'Delete %s'", yyvsp[-4].c);
      }
      Free(yyvsp[-4].c);
    ;
    break;}
case 130:
#line 1800 "Gmsh.y"
{
      if(!strcmp(yyvsp[-1].c, "Meshes") || !strcmp(yyvsp[-1].c, "All")){
	GMODEL->destroy();
	THEM->destroy();
      }
      else if(!strcmp(yyvsp[-1].c, "Physicals")){
	List_Action(THEM->PhysicalGroups, Free_PhysicalGroup);
	List_Reset(THEM->PhysicalGroups);
	GMODEL->deletePhysicalGroups();
      }
      else{
	yymsg(GERROR, "Unknown command 'Delete %s'", yyvsp[-1].c);
      }
      Free(yyvsp[-1].c);
    ;
    break;}
case 131:
#line 1816 "Gmsh.y"
{
      if(!strcmp(yyvsp[-2].c, "Empty") && !strcmp(yyvsp[-1].c, "Views")){
	for(int i = List_Nbr(CTX.post.list) - 1; i >= 0; i--){
	  Post_View *v = *(Post_View **) List_Pointer(CTX.post.list, i);
	  if(v->empty())
	    RemoveViewByIndex(i);
	}
      }
      else{
	yymsg(GERROR, "Unknown command 'Delete %s %s'", yyvsp[-2].c, yyvsp[-1].c);
      }
      Free(yyvsp[-2].c); Free(yyvsp[-1].c);
    ;
    break;}
case 132:
#line 1835 "Gmsh.y"
{
      for(int i = 0; i < List_Nbr(yyvsp[-1].l); i++){
	Shape TheShape;
	List_Read(yyvsp[-1].l, i, &TheShape);
	ColorShape(TheShape.Type, TheShape.Num, yyvsp[-3].u);
      }
      List_Delete(yyvsp[-1].l);      
    ;
    break;}
case 133:
#line 1849 "Gmsh.y"
{
      for(int i = 0; i < 4; i++)
	VisibilityShape(yyvsp[-1].c, i, 1);
      Free(yyvsp[-1].c);
    ;
    break;}
case 134:
#line 1855 "Gmsh.y"
{
      for(int i = 0; i < 4; i++)
	VisibilityShape(yyvsp[-1].c, i, 0);
      Free(yyvsp[-1].c);
    ;
    break;}
case 135:
#line 1861 "Gmsh.y"
{
      for(int i = 0; i < List_Nbr(yyvsp[-1].l); i++){
	Shape TheShape;
	List_Read(yyvsp[-1].l, i, &TheShape);
	VisibilityShape(TheShape.Type, TheShape.Num, 1);
      }
      List_Delete(yyvsp[-1].l);
    ;
    break;}
case 136:
#line 1870 "Gmsh.y"
{
      for(int i = 0; i < List_Nbr(yyvsp[-1].l); i++){
	Shape TheShape;
	List_Read(yyvsp[-1].l, i, &TheShape);
	VisibilityShape(TheShape.Type, TheShape.Num, 0);
      }
      List_Delete(yyvsp[-1].l);
    ;
    break;}
case 137:
#line 1884 "Gmsh.y"
{
      if(!strcmp(yyvsp[-2].c, "Include")){
	char tmpstring[1024];
	FixRelativePath(yyvsp[-1].c, tmpstring);
	// Warning: we *don't* close included files (to allow user
	// functions in these files). If you need to include many many
	// files and don't have functions in the files, use "Merge"
	// instead: some OSes limit the number of files a process can
	// open simultaneously. The right solution would be of course
	// to modify FunctionManager to reopen the files instead of
	// using the FILE pointer, but hey, I'm lazy...
	Msg(STATUS2, "Reading '%s'", tmpstring);
	ParseFile(tmpstring, 0, 1);
	SetBoundingBox();
	Msg(STATUS2, "Read '%s'", tmpstring);
      }
      else if(!strcmp(yyvsp[-2].c, "Print")){
#if defined(HAVE_FLTK)
	// make sure we have the latest data from THEM in GModel
	// (fixes bug where we would have no geometry in the picture if
	// the print command is in the same file as the geometry)
	GMODEL->importTHEM();
	char tmpstring[1024];
	FixRelativePath(yyvsp[-1].c, tmpstring);
	CreateOutputFile(tmpstring, CTX.print.format);
#endif
      }
      else if(!strcmp(yyvsp[-2].c, "Save")){
#if defined(HAVE_FLTK)
	GMODEL->importTHEM();
	char tmpstring[1024];
	FixRelativePath(yyvsp[-1].c, tmpstring);
	CreateOutputFile(tmpstring, CTX.mesh.format);
#endif
      }
      else if(!strcmp(yyvsp[-2].c, "Merge") || !strcmp(yyvsp[-2].c, "MergeWithBoundingBox")){
	// MergeWithBoundingBox is deprecated
	char tmpstring[1024];
	FixRelativePath(yyvsp[-1].c, tmpstring);
	MergeFile(tmpstring, 1);
      }
      else if(!strcmp(yyvsp[-2].c, "System")){
	SystemCall(yyvsp[-1].c);
      }
      else{
	yymsg(GERROR, "Unknown command '%s'", yyvsp[-2].c);
      }
      Free(yyvsp[-2].c); Free(yyvsp[-1].c);
    ;
    break;}
case 138:
#line 1934 "Gmsh.y"
{
      if(!strcmp(yyvsp[-6].c, "Save") && !strcmp(yyvsp[-5].c, "View")){
	Post_View **vv = (Post_View **)List_Pointer_Test(CTX.post.list, (int)yyvsp[-3].d);
	if(vv){
	  char tmpstring[1024];
	  FixRelativePath(yyvsp[-1].c, tmpstring);
	  WriteView(*vv, tmpstring, CTX.post.file_format, 0);
	}
      }
      else{
	yymsg(GERROR, "Unknown command '%s'", yyvsp[-6].c);
      }
      Free(yyvsp[-6].c); Free(yyvsp[-5].c); Free(yyvsp[-1].c);
    ;
    break;}
case 139:
#line 1949 "Gmsh.y"
{
      if(!strcmp(yyvsp[-6].c, "Background") && !strcmp(yyvsp[-5].c, "Mesh")  && !strcmp(yyvsp[-4].c, "View")){
	Post_View **vv = (Post_View **)List_Pointer_Test(CTX.post.list, (int)yyvsp[-2].d);
	if(vv) BGMWithView(*vv);
      }
      else{
	yymsg(GERROR, "Unknown command '%s'", yyvsp[-6].c);
      }
      Free(yyvsp[-6].c); Free(yyvsp[-5].c); Free(yyvsp[-4].c);
    ;
    break;}
case 140:
#line 1960 "Gmsh.y"
{
      if(!strcmp(yyvsp[-2].c, "Sleep")){
	SleepInSeconds(yyvsp[-1].d);
      }
      else if(!strcmp(yyvsp[-2].c, "Remesh")){
	Msg(GERROR, "Surface ReMeshing must be reinterfaced");
	//	ReMesh();
      }
      else if(!strcmp(yyvsp[-2].c, "Mesh")){
	yymsg(GERROR, "Mesh directives are not (yet) allowed in scripts");
      }
      else if(!strcmp(yyvsp[-2].c, "Status")){
	yymsg(GERROR, "Mesh directives are not (yet) allowed in scripts");
      }
      else{
	yymsg(GERROR, "Unknown command '%s'", yyvsp[-2].c);
      }
      Free(yyvsp[-2].c);
    ;
    break;}
case 141:
#line 1980 "Gmsh.y"
{
       try {
	 GMSH_PluginManager::instance()->action(yyvsp[-4].c, yyvsp[-1].c, 0);
       }
       catch(...) {
	 yymsg(GERROR, "Unknown action '%s' or plugin '%s'", yyvsp[-1].c, yyvsp[-4].c);
       }
       Free(yyvsp[-4].c); Free(yyvsp[-1].c);
     ;
    break;}
case 142:
#line 1990 "Gmsh.y"
{
      if(!strcmp(yyvsp[-1].c, "ElementsFromAllViews"))
	CombineViews(0, 1, CTX.post.combine_remove_orig);
      else if(!strcmp(yyvsp[-1].c, "ElementsFromVisibleViews"))
	CombineViews(0, 0, CTX.post.combine_remove_orig);
      else if(!strcmp(yyvsp[-1].c, "ElementsByViewName"))
	CombineViews(0, 2, CTX.post.combine_remove_orig);
      else if(!strcmp(yyvsp[-1].c, "TimeStepsFromAllViews"))
	CombineViews(1, 1, CTX.post.combine_remove_orig);
      else if(!strcmp(yyvsp[-1].c, "TimeStepsFromVisibleViews"))
	CombineViews(1, 0, CTX.post.combine_remove_orig);
      else if(!strcmp(yyvsp[-1].c, "TimeStepsByViewName"))
	CombineViews(1, 2, CTX.post.combine_remove_orig);
      else if(!strcmp(yyvsp[-1].c, "Views"))
	CombineViews(0, 1, CTX.post.combine_remove_orig);
      else if(!strcmp(yyvsp[-1].c, "TimeSteps"))
	CombineViews(1, 2, CTX.post.combine_remove_orig);
      else
	yymsg(GERROR, "Unknown 'Combine' command");
      Free(yyvsp[-1].c);
    ;
    break;}
case 143:
#line 2012 "Gmsh.y"
{
      exit(0);
    ;
    break;}
case 144:
#line 2016 "Gmsh.y"
{
      CTX.forced_bbox = 0;
      SetBoundingBox();
    ;
    break;}
case 145:
#line 2021 "Gmsh.y"
{
      CTX.forced_bbox = 1;
      SetBoundingBox(yyvsp[-12].d, yyvsp[-10].d, yyvsp[-8].d, yyvsp[-6].d, yyvsp[-4].d, yyvsp[-2].d);
    ;
    break;}
case 146:
#line 2026 "Gmsh.y"
{
#if defined(HAVE_FLTK)
      Draw();
#endif
    ;
    break;}
case 147:
#line 2038 "Gmsh.y"
{
      LoopControlVariablesTab[ImbricatedLoop][0] = yyvsp[-3].d;
      LoopControlVariablesTab[ImbricatedLoop][1] = yyvsp[-1].d;
      LoopControlVariablesTab[ImbricatedLoop][2] = 1.0;
      LoopControlVariablesNameTab[ImbricatedLoop] = NULL;
      fgetpos(yyin, &yyposImbricatedLoopsTab[ImbricatedLoop]);
      yylinenoImbricatedLoopsTab[ImbricatedLoop] = yylineno;
      ImbricatedLoop++;
      if(ImbricatedLoop > MAX_RECUR_LOOPS-1){
	yymsg(GERROR, "Reached maximum number of imbricated loops");
	ImbricatedLoop = MAX_RECUR_LOOPS-1;
      }
      if(yyvsp[-3].d > yyvsp[-1].d) skip_until("For", "EndFor");
    ;
    break;}
case 148:
#line 2053 "Gmsh.y"
{
      LoopControlVariablesTab[ImbricatedLoop][0] = yyvsp[-5].d;
      LoopControlVariablesTab[ImbricatedLoop][1] = yyvsp[-3].d;
      LoopControlVariablesTab[ImbricatedLoop][2] = yyvsp[-1].d;
      LoopControlVariablesNameTab[ImbricatedLoop] = NULL;
      fgetpos(yyin, &yyposImbricatedLoopsTab[ImbricatedLoop]);
      yylinenoImbricatedLoopsTab[ImbricatedLoop] = yylineno;
      ImbricatedLoop++;
      if(ImbricatedLoop > MAX_RECUR_LOOPS-1){
	yymsg(GERROR, "Reached maximum number of imbricated loops");
	ImbricatedLoop = MAX_RECUR_LOOPS-1;
      }
      if((yyvsp[-1].d > 0. && yyvsp[-5].d > yyvsp[-3].d) || (yyvsp[-1].d < 0. && yyvsp[-5].d < yyvsp[-3].d))
	skip_until("For", "EndFor");
    ;
    break;}
case 149:
#line 2069 "Gmsh.y"
{
      LoopControlVariablesTab[ImbricatedLoop][0] = yyvsp[-3].d;
      LoopControlVariablesTab[ImbricatedLoop][1] = yyvsp[-1].d;
      LoopControlVariablesTab[ImbricatedLoop][2] = 1.0;
      LoopControlVariablesNameTab[ImbricatedLoop] = yyvsp[-6].c;
      Symbol TheSymbol;      
      TheSymbol.Name = yyvsp[-6].c;
      Symbol *pSymbol;
      if(!(pSymbol = (Symbol*)Tree_PQuery(Symbol_T, &TheSymbol))){
	TheSymbol.val = List_Create(1, 1, sizeof(double));
	List_Put(TheSymbol.val, 0, &yyvsp[-3].d);
	Tree_Add(Symbol_T, &TheSymbol);
      }
      else{
	List_Write(pSymbol->val, 0, &yyvsp[-3].d);
      }
      fgetpos(yyin, &yyposImbricatedLoopsTab[ImbricatedLoop]);
      yylinenoImbricatedLoopsTab[ImbricatedLoop] = yylineno;
      ImbricatedLoop++;
      if(ImbricatedLoop > MAX_RECUR_LOOPS-1){
	yymsg(GERROR, "Reached maximum number of imbricated loops");
	ImbricatedLoop = MAX_RECUR_LOOPS-1;
      }
      if(yyvsp[-3].d > yyvsp[-1].d) skip_until("For", "EndFor");
    ;
    break;}
case 150:
#line 2095 "Gmsh.y"
{
      LoopControlVariablesTab[ImbricatedLoop][0] = yyvsp[-5].d;
      LoopControlVariablesTab[ImbricatedLoop][1] = yyvsp[-3].d;
      LoopControlVariablesTab[ImbricatedLoop][2] = yyvsp[-1].d;
      LoopControlVariablesNameTab[ImbricatedLoop] = yyvsp[-8].c;
      Symbol TheSymbol;
      TheSymbol.Name = yyvsp[-8].c;
      Symbol *pSymbol;
      if(!(pSymbol = (Symbol*)Tree_PQuery(Symbol_T, &TheSymbol))){
	TheSymbol.val = List_Create(1, 1, sizeof(double));
	List_Put(TheSymbol.val, 0, &yyvsp[-5].d);
	Tree_Add(Symbol_T, &TheSymbol);
      }
      else{
	List_Write(pSymbol->val, 0, &yyvsp[-5].d);
      }
      fgetpos(yyin, &yyposImbricatedLoopsTab[ImbricatedLoop]);
      yylinenoImbricatedLoopsTab[ImbricatedLoop] = yylineno;
      ImbricatedLoop++;
      if(ImbricatedLoop > MAX_RECUR_LOOPS-1){
	yymsg(GERROR, "Reached maximum number of imbricated loops");
	ImbricatedLoop = MAX_RECUR_LOOPS-1;
      }
      if((yyvsp[-1].d > 0. && yyvsp[-5].d > yyvsp[-3].d) || (yyvsp[-1].d < 0. && yyvsp[-5].d < yyvsp[-3].d))
	skip_until("For", "EndFor");
    ;
    break;}
case 151:
#line 2122 "Gmsh.y"
{
      if(ImbricatedLoop <= 0){
	yymsg(GERROR, "Invalid For/EndFor loop");
	ImbricatedLoop = 0;
      }
      else{
	double x0 = LoopControlVariablesTab[ImbricatedLoop-1][0];
	double x1 = LoopControlVariablesTab[ImbricatedLoop-1][1];
	double step = LoopControlVariablesTab[ImbricatedLoop-1][2];
	int do_next = (step > 0.) ? (x0+step <= x1) : (x0+step >= x1);
	if(do_next){
	  LoopControlVariablesTab[ImbricatedLoop-1][0] +=
	    LoopControlVariablesTab[ImbricatedLoop-1][2];
	  if(LoopControlVariablesNameTab[ImbricatedLoop-1]){
	    Symbol TheSymbol;
	    TheSymbol.Name = LoopControlVariablesNameTab[ImbricatedLoop-1];
	    Symbol *pSymbol;
	    if(!(pSymbol = (Symbol*)Tree_PQuery(Symbol_T, &TheSymbol)))
	      yymsg(GERROR, "Unknown loop variable");
	    else
	      *(double*)List_Pointer_Fast(pSymbol->val, 0) += 
		LoopControlVariablesTab[ImbricatedLoop-1][2];
	  }
	  fsetpos(yyin, &yyposImbricatedLoopsTab[ImbricatedLoop-1]);
	  yylineno = yylinenoImbricatedLoopsTab[ImbricatedLoop-1];
	}
	else{
	  ImbricatedLoop--;
	}
      }
    ;
    break;}
case 152:
#line 2154 "Gmsh.y"
{
      if(!FunctionManager::Instance()->createFunction(yyvsp[0].c, yyin, yyname, yylineno))
	yymsg(GERROR, "Redefinition of function %s", yyvsp[0].c);
      skip_until(NULL, "Return");
      //FIXME: wee leak $2
    ;
    break;}
case 153:
#line 2161 "Gmsh.y"
{
      if(!FunctionManager::Instance()->leaveFunction(&yyin, yyname, yylineno))
	yymsg(GERROR, "Error while exiting function");
    ;
    break;}
case 154:
#line 2166 "Gmsh.y"
{
      if(!FunctionManager::Instance()->enterFunction(yyvsp[-1].c, &yyin, yyname, yylineno))
	yymsg(GERROR, "Unknown function %s", yyvsp[-1].c);
      //FIXME: wee leak $2
    ;
    break;}
case 155:
#line 2172 "Gmsh.y"
{
      if(!yyvsp[-1].d) skip_until("If", "EndIf");
    ;
    break;}
case 156:
#line 2176 "Gmsh.y"
{
    ;
    break;}
case 157:
#line 2185 "Gmsh.y"
{
      yyval.l = List_Create(2, 1, sizeof(Shape));
      ExtrudeShapes(TRANSLATE, yyvsp[-1].l, 
		    yyvsp[-3].v[0], yyvsp[-3].v[1], yyvsp[-3].v[2], 0., 0., 0., 0., 0., 0., 0.,
		    NULL, yyval.l);
      List_Delete(yyvsp[-1].l);
    ;
    break;}
case 158:
#line 2193 "Gmsh.y"
{
      yyval.l = List_Create(2, 1, sizeof(Shape));
      ExtrudeShapes(ROTATE, yyvsp[-1].l, 
		    0., 0., 0., yyvsp[-8].v[0], yyvsp[-8].v[1], yyvsp[-8].v[2], yyvsp[-6].v[0], yyvsp[-6].v[1], yyvsp[-6].v[2], yyvsp[-4].d,
		    NULL, yyval.l);
      List_Delete(yyvsp[-1].l);
    ;
    break;}
case 159:
#line 2201 "Gmsh.y"
{
      yyval.l = List_Create(2, 1, sizeof(Shape));
      ExtrudeShapes(TRANSLATE_ROTATE, yyvsp[-1].l, 
		    yyvsp[-10].v[0], yyvsp[-10].v[1], yyvsp[-10].v[2], yyvsp[-8].v[0], yyvsp[-8].v[1], yyvsp[-8].v[2], yyvsp[-6].v[0], yyvsp[-6].v[1], yyvsp[-6].v[2], yyvsp[-4].d,
		    NULL, yyval.l);
      List_Delete(yyvsp[-1].l);
    ;
    break;}
case 160:
#line 2209 "Gmsh.y"
{
      extr.mesh.ExtrudeMesh = extr.mesh.Recombine = false;
    ;
    break;}
case 161:
#line 2213 "Gmsh.y"
{
      yyval.l = List_Create(2, 1, sizeof(Shape));
      ExtrudeShapes(TRANSLATE, yyvsp[-3].l, 
		    yyvsp[-5].v[0], yyvsp[-5].v[1], yyvsp[-5].v[2], 0., 0., 0., 0., 0., 0., 0.,
		    &extr, yyval.l);
      List_Delete(yyvsp[-3].l);
    ;
    break;}
case 162:
#line 2221 "Gmsh.y"
{
      extr.mesh.ExtrudeMesh = extr.mesh.Recombine = false;
    ;
    break;}
case 163:
#line 2225 "Gmsh.y"
{
      yyval.l = List_Create(2, 1, sizeof(Shape));
      ExtrudeShapes(ROTATE, yyvsp[-3].l, 
		    0., 0., 0., yyvsp[-10].v[0], yyvsp[-10].v[1], yyvsp[-10].v[2], yyvsp[-8].v[0], yyvsp[-8].v[1], yyvsp[-8].v[2], yyvsp[-6].d,
		    &extr, yyval.l);
      List_Delete(yyvsp[-3].l);
    ;
    break;}
case 164:
#line 2233 "Gmsh.y"
{
      extr.mesh.ExtrudeMesh = extr.mesh.Recombine = false;
    ;
    break;}
case 165:
#line 2237 "Gmsh.y"
{
      yyval.l = List_Create(2, 1, sizeof(Shape));
      ExtrudeShapes(TRANSLATE_ROTATE, yyvsp[-3].l, 
		    yyvsp[-12].v[0], yyvsp[-12].v[1], yyvsp[-12].v[2], yyvsp[-10].v[0], yyvsp[-10].v[1], yyvsp[-10].v[2], yyvsp[-8].v[0], yyvsp[-8].v[1], yyvsp[-8].v[2], yyvsp[-6].d,
		    &extr, yyval.l);
      List_Delete(yyvsp[-3].l);
    ;
    break;}
case 166:
#line 2245 "Gmsh.y"
{
      extr.mesh.ExtrudeMesh = extr.mesh.Recombine = false;
    ;
    break;}
case 167:
#line 2249 "Gmsh.y"
{
      yyval.l = List_Create(2, 1, sizeof(Shape));
      ExtrudeShapes(BOUNDARY_LAYER, yyvsp[-3].l, 0., 0., 0., 0., 0., 0., 0., 0., 0., 0.,
		    &extr, yyval.l);
      List_Delete(yyvsp[-3].l);
    ;
    break;}
case 168:
#line 2256 "Gmsh.y"
{
      extr.mesh.ExtrudeMesh = extr.mesh.Recombine = false;
    ;
    break;}
case 169:
#line 2260 "Gmsh.y"
{
      yyval.l = List_Create(2, 1, sizeof(Shape));
      extr.mesh.ViewIndex = yyvsp[-6].d;
      ExtrudeShapes(BOUNDARY_LAYER, yyvsp[-3].l, 0., 0., 0., 0., 0., 0., 0., 0., 0., 0.,
		    &extr, yyval.l);
      extr.mesh.ViewIndex = -1;
      Free(yyvsp[-8].c);
      List_Delete(yyvsp[-3].l);
    ;
    break;}
case 170:
#line 2272 "Gmsh.y"
{
      yyval.l = List_Create(2, 1, sizeof(Shape));
      ExtrudeShape(TRANSLATE, MSH_POINT, (int)yyvsp[-4].d, 
		   yyvsp[-2].v[0], yyvsp[-2].v[1], yyvsp[-2].v[2], 0., 0., 0., 0., 0., 0., 0.,
		   NULL, yyval.l);
    ;
    break;}
case 171:
#line 2279 "Gmsh.y"
{
      yyval.l = List_Create(2, 1, sizeof(Shape));
      ExtrudeShape(TRANSLATE, MSH_SEGM_LINE, (int)yyvsp[-4].d, 
		   yyvsp[-2].v[0], yyvsp[-2].v[1], yyvsp[-2].v[2], 0., 0., 0., 0., 0., 0., 0.,
		   NULL, yyval.l);
    ;
    break;}
case 172:
#line 2286 "Gmsh.y"
{
      yyval.l = List_Create(2, 1, sizeof(Shape));
      ExtrudeShape(TRANSLATE, MSH_SURF_PLAN, (int)yyvsp[-4].d, 
		   yyvsp[-2].v[0], yyvsp[-2].v[1], yyvsp[-2].v[2], 0., 0., 0., 0., 0., 0., 0.,
		   NULL, yyval.l);
    ;
    break;}
case 173:
#line 2293 "Gmsh.y"
{
      yyval.l = List_Create(2, 1, sizeof(Shape));
      ExtrudeShape(ROTATE, MSH_POINT, (int)yyvsp[-8].d, 
		   0., 0., 0., yyvsp[-6].v[0], yyvsp[-6].v[1], yyvsp[-6].v[2], yyvsp[-4].v[0], yyvsp[-4].v[1], yyvsp[-4].v[2], yyvsp[-2].d,
		   NULL, yyval.l);
    ;
    break;}
case 174:
#line 2300 "Gmsh.y"
{
      yyval.l = List_Create(2, 1, sizeof(Shape));
      ExtrudeShape(ROTATE, MSH_SEGM_LINE, (int)yyvsp[-8].d, 
		   0., 0., 0., yyvsp[-6].v[0], yyvsp[-6].v[1], yyvsp[-6].v[2], yyvsp[-4].v[0], yyvsp[-4].v[1], yyvsp[-4].v[2], yyvsp[-2].d,
		   NULL, yyval.l);
    ;
    break;}
case 175:
#line 2307 "Gmsh.y"
{
      yyval.l = List_Create(2, 1, sizeof(Shape));
      ExtrudeShape(ROTATE, MSH_SURF_PLAN, (int)yyvsp[-8].d, 
		   0., 0., 0., yyvsp[-6].v[0], yyvsp[-6].v[1], yyvsp[-6].v[2], yyvsp[-4].v[0], yyvsp[-4].v[1], yyvsp[-4].v[2], yyvsp[-2].d,
		   NULL, yyval.l);
    ;
    break;}
case 176:
#line 2314 "Gmsh.y"
{
      yyval.l = List_Create(2, 1, sizeof(Shape));
      ExtrudeShape(TRANSLATE_ROTATE, MSH_POINT, (int)yyvsp[-10].d, 
		   yyvsp[-8].v[0], yyvsp[-8].v[1], yyvsp[-8].v[2], yyvsp[-6].v[0], yyvsp[-6].v[1], yyvsp[-6].v[2], yyvsp[-4].v[0], yyvsp[-4].v[1], yyvsp[-4].v[2], yyvsp[-2].d,
		   NULL, yyval.l);
    ;
    break;}
case 177:
#line 2321 "Gmsh.y"
{
      yyval.l = List_Create(2, 1, sizeof(Shape));
      ExtrudeShape(TRANSLATE_ROTATE, MSH_SEGM_LINE, (int)yyvsp[-10].d, 
		   yyvsp[-8].v[0], yyvsp[-8].v[1], yyvsp[-8].v[2], yyvsp[-6].v[0], yyvsp[-6].v[1], yyvsp[-6].v[2], yyvsp[-4].v[0], yyvsp[-4].v[1], yyvsp[-4].v[2], yyvsp[-2].d,
		   NULL, yyval.l);
    ;
    break;}
case 178:
#line 2328 "Gmsh.y"
{
      yyval.l = List_Create(2, 1, sizeof(Shape));
      ExtrudeShape(TRANSLATE_ROTATE, MSH_SURF_PLAN, (int)yyvsp[-10].d, 
		   yyvsp[-8].v[0], yyvsp[-8].v[1], yyvsp[-8].v[2], yyvsp[-6].v[0], yyvsp[-6].v[1], yyvsp[-6].v[2], yyvsp[-4].v[0], yyvsp[-4].v[1], yyvsp[-4].v[2], yyvsp[-2].d,
		   NULL, yyval.l);
    ;
    break;}
case 179:
#line 2335 "Gmsh.y"
{
      extr.mesh.ExtrudeMesh = extr.mesh.Recombine = false;
    ;
    break;}
case 180:
#line 2339 "Gmsh.y"
{
      yyval.l = List_Create(2, 1, sizeof(Shape));
      ExtrudeShape(TRANSLATE, MSH_POINT, (int)yyvsp[-8].d, 
		   yyvsp[-6].v[0], yyvsp[-6].v[1], yyvsp[-6].v[2], 0., 0., 0., 0., 0., 0., 0.,
		   &extr, yyval.l);
    ;
    break;}
case 181:
#line 2346 "Gmsh.y"
{
      extr.mesh.ExtrudeMesh = extr.mesh.Recombine = false;
    ;
    break;}
case 182:
#line 2350 "Gmsh.y"
{
      yyval.l = List_Create(2, 1, sizeof(Shape));
      ExtrudeShape(TRANSLATE, MSH_SEGM_LINE, (int)yyvsp[-8].d, 
		   yyvsp[-6].v[0], yyvsp[-6].v[1], yyvsp[-6].v[2], 0., 0., 0., 0., 0., 0., 0.,
		   &extr, yyval.l);
    ;
    break;}
case 183:
#line 2357 "Gmsh.y"
{
      extr.mesh.ExtrudeMesh = extr.mesh.Recombine = false;
    ;
    break;}
case 184:
#line 2361 "Gmsh.y"
{
      yyval.l = List_Create(2, 1, sizeof(Shape));
      ExtrudeShape(TRANSLATE, MSH_SURF_PLAN, (int)yyvsp[-8].d, 
		   yyvsp[-6].v[0], yyvsp[-6].v[1], yyvsp[-6].v[2], 0., 0., 0., 0., 0., 0., 0.,
		   &extr, yyval.l);
    ;
    break;}
case 185:
#line 2368 "Gmsh.y"
{
      extr.mesh.ExtrudeMesh = extr.mesh.Recombine = false;
    ;
    break;}
case 186:
#line 2372 "Gmsh.y"
{
      yyval.l = List_Create(2, 1, sizeof(Shape));
      ExtrudeShape(ROTATE, MSH_POINT, (int)yyvsp[-12].d, 
		   0., 0., 0., yyvsp[-10].v[0], yyvsp[-10].v[1], yyvsp[-10].v[2], yyvsp[-8].v[0], yyvsp[-8].v[1], yyvsp[-8].v[2], yyvsp[-6].d,
		   &extr, yyval.l);
    ;
    break;}
case 187:
#line 2379 "Gmsh.y"
{
      extr.mesh.ExtrudeMesh = extr.mesh.Recombine = false;
    ;
    break;}
case 188:
#line 2383 "Gmsh.y"
{
      yyval.l = List_Create(2, 1, sizeof(Shape));
      ExtrudeShape(ROTATE, MSH_SEGM_LINE, (int)yyvsp[-12].d, 
		   0., 0., 0., yyvsp[-10].v[0], yyvsp[-10].v[1], yyvsp[-10].v[2], yyvsp[-8].v[0], yyvsp[-8].v[1], yyvsp[-8].v[2], yyvsp[-6].d,
		   &extr, yyval.l);
    ;
    break;}
case 189:
#line 2390 "Gmsh.y"
{
      extr.mesh.ExtrudeMesh = extr.mesh.Recombine = false;
    ;
    break;}
case 190:
#line 2394 "Gmsh.y"
{
      yyval.l = List_Create(2, 1, sizeof(Shape));
      ExtrudeShape(ROTATE, MSH_SURF_PLAN, (int)yyvsp[-12].d, 
		   0., 0., 0., yyvsp[-10].v[0], yyvsp[-10].v[1], yyvsp[-10].v[2], yyvsp[-8].v[0], yyvsp[-8].v[1], yyvsp[-8].v[2], yyvsp[-6].d,
		   &extr, yyval.l);
    ;
    break;}
case 191:
#line 2401 "Gmsh.y"
{
      extr.mesh.ExtrudeMesh = extr.mesh.Recombine = false;
    ;
    break;}
case 192:
#line 2405 "Gmsh.y"
{
      yyval.l = List_Create(2, 1, sizeof(Shape));
      ExtrudeShape(TRANSLATE_ROTATE, MSH_POINT, (int)yyvsp[-14].d, 
		   yyvsp[-12].v[0], yyvsp[-12].v[1], yyvsp[-12].v[2], yyvsp[-10].v[0], yyvsp[-10].v[1], yyvsp[-10].v[2], yyvsp[-8].v[0], yyvsp[-8].v[1], yyvsp[-8].v[2], yyvsp[-6].d,
		   &extr, yyval.l);
    ;
    break;}
case 193:
#line 2412 "Gmsh.y"
{
      extr.mesh.ExtrudeMesh = extr.mesh.Recombine = false;
    ;
    break;}
case 194:
#line 2416 "Gmsh.y"
{
      yyval.l = List_Create(2, 1, sizeof(Shape));
      ExtrudeShape(TRANSLATE_ROTATE, MSH_SEGM_LINE, (int)yyvsp[-14].d, 
		   yyvsp[-12].v[0], yyvsp[-12].v[1], yyvsp[-12].v[2], yyvsp[-10].v[0], yyvsp[-10].v[1], yyvsp[-10].v[2], yyvsp[-8].v[0], yyvsp[-8].v[1], yyvsp[-8].v[2], yyvsp[-6].d,
		   &extr, yyval.l);
    ;
    break;}
case 195:
#line 2423 "Gmsh.y"
{
      extr.mesh.ExtrudeMesh = extr.mesh.Recombine = false;
    ;
    break;}
case 196:
#line 2427 "Gmsh.y"
{
      yyval.l = List_Create(2, 1, sizeof(Shape));
      ExtrudeShape(TRANSLATE_ROTATE, MSH_SURF_PLAN, (int)yyvsp[-14].d, 
		   yyvsp[-12].v[0], yyvsp[-12].v[1], yyvsp[-12].v[2], yyvsp[-10].v[0], yyvsp[-10].v[1], yyvsp[-10].v[2], yyvsp[-8].v[0], yyvsp[-8].v[1], yyvsp[-8].v[2], yyvsp[-6].d,
		   &extr, yyval.l);
    ;
    break;}
case 197:
#line 2438 "Gmsh.y"
{
    ;
    break;}
case 198:
#line 2441 "Gmsh.y"
{
    ;
    break;}
case 199:
#line 2447 "Gmsh.y"
{
      extr.mesh.ExtrudeMesh = true;
      extr.mesh.NbLayer = 1;
      extr.mesh.NbElmLayer.clear();
      extr.mesh.hLayer.clear();
      extr.mesh.NbElmLayer.push_back((int)fabs(yyvsp[-2].d));
      extr.mesh.hLayer.push_back(1.);
    ;
    break;}
case 200:
#line 2456 "Gmsh.y"
{
      double d;
      extr.mesh.ExtrudeMesh = true;
      extr.mesh.NbLayer = List_Nbr(yyvsp[-4].l);
      if(List_Nbr(yyvsp[-4].l) == List_Nbr(yyvsp[-2].l)){
	extr.mesh.NbElmLayer.clear();
	extr.mesh.hLayer.clear();
	for(int i = 0; i < List_Nbr(yyvsp[-4].l); i++){
	  List_Read(yyvsp[-4].l, i, &d);
	  extr.mesh.NbElmLayer.push_back((d > 0) ? (int)d : 1);
	  List_Read(yyvsp[-2].l, i, &d);
	  extr.mesh.hLayer.push_back(d);
	}
      }
      else{
	yymsg(GERROR, "Wrong layer definition {%d, %d}", 
	      List_Nbr(yyvsp[-4].l), List_Nbr(yyvsp[-2].l));
      }
      List_Delete(yyvsp[-4].l);
      List_Delete(yyvsp[-2].l);
    ;
    break;}
case 201:
#line 2478 "Gmsh.y"
{
      yymsg(WARNING, "Explicit region numbers in layers are deprecated");
      double d;
      extr.mesh.ExtrudeMesh = true;
      extr.mesh.NbLayer = List_Nbr(yyvsp[-6].l);
      if(List_Nbr(yyvsp[-6].l) == List_Nbr(yyvsp[-4].l) && List_Nbr(yyvsp[-6].l) == List_Nbr(yyvsp[-2].l)){
	extr.mesh.NbElmLayer.clear();
	extr.mesh.hLayer.clear();
	for(int i = 0; i < List_Nbr(yyvsp[-6].l); i++){
	  List_Read(yyvsp[-6].l, i, &d);
	  extr.mesh.NbElmLayer.push_back((d > 0) ? (int)d : 1);
	  List_Read(yyvsp[-2].l, i, &d);
	  extr.mesh.hLayer.push_back(d);
	}
      }
      else{
	yymsg(GERROR, "Wrong layer definition {%d, %d, %d}", 
	      List_Nbr(yyvsp[-6].l), List_Nbr(yyvsp[-4].l), List_Nbr(yyvsp[-2].l));
      }
      List_Delete(yyvsp[-6].l);
      List_Delete(yyvsp[-4].l);
      List_Delete(yyvsp[-2].l);
    ;
    break;}
case 202:
#line 2502 "Gmsh.y"
{
      extr.mesh.Recombine = true;
    ;
    break;}
case 203:
#line 2506 "Gmsh.y"
{
      int num = (int)yyvsp[-6].d;
      if(FindSurface(num)){
	yymsg(GERROR, "Surface %d already exists", num);
      }
      else{
	Surface *s = Create_Surface(num, MSH_SURF_DISCRETE);
	Tree_Add(THEM->Surfaces, &s);
	extr.mesh.Holes[num].first = yyvsp[-1].d;
	extr.mesh.Holes[num].second.clear();
	for(int i = 0; i < List_Nbr(yyvsp[-3].l); i++){
	  double d;
	  List_Read(yyvsp[-3].l, i, &d);
	  extr.mesh.Holes[num].second.push_back((int)d);
	}
      }
      List_Delete(yyvsp[-3].l);
    ;
    break;}
case 204:
#line 2530 "Gmsh.y"
{
      for(int i = 0; i < List_Nbr(yyvsp[-3].l); i++){
	double d;
	List_Read(yyvsp[-3].l, i, &d);
	int j = (int)fabs(d);
        Curve *c = FindCurve(j);
	if(!c)
	  yymsg(WARNING, "Unknown curve %d", j);
	else{
	  c->Method = TRANSFINI;
	  c->ipar[0] = (yyvsp[-1].d>2)?(int)yyvsp[-1].d:2;
	  c->ipar[1] = sign(d);
	  c->dpar[0] = 1.0;
	}
      }
      List_Delete(yyvsp[-3].l);
    ;
    break;}
case 205:
#line 2548 "Gmsh.y"
{
      for(int i = 0; i < List_Nbr(yyvsp[-6].l); i++){
	double d;
	List_Read(yyvsp[-6].l, i, &d);
	int j = (int)fabs(d);
        Curve *c = FindCurve(j);
	if(!c)
	  yymsg(WARNING, "Unknown curve %d", j);
	else{
	  c->Method = TRANSFINI;
	  c->ipar[0] = (yyvsp[-4].d>2)?(int)yyvsp[-4].d:2;
	  c->ipar[1] = sign(d); /* Progresion : code 1 ou -1 */
	  c->dpar[0] = fabs(yyvsp[-1].d);
	}
      }
      List_Delete(yyvsp[-6].l);
    ;
    break;}
case 206:
#line 2566 "Gmsh.y"
{
      for(int i = 0; i < List_Nbr(yyvsp[-6].l); i++){
	double d;
	List_Read(yyvsp[-6].l, i, &d);
	int j = (int)fabs(d);
        Curve *c = FindCurve(j);
	if(!c)
	  yymsg(WARNING, "Unknown curve %d", j);
	else{
	  c->Method = TRANSFINI;
	  c->ipar[0] = (yyvsp[-4].d>2)?(int)yyvsp[-4].d:2;
	  c->ipar[1] = 2*sign(d); /* Bump : code 2 ou -2 */
	  c->dpar[0] = fabs(yyvsp[-1].d);
	}
      }
      List_Delete(yyvsp[-6].l);
    ;
    break;}
case 207:
#line 2584 "Gmsh.y"
{
      Surface *s = FindSurface((int)yyvsp[-4].d);
      if(!s)
	yymsg(WARNING, "Unknown surface %d", (int)yyvsp[-4].d);
      else{
	s->Method = TRANSFINI;
	s->Recombine_Dir = -1;
	int k = List_Nbr(yyvsp[-1].l);
	if(k != 3 && k != 4){
	  yymsg(GERROR, "Wrong definition of Transfinite Surface %d: "
		"%d points instead of 3 or 4" , (int)yyvsp[-4].d, k);
	}
	else{
	  List_Reset(s->TrsfPoints);
	  for(int i = 0; i < k; i++){
	    double d;
	    List_Read(yyvsp[-1].l, i, &d);
	    int j = (int)fabs(d);
	    Vertex *v = FindPoint(j);
	    if(!v)
	      yymsg(WARNING, "Unknown point %d", j);
	    else
	      List_Add(s->TrsfPoints, &v);
	  }
	}
      }
      List_Delete(yyvsp[-1].l);
    ;
    break;}
case 208:
#line 2613 "Gmsh.y"
{
      Surface *s = FindSurface((int)yyvsp[-5].d);
      if(!s)
	yymsg(WARNING, "Unknown surface %d", (int)yyvsp[-5].d);
      else{
	s->Method = TRANSFINI;
	int k = List_Nbr(yyvsp[-2].l);
	if(k != 3 && k != 4){
	  yymsg(GERROR, "Wrong definition of Transfinite Surface %d: "
		"%d points instead of 3 or 4" , (int)yyvsp[-5].d, k);
	}
	else{
	  List_Reset(s->TrsfPoints);
	  if (!strcmp(yyvsp[-1].c, "Right"))
	    s->Recombine_Dir = 1;
	  else if (!strcmp(yyvsp[-1].c, "Left"))
	    s->Recombine_Dir = -1;
	  else
	    s->Recombine_Dir = 0;
	  for(int i = 0; i < k; i++){
	    double d;
	    List_Read(yyvsp[-2].l, i, &d);
	    int j = (int)fabs(d);
	    Vertex *v = FindPoint(j);
	    if(!v)
	      yymsg(WARNING, "Unknown point %d", j);
	    else
	      List_Add(s->TrsfPoints, &v);
	  }
	}
      }
      List_Delete(yyvsp[-2].l);
      Free(yyvsp[-1].c);
    ;
    break;}
case 209:
#line 2648 "Gmsh.y"
{
      yymsg(WARNING, "Elliptic Surface is deprecated: use Transfinite instead (with smoothing)");
      List_Delete(yyvsp[-1].l);
    ;
    break;}
case 210:
#line 2653 "Gmsh.y"
{
      Volume *v = FindVolume((int)yyvsp[-4].d);
      if(!v)
	yymsg(WARNING, "Unknown volume %d", (int)yyvsp[-4].d);
      else{
	v->Method = TRANSFINI;
	int k = List_Nbr(yyvsp[-1].l);
	if(k != 6 && k != 8)
	  yymsg(GERROR, "Wrong definition of Transfinite Volume %d: "
		"%d points instead of 6 or 8" , (int)yyvsp[-4].d, k);
	else{
	  List_Reset(v->TrsfPoints);
	  for(int i = 0; i < k; i++){
	    double d;
	    List_Read(yyvsp[-1].l, i, &d);
	    int j = (int)fabs(d);
	    Vertex *vert = FindPoint(j);
	    if(!vert)
	      yymsg(WARNING, "Unknown point %d", j);
	    else
	      List_Add(v->TrsfPoints, &vert);
	  }
	}
      }
      List_Delete(yyvsp[-1].l);
    ;
    break;}
case 211:
#line 2680 "Gmsh.y"
{
      for(int i = 0; i < List_Nbr(yyvsp[-3].l); i++){
	double d;
	List_Read(yyvsp[-3].l, i, &d);
	int j = (int)d;
	Surface *s = FindSurface(j);
	if(s){
	  s->Recombine = 1;
	  s->RecombineAngle = (yyvsp[-1].d > 0 && yyvsp[-1].d < 90) ? yyvsp[-1].d : 90;
	}
      }
      List_Delete(yyvsp[-3].l);
    ;
    break;}
case 212:
#line 2694 "Gmsh.y"
{
      for(int i = 0; i < List_Nbr(yyvsp[-1].l); i++){
	double d;
	List_Read(yyvsp[-1].l, i, &d);
	int j = (int)d;
        Surface *s = FindSurface(j);
	if(s){
	  s->Recombine = 1;
        }
      }
      List_Delete(yyvsp[-1].l);
    ;
    break;}
case 213:
#line 2713 "Gmsh.y"
{ 
      Surface *s = FindSurface((int)yyvsp[-2].d);
      if(s)
	setSurfaceEmbeddedPoints(s, yyvsp[-7].l);
    ;
    break;}
case 214:
#line 2719 "Gmsh.y"
{
      Surface *s = FindSurface((int)yyvsp[-2].d);
      if(s)
	setSurfaceEmbeddedCurves(s, yyvsp[-7].l);
    ;
    break;}
case 215:
#line 2725 "Gmsh.y"
{
    ;
    break;}
case 216:
#line 2728 "Gmsh.y"
{
    ;
    break;}
case 217:
#line 2737 "Gmsh.y"
{ 
      ReplaceAllDuplicates();
    ;
    break;}
case 218:
#line 2746 "Gmsh.y"
{ yyval.d = yyvsp[0].d;           ;
    break;}
case 219:
#line 2747 "Gmsh.y"
{ yyval.d = yyvsp[-1].d;           ;
    break;}
case 220:
#line 2748 "Gmsh.y"
{ yyval.d = -yyvsp[0].d;          ;
    break;}
case 221:
#line 2749 "Gmsh.y"
{ yyval.d = yyvsp[0].d;           ;
    break;}
case 222:
#line 2750 "Gmsh.y"
{ yyval.d = !yyvsp[0].d;          ;
    break;}
case 223:
#line 2751 "Gmsh.y"
{ yyval.d = yyvsp[-2].d - yyvsp[0].d;      ;
    break;}
case 224:
#line 2752 "Gmsh.y"
{ yyval.d = yyvsp[-2].d + yyvsp[0].d;      ;
    break;}
case 225:
#line 2753 "Gmsh.y"
{ yyval.d = yyvsp[-2].d * yyvsp[0].d;      ;
    break;}
case 226:
#line 2755 "Gmsh.y"
{ 
      if(!yyvsp[0].d)
	yymsg(GERROR, "Division by zero in '%g / %g'", yyvsp[-2].d, yyvsp[0].d);
      else
	yyval.d = yyvsp[-2].d / yyvsp[0].d;     
    ;
    break;}
case 227:
#line 2761 "Gmsh.y"
{ yyval.d = (int)yyvsp[-2].d % (int)yyvsp[0].d;  ;
    break;}
case 228:
#line 2762 "Gmsh.y"
{ yyval.d = pow(yyvsp[-2].d, yyvsp[0].d);  ;
    break;}
case 229:
#line 2763 "Gmsh.y"
{ yyval.d = yyvsp[-2].d < yyvsp[0].d;      ;
    break;}
case 230:
#line 2764 "Gmsh.y"
{ yyval.d = yyvsp[-2].d > yyvsp[0].d;      ;
    break;}
case 231:
#line 2765 "Gmsh.y"
{ yyval.d = yyvsp[-2].d <= yyvsp[0].d;     ;
    break;}
case 232:
#line 2766 "Gmsh.y"
{ yyval.d = yyvsp[-2].d >= yyvsp[0].d;     ;
    break;}
case 233:
#line 2767 "Gmsh.y"
{ yyval.d = yyvsp[-2].d == yyvsp[0].d;     ;
    break;}
case 234:
#line 2768 "Gmsh.y"
{ yyval.d = yyvsp[-2].d != yyvsp[0].d;     ;
    break;}
case 235:
#line 2769 "Gmsh.y"
{ yyval.d = yyvsp[-2].d && yyvsp[0].d;     ;
    break;}
case 236:
#line 2770 "Gmsh.y"
{ yyval.d = yyvsp[-2].d || yyvsp[0].d;     ;
    break;}
case 237:
#line 2771 "Gmsh.y"
{ yyval.d = yyvsp[-4].d? yyvsp[-2].d : yyvsp[0].d;  ;
    break;}
case 238:
#line 2772 "Gmsh.y"
{ yyval.d = exp(yyvsp[-1].d);      ;
    break;}
case 239:
#line 2773 "Gmsh.y"
{ yyval.d = log(yyvsp[-1].d);      ;
    break;}
case 240:
#line 2774 "Gmsh.y"
{ yyval.d = log10(yyvsp[-1].d);    ;
    break;}
case 241:
#line 2775 "Gmsh.y"
{ yyval.d = sqrt(yyvsp[-1].d);     ;
    break;}
case 242:
#line 2776 "Gmsh.y"
{ yyval.d = sin(yyvsp[-1].d);      ;
    break;}
case 243:
#line 2777 "Gmsh.y"
{ yyval.d = asin(yyvsp[-1].d);     ;
    break;}
case 244:
#line 2778 "Gmsh.y"
{ yyval.d = cos(yyvsp[-1].d);      ;
    break;}
case 245:
#line 2779 "Gmsh.y"
{ yyval.d = acos(yyvsp[-1].d);     ;
    break;}
case 246:
#line 2780 "Gmsh.y"
{ yyval.d = tan(yyvsp[-1].d);      ;
    break;}
case 247:
#line 2781 "Gmsh.y"
{ yyval.d = atan(yyvsp[-1].d);     ;
    break;}
case 248:
#line 2782 "Gmsh.y"
{ yyval.d = atan2(yyvsp[-3].d, yyvsp[-1].d);;
    break;}
case 249:
#line 2783 "Gmsh.y"
{ yyval.d = sinh(yyvsp[-1].d);     ;
    break;}
case 250:
#line 2784 "Gmsh.y"
{ yyval.d = cosh(yyvsp[-1].d);     ;
    break;}
case 251:
#line 2785 "Gmsh.y"
{ yyval.d = tanh(yyvsp[-1].d);     ;
    break;}
case 252:
#line 2786 "Gmsh.y"
{ yyval.d = fabs(yyvsp[-1].d);     ;
    break;}
case 253:
#line 2787 "Gmsh.y"
{ yyval.d = floor(yyvsp[-1].d);    ;
    break;}
case 254:
#line 2788 "Gmsh.y"
{ yyval.d = ceil(yyvsp[-1].d);     ;
    break;}
case 255:
#line 2789 "Gmsh.y"
{ yyval.d = fmod(yyvsp[-3].d, yyvsp[-1].d); ;
    break;}
case 256:
#line 2790 "Gmsh.y"
{ yyval.d = fmod(yyvsp[-3].d, yyvsp[-1].d); ;
    break;}
case 257:
#line 2791 "Gmsh.y"
{ yyval.d = sqrt(yyvsp[-3].d*yyvsp[-3].d+yyvsp[-1].d*yyvsp[-1].d); ;
    break;}
case 258:
#line 2792 "Gmsh.y"
{ yyval.d = yyvsp[-1].d*(double)rand()/(double)RAND_MAX; ;
    break;}
case 259:
#line 2794 "Gmsh.y"
{ yyval.d = exp(yyvsp[-1].d);      ;
    break;}
case 260:
#line 2795 "Gmsh.y"
{ yyval.d = log(yyvsp[-1].d);      ;
    break;}
case 261:
#line 2796 "Gmsh.y"
{ yyval.d = log10(yyvsp[-1].d);    ;
    break;}
case 262:
#line 2797 "Gmsh.y"
{ yyval.d = sqrt(yyvsp[-1].d);     ;
    break;}
case 263:
#line 2798 "Gmsh.y"
{ yyval.d = sin(yyvsp[-1].d);      ;
    break;}
case 264:
#line 2799 "Gmsh.y"
{ yyval.d = asin(yyvsp[-1].d);     ;
    break;}
case 265:
#line 2800 "Gmsh.y"
{ yyval.d = cos(yyvsp[-1].d);      ;
    break;}
case 266:
#line 2801 "Gmsh.y"
{ yyval.d = acos(yyvsp[-1].d);     ;
    break;}
case 267:
#line 2802 "Gmsh.y"
{ yyval.d = tan(yyvsp[-1].d);      ;
    break;}
case 268:
#line 2803 "Gmsh.y"
{ yyval.d = atan(yyvsp[-1].d);     ;
    break;}
case 269:
#line 2804 "Gmsh.y"
{ yyval.d = atan2(yyvsp[-3].d, yyvsp[-1].d);;
    break;}
case 270:
#line 2805 "Gmsh.y"
{ yyval.d = sinh(yyvsp[-1].d);     ;
    break;}
case 271:
#line 2806 "Gmsh.y"
{ yyval.d = cosh(yyvsp[-1].d);     ;
    break;}
case 272:
#line 2807 "Gmsh.y"
{ yyval.d = tanh(yyvsp[-1].d);     ;
    break;}
case 273:
#line 2808 "Gmsh.y"
{ yyval.d = fabs(yyvsp[-1].d);     ;
    break;}
case 274:
#line 2809 "Gmsh.y"
{ yyval.d = floor(yyvsp[-1].d);    ;
    break;}
case 275:
#line 2810 "Gmsh.y"
{ yyval.d = ceil(yyvsp[-1].d);     ;
    break;}
case 276:
#line 2811 "Gmsh.y"
{ yyval.d = fmod(yyvsp[-3].d, yyvsp[-1].d); ;
    break;}
case 277:
#line 2812 "Gmsh.y"
{ yyval.d = fmod(yyvsp[-3].d, yyvsp[-1].d); ;
    break;}
case 278:
#line 2813 "Gmsh.y"
{ yyval.d = sqrt(yyvsp[-3].d*yyvsp[-3].d+yyvsp[-1].d*yyvsp[-1].d); ;
    break;}
case 279:
#line 2814 "Gmsh.y"
{ yyval.d = yyvsp[-1].d*(double)rand()/(double)RAND_MAX; ;
    break;}
case 280:
#line 2823 "Gmsh.y"
{ yyval.d = yyvsp[0].d; ;
    break;}
case 281:
#line 2824 "Gmsh.y"
{ yyval.d = 3.141592653589793; ;
    break;}
case 282:
#line 2825 "Gmsh.y"
{ yyval.d = ParUtil::Instance()->rank(); ;
    break;}
case 283:
#line 2826 "Gmsh.y"
{ yyval.d = ParUtil::Instance()->size(); ;
    break;}
case 284:
#line 2827 "Gmsh.y"
{ yyval.d = Get_GmshMajorVersion(); ;
    break;}
case 285:
#line 2828 "Gmsh.y"
{ yyval.d = Get_GmshMinorVersion(); ;
    break;}
case 286:
#line 2829 "Gmsh.y"
{ yyval.d = Get_GmshPatchVersion(); ;
    break;}
case 287:
#line 2834 "Gmsh.y"
{
      Symbol TheSymbol;
      TheSymbol.Name = yyvsp[0].c;
      Symbol *pSymbol;
      if(!(pSymbol = (Symbol*)Tree_PQuery(Symbol_T, &TheSymbol))) {
	yymsg(GERROR, "Unknown variable '%s'", yyvsp[0].c);
	yyval.d = 0.;
      }
      else
	yyval.d = *(double*)List_Pointer_Fast(pSymbol->val, 0);
      Free(yyvsp[0].c);
    ;
    break;}
case 288:
#line 2850 "Gmsh.y"
{
      char tmpstring[1024];
      sprintf(tmpstring, "%s_%d", yyvsp[-4].c, (int)yyvsp[-1].d) ;
      Symbol TheSymbol;
      TheSymbol.Name = tmpstring;
      Symbol *pSymbol;
      if(!(pSymbol = (Symbol*)Tree_PQuery(Symbol_T, &TheSymbol))) {
	yymsg(GERROR, "Unknown variable '%s'", tmpstring);
	yyval.d = 0.;
      }
      else
	yyval.d = *(double*)List_Pointer_Fast(pSymbol->val, 0);
      Free(yyvsp[-4].c);
    ;
    break;}
case 289:
#line 2865 "Gmsh.y"
{
      Symbol TheSymbol;
      TheSymbol.Name = yyvsp[-3].c;
      Symbol *pSymbol;
      if(!(pSymbol = (Symbol*)Tree_PQuery(Symbol_T, &TheSymbol))) {
	yymsg(GERROR, "Unknown variable '%s'", yyvsp[-3].c);
	yyval.d = 0.;
      }
      else{
	double *pd;
	if((pd = (double*)List_Pointer_Test(pSymbol->val, (int)yyvsp[-1].d)))
	  yyval.d = *pd;
	else{
	  yymsg(GERROR, "Uninitialized variable '%s[%d]'", yyvsp[-3].c, (int)yyvsp[-1].d);
	  yyval.d = 0.;
	}
      }
      Free(yyvsp[-3].c);
    ;
    break;}
case 290:
#line 2885 "Gmsh.y"
{
      Symbol TheSymbol;
      TheSymbol.Name = yyvsp[-2].c;
      Symbol *pSymbol;
      if(!(pSymbol = (Symbol*)Tree_PQuery(Symbol_T, &TheSymbol))) {
	yymsg(GERROR, "Unknown variable '%s'", yyvsp[-2].c);
	yyval.d = 0.;
      }
      else{
	yyval.d = List_Nbr(pSymbol->val);
      }
      Free(yyvsp[-2].c);
    ;
    break;}
case 291:
#line 2899 "Gmsh.y"
{
      Symbol TheSymbol;
      TheSymbol.Name = yyvsp[-1].c;
      Symbol *pSymbol;
      if(!(pSymbol = (Symbol*)Tree_PQuery(Symbol_T, &TheSymbol))) {
	yymsg(GERROR, "Unknown variable '%s'", yyvsp[-1].c);
	yyval.d = 0.;
      }
      else
	yyval.d = (*(double*)List_Pointer_Fast(pSymbol->val, 0) += yyvsp[0].i);
      Free(yyvsp[-1].c);
    ;
    break;}
case 292:
#line 2912 "Gmsh.y"
{
      Symbol TheSymbol;
      TheSymbol.Name = yyvsp[-4].c;
      Symbol *pSymbol;
      if(!(pSymbol = (Symbol*)Tree_PQuery(Symbol_T, &TheSymbol))) {
	yymsg(GERROR, "Unknown variable '%s'", yyvsp[-4].c);
	yyval.d = 0.;
      }
      else{
	double *pd;
	if((pd = (double*)List_Pointer_Test(pSymbol->val, (int)yyvsp[-2].d)))
	  yyval.d = (*pd += yyvsp[0].i);
	else{
	  yymsg(GERROR, "Uninitialized variable '%s[%d]'", yyvsp[-4].c, (int)yyvsp[-2].d);
	  yyval.d = 0.;
	}
      }
      Free(yyvsp[-4].c);
    ;
    break;}
case 293:
#line 2935 "Gmsh.y"
{
      double (*pNumOpt)(int num, int action, double value);
      StringXNumber *pNumCat;
      if(!(pNumCat = Get_NumberOptionCategory(yyvsp[-2].c))){
	yymsg(GERROR, "Unknown numeric option class '%s'", yyvsp[-2].c);
	yyval.d = 0.;
      }
      else{
	if(!(pNumOpt =  (double (*) (int, int, double))Get_NumberOption(yyvsp[0].c, pNumCat))){
	  yymsg(GERROR, "Unknown numeric option '%s.%s'", yyvsp[-2].c, yyvsp[0].c);
	  yyval.d = 0.;
	}
	else
	  yyval.d = pNumOpt(0, GMSH_GET, 0);
      }
      Free(yyvsp[-2].c); Free(yyvsp[0].c);
    ;
    break;}
case 294:
#line 2953 "Gmsh.y"
{
      double (*pNumOpt)(int num, int action, double value);
      StringXNumber *pNumCat;
      if(!(pNumCat = Get_NumberOptionCategory(yyvsp[-5].c))){
	yymsg(GERROR, "Unknown numeric option class '%s'", yyvsp[-5].c);
	yyval.d = 0.;
      }
      else{
	if(!(pNumOpt =  (double (*) (int, int, double))Get_NumberOption(yyvsp[0].c, pNumCat))){
	  yymsg(GERROR, "Unknown numeric option '%s[%d].%s'", yyvsp[-5].c, (int)yyvsp[-3].d, yyvsp[0].c);
	  yyval.d = 0.;
	}
	else
	  yyval.d = pNumOpt((int)yyvsp[-3].d, GMSH_GET, 0);
      }
      Free(yyvsp[-5].c); Free(yyvsp[0].c);
    ;
    break;}
case 295:
#line 2971 "Gmsh.y"
{
      double (*pNumOpt)(int num, int action, double value);
      StringXNumber *pNumCat;
      if(!(pNumCat = Get_NumberOptionCategory(yyvsp[-3].c))){
	yymsg(GERROR, "Unknown numeric option class '%s'", yyvsp[-3].c);
	yyval.d = 0.;
      }
      else{
	if(!(pNumOpt =  (double (*) (int, int, double))Get_NumberOption(yyvsp[-1].c, pNumCat))){
	  yymsg(GERROR, "Unknown numeric option '%s.%s'", yyvsp[-3].c, yyvsp[-1].c);
	  yyval.d = 0.;
	}
	else
	  yyval.d = pNumOpt(0, GMSH_SET|GMSH_GUI, pNumOpt(0, GMSH_GET, 0)+yyvsp[0].i);
      }
      Free(yyvsp[-3].c); Free(yyvsp[-1].c);
    ;
    break;}
case 296:
#line 2989 "Gmsh.y"
{
      double (*pNumOpt)(int num, int action, double value);
      StringXNumber *pNumCat;
      if(!(pNumCat = Get_NumberOptionCategory(yyvsp[-6].c))){
	yymsg(GERROR, "Unknown numeric option class '%s'", yyvsp[-6].c);
	yyval.d = 0.;
      }
      else{
	if(!(pNumOpt =  (double (*) (int, int, double))Get_NumberOption(yyvsp[-1].c, pNumCat))){
	  yymsg(GERROR, "Unknown numeric option '%s[%d].%s'", yyvsp[-6].c, (int)yyvsp[-4].d, yyvsp[-1].c);
	  yyval.d = 0.;
	}
	else
	  yyval.d = pNumOpt((int)yyvsp[-4].d, GMSH_SET|GMSH_GUI, pNumOpt((int)yyvsp[-4].d, GMSH_GET, 0)+yyvsp[0].i);
      }
      Free(yyvsp[-6].c); Free(yyvsp[-1].c);
    ;
    break;}
case 297:
#line 3007 "Gmsh.y"
{ 
      yyval.d = GetValue(yyvsp[-3].c, yyvsp[-1].d);
      Free(yyvsp[-3].c);
    ;
    break;}
case 298:
#line 3015 "Gmsh.y"
{
      memcpy(yyval.v, yyvsp[0].v, 5*sizeof(double));
    ;
    break;}
case 299:
#line 3019 "Gmsh.y"
{
      for(int i = 0; i < 5; i++) yyval.v[i] = -yyvsp[0].v[i];
    ;
    break;}
case 300:
#line 3023 "Gmsh.y"
{ 
      for(int i = 0; i < 5; i++) yyval.v[i] = yyvsp[0].v[i];
    ;
    break;}
case 301:
#line 3027 "Gmsh.y"
{ 
      for(int i = 0; i < 5; i++) yyval.v[i] = yyvsp[-2].v[i] - yyvsp[0].v[i];
    ;
    break;}
case 302:
#line 3031 "Gmsh.y"
{
      for(int i = 0; i < 5; i++) yyval.v[i] = yyvsp[-2].v[i] + yyvsp[0].v[i];
    ;
    break;}
case 303:
#line 3038 "Gmsh.y"
{ 
      yyval.v[0] = yyvsp[-9].d;  yyval.v[1] = yyvsp[-7].d;  yyval.v[2] = yyvsp[-5].d;  yyval.v[3] = yyvsp[-3].d; yyval.v[4] = yyvsp[-1].d;
    ;
    break;}
case 304:
#line 3042 "Gmsh.y"
{ 
      yyval.v[0] = yyvsp[-7].d;  yyval.v[1] = yyvsp[-5].d;  yyval.v[2] = yyvsp[-3].d;  yyval.v[3] = yyvsp[-1].d; yyval.v[4] = 1.0;
    ;
    break;}
case 305:
#line 3046 "Gmsh.y"
{
      yyval.v[0] = yyvsp[-5].d;  yyval.v[1] = yyvsp[-3].d;  yyval.v[2] = yyvsp[-1].d;  yyval.v[3] = 0.0; yyval.v[4] = 1.0;
    ;
    break;}
case 306:
#line 3050 "Gmsh.y"
{
      yyval.v[0] = yyvsp[-5].d;  yyval.v[1] = yyvsp[-3].d;  yyval.v[2] = yyvsp[-1].d;  yyval.v[3] = 0.0; yyval.v[4] = 1.0;
    ;
    break;}
case 307:
#line 3057 "Gmsh.y"
{
      yyval.l = List_Create(2, 1, sizeof(List_T*));
      List_Add(yyval.l, &(yyvsp[0].l));
    ;
    break;}
case 308:
#line 3062 "Gmsh.y"
{
      List_Add(yyval.l, &(yyvsp[0].l));
    ;
    break;}
case 309:
#line 3070 "Gmsh.y"
{
      yyval.l = List_Create(2, 1, sizeof(double));
      List_Add(yyval.l, &(yyvsp[0].d));
    ;
    break;}
case 310:
#line 3075 "Gmsh.y"
{
      yyval.l = yyvsp[0].l;
    ;
    break;}
case 311:
#line 3079 "Gmsh.y"
{
      // creates an empty list
      yyval.l = List_Create(2, 1, sizeof(double));
    ;
    break;}
case 312:
#line 3084 "Gmsh.y"
{
      yyval.l = yyvsp[-1].l;
    ;
    break;}
case 313:
#line 3088 "Gmsh.y"
{
      yyval.l = yyvsp[-1].l;
      for(int i = 0; i < List_Nbr(yyval.l); i++){
	double *pd = (double*)List_Pointer(yyval.l, i);
	(*pd) = - (*pd);
      }
    ;
    break;}
case 314:
#line 3096 "Gmsh.y"
{
      yyval.l = yyvsp[-1].l;
      for(int i = 0; i < List_Nbr(yyval.l); i++){
	double *pd = (double*)List_Pointer(yyval.l, i);
	(*pd) *= yyvsp[-4].d;
      }
    ;
    break;}
case 315:
#line 3107 "Gmsh.y"
{
      yyval.l = yyvsp[0].l;
      for(int i = 0; i < List_Nbr(yyval.l); i++){
	double *pd = (double*)List_Pointer(yyval.l, i);
	(*pd) = - (*pd);
      }
    ;
    break;}
case 316:
#line 3115 "Gmsh.y"
{
      yyval.l = yyvsp[0].l;
      for(int i = 0; i < List_Nbr(yyval.l); i++){
	double *pd = (double*)List_Pointer(yyval.l, i);
	(*pd) *= yyvsp[-2].d;
      }
    ;
    break;}
case 317:
#line 3123 "Gmsh.y"
{ 
      yyval.l = List_Create(2, 1, sizeof(double)); 
      for(double d = yyvsp[-2].d; (yyvsp[-2].d < yyvsp[0].d) ? (d <= yyvsp[0].d) : (d >= yyvsp[0].d); (yyvsp[-2].d < yyvsp[0].d) ? (d += 1.) : (d -= 1.)) 
	List_Add(yyval.l, &d);
    ;
    break;}
case 318:
#line 3129 "Gmsh.y"
{
      yyval.l = List_Create(2, 1, sizeof(double)); 
      if(!yyvsp[0].d || (yyvsp[-4].d < yyvsp[-2].d && yyvsp[0].d < 0) || (yyvsp[-4].d > yyvsp[-2].d && yyvsp[0].d > 0)){
        yymsg(GERROR, "Wrong increment in '%g:%g:%g'", yyvsp[-4].d, yyvsp[-2].d, yyvsp[0].d);
	List_Add(yyval.l, &(yyvsp[-4].d));
      }
      else
	for(double d = yyvsp[-4].d; (yyvsp[0].d > 0) ? (d <= yyvsp[-2].d) : (d >= yyvsp[-2].d); d += yyvsp[0].d)
	  List_Add(yyval.l, &d);
   ;
    break;}
case 319:
#line 3140 "Gmsh.y"
{
      // Returns the coordinates of a point and fills a list with it.
      // This allows to ensure e.g. that relative point positions are
      // always conserved
      Vertex *v = FindPoint((int)yyvsp[-1].d);
      yyval.l = List_Create(3, 1, sizeof(double));      
      if(!v) {
	yymsg(GERROR, "Unknown point '%d'", (int) yyvsp[-1].d);
	double d = 0.0;
	List_Add(yyval.l, &d);
	List_Add(yyval.l, &d);
	List_Add(yyval.l, &d);
      }
      else{
	List_Add(yyval.l, &v->Pos.X);
	List_Add(yyval.l, &v->Pos.Y);
	List_Add(yyval.l, &v->Pos.Z);
      }
    ;
    break;}
case 320:
#line 3160 "Gmsh.y"
{
      yyval.l = List_Create(List_Nbr(yyvsp[0].l), 1, sizeof(double));
      for(int i = 0; i < List_Nbr(yyvsp[0].l); i++){
	Shape *s = (Shape*) List_Pointer(yyvsp[0].l, i);
	double d = s->Num;
	List_Add(yyval.l, &d);
      }
      List_Delete(yyvsp[0].l);
    ;
    break;}
case 321:
#line 3170 "Gmsh.y"
{
      yyval.l = List_Create(List_Nbr(yyvsp[0].l), 1, sizeof(double));
      for(int i = 0; i < List_Nbr(yyvsp[0].l); i++){
	Shape *s = (Shape*) List_Pointer(yyvsp[0].l, i);
	double d = s->Num;
	List_Add(yyval.l, &d);
      }
      List_Delete(yyvsp[0].l);
    ;
    break;}
case 322:
#line 3180 "Gmsh.y"
{
      yyval.l = List_Create(List_Nbr(yyvsp[0].l), 1, sizeof(double));
      for(int i = 0; i < List_Nbr(yyvsp[0].l); i++){
	Shape *s = (Shape*) List_Pointer(yyvsp[0].l, i);
	double d = s->Num;
	List_Add(yyval.l, &d);
      }
      List_Delete(yyvsp[0].l);
    ;
    break;}
case 323:
#line 3190 "Gmsh.y"
{
      yyval.l = List_Create(2, 1, sizeof(double));
      Symbol TheSymbol;
      TheSymbol.Name = yyvsp[-2].c;
      Symbol *pSymbol;
      if(!(pSymbol = (Symbol*)Tree_PQuery(Symbol_T, &TheSymbol))) {
	yymsg(GERROR, "Unknown variable '%s'", yyvsp[-2].c);
	double d = 0.0;
	List_Add(yyval.l, &d);
      }
      else{
	for(int i = 0; i < List_Nbr(pSymbol->val); i++)
	  List_Add(yyval.l, (double*)List_Pointer_Fast(pSymbol->val, i));
      }
      Free(yyvsp[-2].c);
    ;
    break;}
case 324:
#line 3207 "Gmsh.y"
{
      yyval.l = List_Create(2, 1, sizeof(double));
      Symbol TheSymbol;
      TheSymbol.Name = yyvsp[-5].c;
      Symbol *pSymbol;
      if(!(pSymbol = (Symbol*)Tree_PQuery(Symbol_T, &TheSymbol))) {
	yymsg(GERROR, "Unknown variable '%s'", yyvsp[-5].c);
	double d = 0.0;
	List_Add(yyval.l, &d);
      }
      else{
	for(int i = 0; i < List_Nbr(yyvsp[-2].l); i++){
	  int j = (int)(*(double*)List_Pointer_Fast(yyvsp[-2].l, i));
	  double *pd;
	  if((pd = (double*)List_Pointer_Test(pSymbol->val, j)))
	    List_Add(yyval.l, pd);
	  else
	    yymsg(GERROR, "Uninitialized variable '%s[%d]'", yyvsp[-5].c, j);	  
	}
      }
      Free(yyvsp[-5].c);
      List_Delete(yyvsp[-2].l);
    ;
    break;}
case 325:
#line 3234 "Gmsh.y"
{
      yyval.l = List_Create(2, 1, sizeof(double));
      List_Add(yyval.l, &(yyvsp[0].d));
    ;
    break;}
case 326:
#line 3239 "Gmsh.y"
{
      yyval.l = yyvsp[0].l;
    ;
    break;}
case 327:
#line 3243 "Gmsh.y"
{
      List_Add(yyval.l, &(yyvsp[0].d));
    ;
    break;}
case 328:
#line 3247 "Gmsh.y"
{
      for(int i = 0; i < List_Nbr(yyvsp[0].l); i++){
	double d;
	List_Read(yyvsp[0].l, i, &d);
	List_Add(yyval.l, &d);
      }
      List_Delete(yyvsp[0].l);
    ;
    break;}
case 329:
#line 3260 "Gmsh.y"
{
      yyval.u = CTX.PACK_COLOR((int)yyvsp[-7].d, (int)yyvsp[-5].d, (int)yyvsp[-3].d, (int)yyvsp[-1].d);
    ;
    break;}
case 330:
#line 3264 "Gmsh.y"
{
      yyval.u = CTX.PACK_COLOR((int)yyvsp[-5].d, (int)yyvsp[-3].d, (int)yyvsp[-1].d, 255);
    ;
    break;}
case 331:
#line 3276 "Gmsh.y"
{
      int flag;
      yyval.u = Get_ColorForString(ColorString, -1, yyvsp[0].c, &flag);
      if(flag) yymsg(GERROR, "Unknown color '%s'", yyvsp[0].c);
      Free(yyvsp[0].c);
    ;
    break;}
case 332:
#line 3283 "Gmsh.y"
{
      unsigned int (*pColOpt)(int num, int action, unsigned int value);
      StringXColor *pColCat;
      if(!(pColCat = Get_ColorOptionCategory(yyvsp[-4].c))){
	yymsg(GERROR, "Unknown color option class '%s'", yyvsp[-4].c);
	yyval.u = 0;
      }
      else{
	if(!(pColOpt =  (unsigned int (*) (int, int, unsigned int))Get_ColorOption(yyvsp[0].c, pColCat))){
	  yymsg(GERROR, "Unknown color option '%s.Color.%s'", yyvsp[-4].c, yyvsp[0].c);
	  yyval.u = 0;
	}
	else{
	  yyval.u = pColOpt(0, GMSH_GET, 0);
	}
      }
      Free(yyvsp[-4].c); Free(yyvsp[0].c);
    ;
    break;}
case 333:
#line 3305 "Gmsh.y"
{
      yyval.l = yyvsp[-1].l;
    ;
    break;}
case 334:
#line 3309 "Gmsh.y"
{
      yyval.l = List_Create(256, 10, sizeof(unsigned int));
      GmshColorTable *ct = Get_ColorTable((int)yyvsp[-3].d);
      if(!ct)
	yymsg(GERROR, "View[%d] does not exist", (int)yyvsp[-3].d);
      else{
	for(int i = 0; i < ct->size; i++) 
	  List_Add(yyval.l, &ct->table[i]);
      }
      Free(yyvsp[-5].c);
    ;
    break;}
case 335:
#line 3324 "Gmsh.y"
{
      yyval.l = List_Create(256, 10, sizeof(unsigned int));
      List_Add(yyval.l, &(yyvsp[0].u));
    ;
    break;}
case 336:
#line 3329 "Gmsh.y"
{
      List_Add(yyval.l, &(yyvsp[0].u));
    ;
    break;}
case 337:
#line 3336 "Gmsh.y"
{
      yyval.c = yyvsp[0].c;
    ;
    break;}
case 338:
#line 3340 "Gmsh.y"
{
      yyval.c = (char *)Malloc(32*sizeof(char));
      time_t now;
      time(&now);
      strcpy(yyval.c, ctime(&now));
      yyval.c[strlen(yyval.c) - 1] = '\0';
    ;
    break;}
case 339:
#line 3348 "Gmsh.y"
{
      yyval.c = (char *)Malloc((strlen(yyvsp[-3].c)+strlen(yyvsp[-1].c)+1)*sizeof(char));
      strcpy(yyval.c, yyvsp[-3].c);
      strcat(yyval.c, yyvsp[-1].c);
      Free(yyvsp[-3].c);
      Free(yyvsp[-1].c);
    ;
    break;}
case 340:
#line 3356 "Gmsh.y"
{
      yyval.c = (char *)Malloc((strlen(yyvsp[-1].c)+1)*sizeof(char));
      int i;
      for(i = strlen(yyvsp[-1].c)-1; i >= 0; i--){
	if(yyvsp[-1].c[i] == '.'){
	  strncpy(yyval.c, yyvsp[-1].c, i);
	  yyval.c[i]='\0';
	  break;
	}
      }
      if(i <= 0) strcpy(yyval.c, yyvsp[-1].c);
      Free(yyvsp[-1].c);
    ;
    break;}
case 341:
#line 3370 "Gmsh.y"
{
      yyval.c = (char *)Malloc((strlen(yyvsp[-1].c)+1)*sizeof(char));
      int i;
      for(i = strlen(yyvsp[-1].c)-1; i >= 0; i--){
	if(yyvsp[-1].c[i] == '/' || yyvsp[-1].c[i] == '\\')
	  break;
      }
      if(i <= 0)
	strcpy(yyval.c, yyvsp[-1].c);
      else
	strcpy(yyval.c, &yyvsp[-1].c[i+1]);
      Free(yyvsp[-1].c);
    ;
    break;}
case 342:
#line 3384 "Gmsh.y"
{
      yyval.c = yyvsp[-1].c;
    ;
    break;}
case 343:
#line 3388 "Gmsh.y"
{
      char tmpstring[1024];
      int i = PrintListOfDouble(yyvsp[-3].c, yyvsp[-1].l, tmpstring);
      if(i < 0){
	yymsg(GERROR, "Too few arguments in Sprintf");
	yyval.c = yyvsp[-3].c;
      }
      else if(i > 0){
	yymsg(GERROR, "%d extra argument%s in Sprintf", i, (i>1)?"s":"");
	yyval.c = yyvsp[-3].c;
      }
      else{
	yyval.c = (char*)Malloc((strlen(tmpstring)+1)*sizeof(char));
	strcpy(yyval.c, tmpstring);
	Free(yyvsp[-3].c);
      }
      List_Delete(yyvsp[-1].l);
    ;
    break;}
case 344:
#line 3407 "Gmsh.y"
{ 
      char* (*pStrOpt)(int num, int action, char *value);
      StringXString *pStrCat;
      if(!(pStrCat = Get_StringOptionCategory(yyvsp[-3].c))){
	yymsg(GERROR, "Unknown string option class '%s'", yyvsp[-3].c);
	yyval.c = (char*)Malloc(sizeof(char));
	yyval.c[0] = '\0';
      }
      else{
	if(!(pStrOpt = (char *(*) (int, int, char *))Get_StringOption(yyvsp[-1].c, pStrCat))){
	  yymsg(GERROR, "Unknown string option '%s.%s'", yyvsp[-3].c, yyvsp[-1].c);
	  yyval.c = (char*)Malloc(sizeof(char));
	  yyval.c[0] = '\0';
	}
	else{
	  char *str = pStrOpt(0, GMSH_GET, NULL);
	  yyval.c = (char*)Malloc((strlen(str)+1)*sizeof(char));
	  strcpy(yyval.c, str);
	}
      }
    ;
    break;}
case 345:
#line 3429 "Gmsh.y"
{ 
      char* (*pStrOpt)(int num, int action, char *value);
      StringXString *pStrCat;
      if(!(pStrCat = Get_StringOptionCategory(yyvsp[-6].c))){
	yymsg(GERROR, "Unknown string option class '%s'", yyvsp[-6].c);
	yyval.c = (char*)Malloc(sizeof(char));
	yyval.c[0] = '\0';
      }
      else{
	if(!(pStrOpt = (char *(*) (int, int, char *))Get_StringOption(yyvsp[-1].c, pStrCat))){
	  yymsg(GERROR, "Unknown string option '%s[%d].%s'", yyvsp[-6].c, (int)yyvsp[-4].d, yyvsp[-1].c);
	  yyval.c = (char*)Malloc(sizeof(char));
	  yyval.c[0] = '\0';
	}
	else{
	  char *str = pStrOpt((int)yyvsp[-4].d, GMSH_GET, NULL);
	  yyval.c = (char*)Malloc((strlen(str)+1)*sizeof(char));
	  strcpy(yyval.c, str);
	}
      }
    ;
    break;}
}
   /* the action file gets copied in in place of this dollarsign */
#line 543 "/usr/share/bison.simple"

  yyvsp -= yylen;
  yyssp -= yylen;
#ifdef YYLSP_NEEDED
  yylsp -= yylen;
#endif

#if YYDEBUG != 0
  if (yydebug)
    {
      short *ssp1 = yyss - 1;
      fprintf (stderr, "state stack now");
      while (ssp1 != yyssp)
	fprintf (stderr, " %d", *++ssp1);
      fprintf (stderr, "\n");
    }
#endif

  *++yyvsp = yyval;

#ifdef YYLSP_NEEDED
  yylsp++;
  if (yylen == 0)
    {
      yylsp->first_line = yylloc.first_line;
      yylsp->first_column = yylloc.first_column;
      yylsp->last_line = (yylsp-1)->last_line;
      yylsp->last_column = (yylsp-1)->last_column;
      yylsp->text = 0;
    }
  else
    {
      yylsp->last_line = (yylsp+yylen-1)->last_line;
      yylsp->last_column = (yylsp+yylen-1)->last_column;
    }
#endif

  /* Now "shift" the result of the reduction.
     Determine what state that goes to,
     based on the state we popped back to
     and the rule number reduced by.  */

  yyn = yyr1[yyn];

  yystate = yypgoto[yyn - YYNTBASE] + *yyssp;
  if (yystate >= 0 && yystate <= YYLAST && yycheck[yystate] == *yyssp)
    yystate = yytable[yystate];
  else
    yystate = yydefgoto[yyn - YYNTBASE];

  goto yynewstate;

yyerrlab:   /* here on detecting error */

  if (! yyerrstatus)
    /* If not already recovering from an error, report this error.  */
    {
      ++yynerrs;

#ifdef YYERROR_VERBOSE
      yyn = yypact[yystate];

      if (yyn > YYFLAG && yyn < YYLAST)
	{
	  int size = 0;
	  char *msg;
	  int x, count;

	  count = 0;
	  /* Start X at -yyn if nec to avoid negative indexes in yycheck.  */
	  for (x = (yyn < 0 ? -yyn : 0);
	       x < (sizeof(yytname) / sizeof(char *)); x++)
	    if (yycheck[x + yyn] == x)
	      size += strlen(yytname[x]) + 15, count++;
	  msg = (char *) malloc(size + 15);
	  if (msg != 0)
	    {
	      strcpy(msg, "parse error");

	      if (count < 5)
		{
		  count = 0;
		  for (x = (yyn < 0 ? -yyn : 0);
		       x < (sizeof(yytname) / sizeof(char *)); x++)
		    if (yycheck[x + yyn] == x)
		      {
			strcat(msg, count == 0 ? ", expecting `" : " or `");
			strcat(msg, yytname[x]);
			strcat(msg, "'");
			count++;
		      }
		}
	      yyerror(msg);
	      free(msg);
	    }
	  else
	    yyerror ("parse error; also virtual memory exceeded");
	}
      else
#endif /* YYERROR_VERBOSE */
	yyerror("parse error");
    }

  goto yyerrlab1;
yyerrlab1:   /* here on error raised explicitly by an action */

  if (yyerrstatus == 3)
    {
      /* if just tried and failed to reuse lookahead token after an error, discard it.  */

      /* return failure if at end of input */
      if (yychar == YYEOF)
	YYABORT;

#if YYDEBUG != 0
      if (yydebug)
	fprintf(stderr, "Discarding token %d (%s).\n", yychar, yytname[yychar1]);
#endif

      yychar = YYEMPTY;
    }

  /* Else will try to reuse lookahead token
     after shifting the error token.  */

  yyerrstatus = 3;		/* Each real token shifted decrements this */

  goto yyerrhandle;

yyerrdefault:  /* current state does not do anything special for the error token. */

#if 0
  /* This is wrong; only states that explicitly want error tokens
     should shift them.  */
  yyn = yydefact[yystate];  /* If its default is to accept any token, ok.  Otherwise pop it.*/
  if (yyn) goto yydefault;
#endif

yyerrpop:   /* pop the current state because it cannot handle the error token */

  if (yyssp == yyss) YYABORT;
  yyvsp--;
  yystate = *--yyssp;
#ifdef YYLSP_NEEDED
  yylsp--;
#endif

#if YYDEBUG != 0
  if (yydebug)
    {
      short *ssp1 = yyss - 1;
      fprintf (stderr, "Error: state stack now");
      while (ssp1 != yyssp)
	fprintf (stderr, " %d", *++ssp1);
      fprintf (stderr, "\n");
    }
#endif

yyerrhandle:

  yyn = yypact[yystate];
  if (yyn == YYFLAG)
    goto yyerrdefault;

  yyn += YYTERROR;
  if (yyn < 0 || yyn > YYLAST || yycheck[yyn] != YYTERROR)
    goto yyerrdefault;

  yyn = yytable[yyn];
  if (yyn < 0)
    {
      if (yyn == YYFLAG)
	goto yyerrpop;
      yyn = -yyn;
      goto yyreduce;
    }
  else if (yyn == 0)
    goto yyerrpop;

  if (yyn == YYFINAL)
    YYACCEPT;

#if YYDEBUG != 0
  if (yydebug)
    fprintf(stderr, "Shifting error token, ");
#endif

  *++yyvsp = yylval;
#ifdef YYLSP_NEEDED
  *++yylsp = yylloc;
#endif

  yystate = yyn;
  goto yynewstate;

 yyacceptlab:
  /* YYACCEPT comes here.  */
  if (yyfree_stacks)
    {
      free (yyss);
      free (yyvs);
#ifdef YYLSP_NEEDED
      free (yyls);
#endif
    }
  return 0;

 yyabortlab:
  /* YYABORT comes here.  */
  if (yyfree_stacks)
    {
      free (yyss);
      free (yyvs);
#ifdef YYLSP_NEEDED
      free (yyls);
#endif
    }
  return 1;
}
#line 3452 "Gmsh.y"


void DeleteSymbol(void *a, void *b){
  Symbol *s = (Symbol*)a;
  Free(s->Name);
  List_Delete(s->val);
}

int CompareSymbols (const void *a, const void *b){
  return(strcmp(((Symbol*)a)->Name, ((Symbol*)b)->Name));
}

void InitSymbols(void){
  if(Symbol_T){
    Tree_Action(Symbol_T, DeleteSymbol);
    Tree_Delete(Symbol_T);
  }
  Symbol_T = Tree_Create(sizeof(Symbol), CompareSymbols);
}

int PrintListOfDouble(char *format, List_T *list, char *buffer){
  int j, k;
  char tmp1[256], tmp2[256];

  j = 0;
  buffer[j] = '\0';

  while(j < (int)strlen(format) && format[j] != '%') j++;
  strncpy(buffer, format, j); 
  buffer[j]='\0'; 
  for(int i = 0; i < List_Nbr(list); i++){
    k = j;
    j++;
    if(j < (int)strlen(format)){
      if(format[j] == '%'){
	strcat(buffer, "%");
	j++;
      }
      while(j < (int)strlen(format) && format[j] != '%') j++;
      if(k != j){
	strncpy(tmp1, &(format[k]), j-k);
	tmp1[j-k] = '\0';
	sprintf(tmp2, tmp1, *(double*)List_Pointer(list, i)); 
	strcat(buffer, tmp2);
      }
    }
    else{
      return List_Nbr(list)-i;
    }
  }
  if(j != (int)strlen(format))
    return -1;
  return 0;
}

int CheckViewErrorFlags(Post_View *v){
  if(View->adaptive) return 0; // hope for the best :-)

  char *name[8] = { "point", "line", "triangle", "quadrangle", 
		    "tetrahedron", "hexahedron", "prism", "pyramid" };
  char *type[3] = { "scalar", "vector", "tensor" };

  if(8 * 3 != VIEW_NB_ELEMENT_TYPES){
    Msg(GERROR, "Please upgrade CheckViewErrorFlags!");
    return 0;
  }
  
  for(int i = 0; i < VIEW_NB_ELEMENT_TYPES; i++)
    if(ViewErrorFlags[i])
      Msg(GERROR, "%d %s %s%s in View[%d] contain%s a wrong number of values",
	  ViewErrorFlags[i], type[i%3], name[i/3], (ViewErrorFlags[i] > 1) ? "s" : "",
	  v->Index, (ViewErrorFlags[i] > 1) ? "" : "s");
  
  return 0;
}

void yyerror(char *s){
  Msg(GERROR, "'%s', line %d : %s (%s)", yyname, yylineno-1, s, yytext);
  yyerrorstate++;
}

void yymsg(int type, char *fmt, ...){
  va_list args;
  char tmp[1024];

  va_start (args, fmt);
  vsprintf (tmp, fmt, args);
  va_end (args);

  Msg(type, "'%s', line %d : %s", yyname, yylineno-1, tmp);

  if(type == GERROR) yyerrorstate++;
}
